Changelog
=========

7.4.1 (19.05.2026)
~~~~~~~~~~~~~~~~~~

 * Fix: Reinstate missing file `jquery.fileupload-validate.js` (Rob Brackett)


7.4 LTS (05.05.2026)
~~~~~~~~~~~~~~~~~~~~

 * Add `is_deferred_validation` flag to support skipping custom validation when saving drafts (Daniel Kirkham)
 * Update project template Dockerfile to build dependencies in a separate stage (Brylie Oxley, Akshat Gupta)
 * Add `include_root` parameter to admin pages API endpoint (Divyansh Mishra)
 * Add support for Flourish oEmbeds (Garrett Coakley)
 * Add support for Heyzine oEmbeds (Baptiste Darthenay)
 * Allow specifying `creation_form_class` on `ChooserViewSet` as a dotted path string (K Adithya)
 * Various user experience improvements to autosave and concurrent editing notifications (Sage Abdullah)
 * Allow validation of required StreamField blocks to be deferred on saving drafts (Sage Abdullah)
 * Add `WAGTAILDOCS_MAX_UPLOAD_SIZE` setting for specifying maximum document file size (Om Harsh)
 * Set the project template `WAGTAILDOCS_MAX_UPLOAD_SIZE` to 10MB (Thibaud Colas)
 * Optimize combining of querysets in site history report (Alex Bridge)
 * Add more informative error for `format-*` operations on SVG images (Ankit Kumar)
 * Store preview data in new `FormState` model to improve compatibility with cookie-based sessions (Sage Abdullah)
 * Change StreamBlock options so groups are shown in declaration order of their blocks (Darshan Kerkar)
 * Add `WAGTAILADMIN_PAGE_SEARCH_FILTER_BY_PERMISSIONS` setting to disable permission filtering on page searches (Matt Westcott)
 * Use choice label when displaying choice fields in `SnippetViewSet`/`ModelViewSet`'s `list_display` (Srishti Jaiswal)
 * Add new content check `empty-meta-description` to validate meta description tags are not empty (Thibaud Colas)
 * Add `extractMetrics` method to `PreviewController` to retrieve content metrics from the preview panel (Thibaud Colas)
 * Refine hover / focus styles for title field’s comment button (Srishti Jaiswal)
 * Preserve "Collapse all" button state when switching between editor tabs (Raghad Dahi)
 * Upgrade modelsearch to 1.3 (Matt Westcott)
 * Implement checker error highlights within the preview panel (Thibaud Colas)
 * Add `routablefullpageurl` template tag (Pravin Kamble)
 * Add support for customizing page explorer views per page type using `PageViewSet` (Sage Abdullah)
 * Enhance page content type usage view with custom listings and ability to create new pages (Sage Abdullah)
 * Fix: CVE-2026-44197: Improper permission handling when comparing revisions (Seoyoung Kang, Jake Howard)
 * Fix: CVE-2026-44198: Improper permission handling when viewing page history (Seoyoung Kang, Jake Howard, Dan Braghis)
 * Fix: CVE-2026-44199: Improper permission handling when deleting form submissions (Vishal Shukla, Jake Howard)
 * Fix: CVE-2026-44200: Improper permission handling when copying pages (Sanjok Karki, Matt Westcott)
 * Fix: CVE-2026-44201: Improper restriction handling on Documents and Images API (Sanjok Karki, Jake Howard)
 * Fix: Handle nested inline models when displaying object usage information (Sage Abdullah, Kacper Walęga, Tian Jie Wong)
 * Fix: Avoid duplicate `get_object()` DB query in API detail view (Siddheshwar Kadam)
 * Fix: Ensure `ImageBlock` alt text populates on choosing a new image after unchecking decorative state (Pratham Jaiswal)
 * Fix: Set `verbose_name_plural` for Query model in search promotions app (Saptami)
 * Fix: Truncate overly long task names in workflow admin view (Gaurav Takhi)
 * Fix: Hide "Add child page" button when no child pages can be created as per `max_count` or `max_count_per_parent` (Lasse Schmieding)
 * Fix: Prevent multiple child pages with `max_count_per_parent` being moved under one parent (James Biggs)
 * Fix: Use POST instead of DELETE in Cloudflare Frontend Cache Backend (Tom Usher)
 * Fix: Handle null values for title, author name or provider name in OEmbed responses (Baptiste Darthenay)
 * Fix: Preserve original data types from `ChoiceBlock` choices in block values (Devarshi Mani Tripathi)
 * Fix: Fix translation sync logic for django-treebeard 5.0.2 (Matt Westcott)
 * Fix: Correctly HTML-escape page title in approval/rejection notification emails (Matt Westcott)
 * Fix: Correctly HTML-escape URL in photo type oembeds (Thibaud Colas)
 * Fix: Ensure user with appropriate permissions can cancel a workflow task (Dan Braghis)
 * Fix: Ensure "submit to workflow" menu item uses the workflow name when creating pages (Sage Abdullah)
 * Fix: Better align page descriptions in add subpage views (Tibor Leupold)
 * Fix: Correctly close the Pages menu panel when clicking sidebar search (Divyansh Mishra)
 * Docs: Add documentation for the `filter_spec` parameter of `ImageRenditionField` (Soumya-codr)
 * Docs: Add guide for testing document upload forms (Wenli Tsai, Bhavesh Sharma)
 * Docs: Document the `nested_default_fields` attribute on API viewsets (Deepanshu Tevathiya)
 * Docs: Replace `http` with `https` in example URLs (Kunal Gupta)
 * Docs: Use `pathlib.Path` for settings in "Integrating into Django" documentation (Kunal Gupta)
 * Docs: Clarify example of how to implement custom embed finders (Naman Sharma S)
 * Docs: Add documentation for using the `ReferenceIndex` API (Saptami)
 * Docs: Retitle documentation page for settings contrib module to "Settings models" (Karl Hobley)
 * Docs: Fix typos and minor grammar issues (Kunal Gupta)
 * Docs: Correct references to macOS and POSIX shell in tutorial (Ankit Kumar)
 * Docs: Add PowerShell setup instructions to tutorial and correct method versus property terminology (Mustansir Dabhiya)
 * Docs: Fix ordering of image rendition documentation (Seb Corbin)
 * Docs: Remove references to now-addressed Django accessibility issues (Nirmal Kumar)
 * Docs: Add content personalization how-to guide (Thibaud Colas)
 * Docs: Add new package maintenance guidelines (Thibaud Colas)
 * Docs: Fix use of `format_html` in `insert_global_admin_js` example (Lasse Schmieding)
 * Docs: Mention front-end component names in Sphinx docs for discoverability (Aditya Kammati)
 * Docs: Clarify the icon template tag is only for admin views (Aditya Kammati)
 * Docs: Add documentation for generic `published` and `unpublished` signals (Kunal Hemnani)
 * Docs: Improve organization of signals reference docs (Sage Abdullah)
 * Docs: Add documentation for overriding the default user avatar image (Aviral Sapra)
 * Docs: Document how `list_export` in reports accepts a dotted path for nested attribute resolution (mikko2577)
 * Docs: Update audit log actions docs to cover all currently-logged actions (Thibaud Colas)
 * Docs: Document more approaches to mitigating untrusted file uploads when storing and serving documents (Thibaud Colas)
 * Docs: Clarify default value for for `WAGTAILDOCS_SERVE_METHOD` (Thibaud Colas)
 * Docs: Document security reporting policy about runtime vs. development dependencies (Thibaud Colas)
 * Docs: Add reference documentation for `wagtail.admin.ui.tables` (Sage Abdullah)
 * Maintenance: Removed support for Django 4.2
 * Maintenance: Fix LocaleController test failures caused by differing timezone representations between Node versions (Saptami, Matt Westcott)
 * Maintenance: Fix frontend coverage upload to Codecov (Sage Abdullah)
 * Maintenance: Update semgrep to 1.150.0 (Pravin Kamble)
 * Maintenance: Fix `hash_filelike` test case to account for line break differences on Windows (Mustansir Dabhiya)
 * Maintenance: Fix temporary file handling in redirect import tests on Windows (Mustansir Dabhiya)
 * Maintenance: Fix use of platform-specific date formatting in edit handler tests (Mustansir Dabhiya)
 * Maintenance: Bump Node.js to 24 (active LTS), upgrade Jest and Storybook (Sage Abdullah)
 * Maintenance: Use Docker Elasticsearch images for GitHub CI instead of unofficial actions (Matt Westcott)
 * Maintenance: Make LocaleController tests robust against changes to timezone data in Node (Sage Abdullah)
 * Maintenance: Fix `PermissionError` on document serve tests under Windows (Matt Westcott)
 * Maintenance: Update JavaScript linting to ESLint 9, with updated linting rules and related fixes (Sage Abdullah)
 * Maintenance: Replace Puppeteer with Playwright for integration tests (Sage Abdullah)
 * Maintenance: Upgrade to latest Sass with changes for deprecated `if` syntax (Sage Abdullah)
 * Maintenance: Add explicit `timeout-minutes` to GitHub Actions workflow jobs (Ashutosh)
 * Maintenance: Upgrade Python tooling, testing, and docs dependencies (Sage Abdullah)
 * Maintenance: Support skipping transaction unit tests with a tag (Sage Abdullah)
 * Maintenance: Remove unreachable code in wagtail.py (Oluwagbeminiyi Agbedejobi)
 * Maintenance: Upgrade django-treebeard dependency to 4.8-5.x (Samir Shah)
 * Maintenance: Clean up JSDoc & ordering of values in `SwapController` (LB (Ben Johnston))
 * Maintenance: Refactor accessibility checker code to use generic content checker terminology (Thibaud Colas)
 * Maintenance: Upgrade BeautifulSoup dependency to >=4.13.3 (Matt Westcott)
 * Maintenance: Make sphinx_llms.txt extension optional when building docs (Sage Abdullah)
 * Maintenance: Refactor handling of invalid form submissions in choosers (Sage Abdullah)
 * Maintenance: Switch StreamField block rendering to use `w-block-` prefixes for block type class names (Kalash Kumari Thakur)
 * Maintenance: Upgrade CodeQL security scanning to cover more parts of the codebase (Thibaud Colas)
 * Maintenance: Upgrade django-modelcluster to 6.5 to fix issues with duplicated inline children (Alex Tomkins, Matt Westcott)


7.3.2 (05.05.2026)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2026-44197: Improper permission handling when comparing revisions (Seoyoung Kang, Jake Howard)
 * Fix: CVE-2026-44198: Improper permission handling when viewing page history (Seoyoung Kang, Jake Howard, Dan Braghis)
 * Fix: CVE-2026-44199: Improper permission handling when deleting form submissions (Vishal Shukla, Jake Howard)
 * Fix: CVE-2026-44200: Improper permission handling when copying pages (Sanjok Karki, Matt Westcott)
 * Fix: CVE-2026-44201: Improper restriction handling on Documents and Images API (Sanjok Karki, Jake Howard)
 * Fix: Use protocol-relative URLs in the userbar for compatibility with environments where Django does not detect the protocol (Sage Abdullah)
 * Fix: Index the contents of image descriptions as well as titles, for CMS search (Advik Sharma)
 * Fix: Avoid creating a new editing session when updating UI elements after an autosave (Sage Abdullah)
 * Fix: Group audit log entries for autosave operations in page history view (Sage Abdullah)
 * Fix: Retain page explorer header buttons when searching or filtering (Sage Abdullah)
 * Fix: Correctly escape the `sizes` attribute in responsive image template tags (Jake Howard)
 * Fix: Add accessible label to userbar aside element for accessibility (Kalash Kumari Thakur)
 * Fix: Pause SessionController pings during autosave to prevent conflict notification with own session (Sage Abdullah)
 * Fix: Ensure live preview does not get stuck when edits occur during an in-progress update (Aniket Singh)
 * Fix: Ensure only one autosave request can happen at a time to prevent incorrect conflict notifications with the current session (Sage Abdullah)
 * Fix: Prevent incorrect concurrent editing conflict notifications when doing a manual save (Sage Abdullah)

7.3.1 (03.03.2026)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2026-28222: Improper escaping of HTML (Cross-site Scripting) on TableBlock class attributes (Guan Chenxian, Matt Westcott)
 * Fix: CVE-2026-28223: Improper escaping of HTML (Cross-site Scripting) in simple_translation admin interface (Guan Chenxian, Matt Westcott)
 * Fix: Update dependencies to allow django-modelsearch 1.2 and django-tasks 0.11
 * Fix: Fix duplicate inline panel items when editing snippets with autosave enabled (Sage Abdullah)
 * Fix: Prevent dropdowns from closing after a successful autosave (Sage Abdullah)
 * Fix: Show placeholder image icons when image upload previews fail (Collins Kubu)
 * Fix: Ensure that 'create' form within choosers is not hidden on validation errors (Ankit Chaudhary)
 * Maintenance: Update semgrep to 1.150.0 (Pravin Kamble)


7.3 (03.02.2026)
~~~~~~~~~~~~~~~~

 * Add support for Django 6.0
 * Resize overly large avatar images on upload (Harshit Ranjan)
 * Add natural keys for `Page` and `Collection` models (Samya Aggarwal)
 * Add Loom oEmbed provider (Nick Ivons)
 * Add `ModelViewSet.pk_path_converter` with defaults for `IntegerField` and `UUIDField` primary keys (Seb Corbin)
 * Improve accessibility for sidebar menu with visual active (expanded) menu item indicators (Vignesh Shivhare)
 * Add `before_edit_setting` / `after_edit_setting` hooks (Baptiste Mispelon)
 * Lower default AVIF encoding quality from 80 to 73 (Thibaud Colas)
 * Provide a structured rendering of `StreamBlock` in comparison view (Taras Panasiuk)
 * Add support for settings and custom block layouts for StructBlock (Sage Abdullah)
 * Add llms.txt versions of the developer documentation and Wagtail user guide (Thibaud Colas)
 * Lower default JPEG and AVIF image quality settings to provide consistent perceptual quality between formats (Thibaud Colas)
 * Add support for custom content checks with client-side registration (Thibaud Colas)
 * Initial support for autosave (Matt Westcott, Sage Abdullah)
 * Fix: Do not try to resolve locale during fixture load (Jake Howard, Seb Corbin)
 * Fix: Gracefully handle oEmbed responses with a non-200 status or missing type (Shivam Kumar, Bhavesh Sharma)
 * Fix: Keep action button labelled as "Publish" rather than "Schedule to publish" if go-live date has passed (Vishrut Ramraj)
 * Fix: Pass accumulated icons to each `register_icons` hook (Joey Jurjens, Sage Abdullah)
 * Fix: Skip revisions that are missing the specified field in StreamField migrations (Joshua Munn)
 * Fix: Preserve listing search and filter parameters when redirecting from bulk actions (Sage Abdullah)
 * Fix: Ensure that object references within `TypedTableBlock` are counted in the reference index (Aman Bora)
 * Fix: Fix slug auto-generation when slug field is omitted from page edit form (Pravin Kamble)
 * Fix: Ensure `request.is_preview` and `request.preview_mode` are set for password-required responses (Ishtpreet Singh)
 * Fix: Optimise storage of redirect paths containing Unicode characters and ensure percent-encoded characters are matched case-insensitively (Andy Babic, Florin Barnea, Aman Bora, Matt Westcott)
 * Fix: Ensure that reference index records are deleted when the target object is deleted (bettercallok)
 * Fix: Ensure filters are applied to export button URLs in custom page listings (Ritik Arya, Sage Abdullah)
 * Fix: Prevent conflicting IDs in nested `StructBlock`s with blocks named `content` (Sage Abdullah, Serkan Korkusuz)
 * Fix: CVE-2026-25517: Improper permission handling on admin preview endpoints (thxtech, Matt Westcott, Jake Howard)
 * Docs: Recommend running `purge_embeds` after an embed provider changes policies (Paul Souders)
 * Docs: Document `WAGTAILIMAGES_FORMAT_CONVERSIONS` in the settings docs (David Buxton)
 * Docs: Wording changes to Draftail extension docs to improve searchability (Lasse Schmieding)
 * Docs: Fix StreamField param name (Baptiste Mispelon)
 * Docs: Clarify that `before_delete_page` and similar hooks only trigger on the individual page view, not bulk actions (Shivam Kumar)
 * Docs: Clarify template location in custom user model documentation (Akhil Muraleedharan)
 * Docs: Improve signposting for contributor docs (Matt Westcott)
 * Docs: Add mention of novalidate attribute in form builder docs (Thibaud Colas)
 * Docs: Fix formatting for `PageQuerySet.prefetch_related` performance note (Lasse Schmieding)
 * Docs: Fix path to `search.html` in tutorial (Lee Hart)
 * Docs: Grammar fixes to contributor guidelines (Biswajeet Yadav)
 * Docs: Mention punctuation is unsupported in paths for `RoutablePageMixin` (Tibor Leupold)
 * Docs: Various typo and grammar fixes (Mustansir Dabhiya)
 * Docs: Improve instructions for building documentation on Windows (Mustansir Dabhiya)
 * Docs: Provide recommended image quality settings for common use cases (Thibaud Colas)
 * Docs: Add detailed documentation on reordering within generic listing view (Ankit Chaudhary)
 * Docs: Document early notification process for security releases (Jake Howard)
 * Docs: Remove mention of Wagtailtrans from internationalization docs (Andreas Nüßlein)
 * Maintenance: Dropped support for Django 5.1
 * Maintenance: Updated NPM packages (LB (Ben) Johnston)
 * Maintenance: Rationalize front-end linting tasks and run concurrently (LB (Ben) Johnston)
 * Maintenance: Add a basic set of Storybook stories for the Stimulus Autosize controller (LB (Ben) Johnston)
 * Maintenance: Remove use of `_WAGTAILSEARCH_FORCE_AUTO_UPDATE` in search tests (Matt Westcott)
 * Maintenance: Add unit test for `SubmitController` error handling (LB (Ben) Johnston)
 * Maintenance: Improve nightly release upload scripts (Jake Howard)
 * Maintenance: Upload redundant `latest.whl` nightly build for ease of use with package managers (Sage Abdullah)
 * Maintenance: Move MANIFEST.in settings into pyproject.toml (Pravin Kamble)
 * Maintenance: Fix linting rules B006 and B904 (Vivek Subramani, Matt Westcott)
 * Maintenance: Remove jQuery dependency for image URL generator (LB (Ben) Johnston)
 * Maintenance: Upgrade to django-modelcluster 6.4.1 for Django 6.0 compatibility (Matt Westcott)
 * Maintenance: Refactor CreateView/EditView validation logic to support non-form validation (Matt Westcott)
 * Maintenance: Formalized support for Django 6.0 (Pravin Kamble)
 * Maintenance: Add `no-jquery` ESLint plugin to start final deprecation of jQuery (LB (Ben) Johnston)
 * Maintenance: Add `mode` value to `w-teleport` to allow different DOM update strategies (Sage Abdullah)
 * Maintenance: Ignore 'build' dir when running ESLint (Matt Westcott)
 * Maintenance: Upgrade to django-tasks 0.11.0 for Django 6.0 and Python 3.11 compatibility (Guilhem Saurel)
 * Maintenance: Switch userbar items to the template components API (Thibaud Colas)


7.2.3 (03.03.2026)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2026-28222: Improper escaping of HTML (Cross-site Scripting) on TableBlock class attributes (Guan Chenxian, Matt Westcott)
 * Fix: CVE-2026-28223: Improper escaping of HTML (Cross-site Scripting) in simple_translation admin interface (Guan Chenxian, Matt Westcott)
 * Maintenance: Update semgrep to 1.150.0 (Pravin Kamble)


7.2.2 (03.02.2026)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent conflicting IDs in nested `StructBlock`s with blocks named `content` (Sage Abdullah, Serkan Korkusuz)
 * Fix: CVE-2026-25517: Improper permission handling on admin preview endpoints (thxtech, Matt Westcott, Jake Howard)


7.2.1 (26.11.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Allow userbar in page previews to render without needing to configure site record (Sage Abdullah)
 * Fix: Disable usage count ordering when searching on documents and images listing views, to prevent unsupported search query (Sage Abdullah)
 * Fix: Do not replace existing document or image title when uploading a new file (Sage Abdullah)
 * Fix: Use a more efficient query for fetching usage counts on image and document listings when not ordering by usage count (Sage Abdullah)
 * Fix: Add composite indexes to improve reference index performance (Sage Abdullah)
 * Maintenance: Remove use of `_WAGTAILSEARCH_FORCE_AUTO_UPDATE` in search tests (Matt Westcott)


7.2 (05.11.2025)
~~~~~~~~~~~~~~~~

 * Added support for Python 3.14 (Sage Abdullah)
 * Add usage count filter to the admin image and document listings (Joel William)
 * Add keyboard shortcut (`?`) to activate the keyboard shortcuts dialog (Dhruvi Patel)
 * Add keyboard shortcut (`/`) to activate and focus on the search input in the sidebar (Dhruvi Patel)
 * Allow deep contentpath for comments on fields other than StreamField (Lasse Schmieding, Sébastien Corbin, Joel William, Sage Abdullah)
 * Reorganize keyboard shortcuts into better categories with an ordering from most common to most specific (Dhruvi Patel)
 * Add `max_value` of 100 (%) for the `closeness` field in Image URL Generator form (LB (Ben) Johnston)
 * Add reordering support to generic model and snippet listing views (Joey Jurjens, Sage Abdullah)
 * Add messaging within the keyboard shortcuts dialog to indicate when keyboard shortcuts are disabled or how to disable them via user preferences (Pravin Kamble)
 * Allow defining a custom `WorkflowLock` subclass via `Task.lock_class` in a custom task (Dan Braghis)
 * Add new toggle from grid to list layout for image choosers (Joel William)
 * Update grid-list layout toggle to new design (Joel William)
 * Add readability score metric to content checks (Thibaud Colas)
 * Add explainer panel for content metrics (Thibaud Colas)
 * Add a button to jump to the first validation error in header messages (Srishti Jaiswal, Sage Abdullah, LB (Ben) Johnston)
 * Support calculating content metrics without opening the preview panel (Sage Abdullah)
 * Update project template settings to use pathlib Path object (Eric Matthes)
 * Migrate to django-modelsearch library, providing Elasticsearch 9 and OpenSearch backends (Karl Hobley, Matt Westcott)
 * Fix: Use the correct method of resolving the file storage dynamically for FileField usage in images & documents (Amir Mahmoodi)
 * Fix: Ensure the add comment keyboard shortcut is disabled when keyboard shortcuts are disabled in user preferences (Dhruvi Patel)
 * Fix: Use model name when ordering by page type in page listings (Sage Abdullah)
 * Fix: Prevent error from default `update_fields` parameter on `Page.asave()` (Tosinibikunle)
 * Fix: Ignore hidden error messages in minimap & `CountController` default `findValue` (Sage Abdullah)
 * Fix: Change default ordering for `UserViewSet` to `User.USERNAME_FIELD` to support default ordering with custom User models that may not have a `name` field (Lynwee)
 * Fix: Ensure starter tests in the project template pass (Lasse Schmieding)
 * Fix: Ensure fixed RichText toolbar shows under footer actions (Maciek Baron)
 * Fix: Prevent error when iterating over specific tasks with missing models (Lasse Schmieding)
 * Fix: Ensure `TableBlock` header dropdown default option can be translated (arpitmak)
 * Fix: Fix missing cache key prefix when removing cached redirect files (Heric Libong)
 * Docs: Fix cross-reference links to the TypeDoc-generated docs (Sage Abdullah)
 * Docs: Refine readthedocs' search indexing for releases and client-side code (Sage Abdullah)
 * Docs: Fix incorrect link to third party site in advanced topics (Yousef Al-Hadhrami (Yemeni))
 * Docs: Fix incorrect import references and update steps for clarity in getting started tutorial (Hunzlah Malik, Pravin Kamble)
 * Docs: Fix code example for `construct_wagtail_userbar` (Baptiste Mispelon)
 * Docs: Add a note about CSP for background image position and responsive embed styles (Thibaud Colas, Chiemezuo Akujobi, Sage Abdullah)
 * Docs: Add guidance for AI-led contributions to contributor docs (Andrew Selzer)
 * Docs: Add guidance for AI agents via `AGENTS.md` (Andrew Selzer)
 * Docs: Add Windows command examples for contributing setup (Shivam Kumar)
 * Docs: Add recent third party tutorials from 2025 (LB (Ben) Johnston)
 * Maintenance: Removed support for Python 3.9 (Matt Westcott)
 * Maintenance: Updated NPM packages and linting configuration (LB (Ben) Johnston)
 * Maintenance: Added linting script to keep package.json and pre-commit package versions in sync (LB (Ben) Johnston)
 * Maintenance: Migrate privacy switch modal field hiding to the Stimulus `RulesController` (LB (Ben) Johnston)
 * Maintenance: Add semgrep rules for inline styles and scripts (Chiemezuo Akujobi, Sage Abdullah)
 * Maintenance: Fix intermittent test failures caused by nondeterministic order in TestFilteredModelChoiceField (Sage Abdullah)
 * Maintenance: Add support for `attrs` in `formattedfield` tag & clean up other usages of the `attrs` template include (LB (Ben) Johnston)
 * Maintenance: Allow exempting external templates from number formatting checks (Sage Abdullah)
 * Maintenance: Migrate file title generation to SyncController for CSP compliance (Aayushman Singh, Chiemezuo Akujobi, LB (Ben) Johnston, Sage Abdullah)
 * Maintenance: Remove outdated pytest configuration (Shivam Kumar)
 * Maintenance: Avoid mutable default argument in `ImageNode` within image template tags (minusf)
 * Maintenance: Use consistent sentence format for user-facing errors (LB (Ben) Johnson)
 * Maintenance: Update django-tasks dependency to allow 0.9, for preliminary Django 6.0 support (Sage Abdullah)
 * Maintenance: Fix linting issues B009, B010, B033 (minusf)


7.1.3 (03.02.2026)
~~~~~~~~~~~~~~~~~~

 * Fix: Allow userbar in page previews to render without needing to configure site record (Sage Abdullah)
 * Fix: Disable usage count ordering when searching on documents and images listing views, to prevent unsupported search query (Sage Abdullah)
 * Fix: Prevent conflicting IDs in nested `StructBlock`s with blocks named `content` (Sage Abdullah, Serkan Korkusuz)
 * Fix: CVE-2026-25517: Improper permission handling on admin preview endpoints (thxtech, Matt Westcott, Jake Howard)


7.1.2 (23.10.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Allow `label_format` to be set to an empty string to hide the block summary label (Sage Abdullah)
 * Fix: Better support userbar loading on multi-site through site hosts (Sage Abdullah)
 * Fix: Prevent error on custom generic create and edit views without a header icon (Sage Abdullah)
 * Fix: Use the correct origin when computing content metrics via cross-origin communications (Sage Abdullah)
 * Docs: Link to django-treebeard's `Node.move()` in `Page.move()` documentation (Baptiste Mispelon)


7.1.1 (28.08.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Ensure the add comment keyboard shortcut is disabled when keyboard shortcuts are disabled in user preferences (Dhruvi Patel)
 * Fix: Fix crash when the Wagtail API is accessed without `rest_framework` installed (Vijay Raj)
 * Fix: Fix failure of `FieldPanel` and `TitleFieldPanel` with `read_only=True` (Sage Abdullah)
 * Fix: Fix broken Javascript interactions on nested inline panels (Matt Westcott, Sage Abdullah)
 * Fix: Fix rendering of StructBlock with custom form templates (Sage Abdullah)
 * Fix: Prevent crash when previewing a form page with an empty field type (Sage Abdullah)
 * Docs: Fix cross-reference links to the TypeDoc-generated docs (Sage Abdullah)
 * Docs: Refine readthedocs' search indexing for releases and client-side code (Sage Abdullah)
 * Docs: Add section about closing stale pull requests to the issue tracking documentation (Thibaud Colas, Sage Abdullah, LB (Ben) Johnston)
 * Docs: Add backporting policy for UI and accessibility fixes with updated "active support" and "security support" definitions (Thibaud Colas, Sage Abdullah, Scott Cranfill)

7.1 (04.08.2025)
~~~~~~~~~~~~~~~~

 * Allow configuring permissions for site settings on a per-site basis (Matt Westcott)
 * Add iHeart oEmbed provider (Storm Heg)
 * Add locale-aware `NumberColumn` to display numbers in universal listings (Baptiste Mispelon)
 * Add ability for the header breadcrumbs to save their open/closed state across navigation & refresh (Srishti Jaiswal)
 * Update Twitter oEmbed provider to recognize x.com links (manu)
 * Render listing buttons as template components (Sage Abdullah)
 * Define default `GenericRelations` for `RevisionMixin` and `WorkflowMixin`, to avoid issues with deletion cascades (Sage Abdullah)
 * Document and relocate the `init_new_page` signal (Maciek Baron)
 * Use `requests` to access oEmbed endpoints, for more robust SSL certificate handling (Matt Westcott)
 * Ensure that bulk deletion views respect protected foreign keys (Sage Abdullah)
 * Add minimum length validation for `RichTextBlock` and `RichTextField` (Alec Baron)
 * Allow `SnippetChooserBlock`'s `icon` to take precedence over `SnippetViewSet.icon` (Matt Westcott)
 * Allow searching the users index on custom fields (Paul Craciunoiu, Sage Abdullah)
 * Support `preserve-svg` in Jinja2 image tags (Vishesh Garg)
 * Recognize `preserve-svg` as a filter when calling `Image.get_rendition` directly (Richard Allen)
 * Add support for `preserve-svg` for `Image.get_renditions`, picture, and srcset_image tags (Matt Westcott)
 * Include `TypedTableBlock` content when indexing for search (Charan T M)
 * Preserve query parameters when redirecting from the API `find` view to the `detail` view (Andrew Hosgood)
 * Add 'Edit' button to success message after copying page (Dhruvi Patel)
 * Restrict file dialog in multiple image uploader to the allowed image file types (Mustopha Mubarak O)
 * Raise clear error when non-StreamBlock is used as top-level block in StreamField (Clifford Gama)
 * Refactor user bar rendering to better support headless websites (Sage Abdullah)
 * Add type-to-confirm step when deleting large numbers of pages through bulk actions (Rachel Smith)
 * Add `NoFutureDateValidator` to validate against dates in the future (Talha Rizwan)
 * Extract separate `background_position_x` and `background_position_y` properties from `AbstractRendition.background_position_style` (Chiemezuo Akujobi)
 * Add support for translated string concatenation in the locale selector when switching between a model's language in the admin (Matt Westcott, Ellie Walsh-O'Neill)
 * Switch to check / cross icons for users’ active state in users listing (Sage Abdullah)
 * Add a keyboard shortcut to easily toggle the visibility of the minimap side panel (Dhruvi Patel)
 * Add a new user profile setting to disable Wagtail’s custom keyboard shortcuts (Dhruvi Patel)
 * Add API for extracting preview page content (Sage Abdullah)
 * Add toggle from grid to list layout for image listings (Joel William)
 * Add `UsageCountColumn` to document and image listings (Joel William, Sage Abdullah)
 * Make `StructBlock`s collapsible when nested to support block settings (Sage Abdullah)
 * Improve `label_format` support for more widget types in StreamField (Sage Abdullah)
 * Add `form_attrs` support to all StreamField blocks (Sage Abdullah)
 * Update project template documentation to include testing instructions and include starting test file in template (Aditya (megatrron))
 * Add support for `preview_value` and `default` in `Block` meta options as callables for dynamic previews within StreamField (Ziyao Yan, Sage Abdullah)
 * Add previews support for generic and site settings (Sébastien Corbin, Sage Abdullah)
 * Provide client-side access to the editing form panel structure (Matt Westcott)
 * Make transliteration of titles to slugs locale-aware, and provide further customisation options (LB (Ben) Johnston)
 * Add a keyboard shortcut to easily toggle the visibility of the main menu (Dhruvi Patel)
 * Fix: Handle lazy translation strings as `preview_value` for `RichTextBlock` (Seb Corbin)
 * Fix: Fix handling of newline-separated choices in form builder when using non-windows newline characters (Baptiste Mispelon)
 * Fix: Ensure `WAGTAILADMIN_LOGIN_URL` is respected when logging out of the admin (Antoine Rodriguez, Ramon de Jezus)
 * Fix: Fix behavior of `ViewSet.inject_view_methods` with multiple methods (Gorlik)
 * Fix: Preserve query strings in URLs submitted to CloudFront for invalidation (Jigyasu Rajput)
 * Fix: Handle non-JSON-safe fields in `exclude_fields_in_copy` (Matt Westcott)
 * Fix: Allow upload of AVIF images through image chooser on Firefox (Matt Westcott)
 * Fix: Accept any string beginning with 'y' as confirmation for `import_redirects` command (Matt Westcott)
 * Fix: Fix error when accessing the submissions listing view with a non-form page (Sage Abdullah)
 * Fix: Replace inline styles with CSS classes in HTML files (Srishti Jaiswal)
 * Fix: Refactor remaining inline styles to avoid unsafe-inline style-src CSP (Chiemezuo Akujobi)
 * Fix: Avoid breaking words in listing table cells unless specifically enabled (Ziyao Yan)
 * Fix: Ensure that "all items in listing" option on image / document bulk actions respects user permissions (Alex Morega)
 * Fix: Adjust accessibility dialog position based on user bar position (Anees Asghar, Sage Abdullah)
 * Fix: Correctly handle ordering API results by mixed ascending and descending order (Rohit Sharma, Mahmoud Nasser)
 * Fix: Ensure that draft changes to an editable `first_published_at` field are preserved on reloading (Talha Rizwan)
 * Fix: Remove ngram parser on MySQL that prevented autocomplete search from returning results (Vince Salvino)
 * Fix: Only enable ManifestStaticFilesStorage in production settings, to aid test running (M. Sumair Khokhar)
 * Fix: Update `BooleanColumn` icons so they can be distinguished without relying on color (Sage Abdullah)
 * Fix: Do not delete default homepage by ID in home app migration (Matt Westcott)
 * Fix: Update the start project template to align with Django's recommendation to have the `django.middleware.security.SecurityMiddleware` first (Brylie Christopher Oxley)
 * Fix: Ensure keyboard usage will correctly focus on new comments, including replies, when the side panel is open or closed (Dhruvi Patel)
 * Fix: Handle `help_text` kwarg in `FloatBlock` (Nick Smith)
 * Fix: Set `aria-invalid` on StreamField widgets input when there is an error (Sage Abdullah)
 * Fix: Make sure the label of panel collapse buttons is translatable (Thibaud Colas)
 * Fix: Ensure there is suitable padding for large numbers on pagination within universal listings (M. Sumair Khokhar)
 * Fix: Use the correct localized format utils in the `human_readable_date` template tag (Seb Corbin)
 * Fix: Ensure the editing of translation alias pages correctly shows links to the source page if the alias was created from a draft (Dan Braghis)
 * Fix: Support complex `order_by` expressions in database search backends (Seb Corbin)
 * Fix: Improve handling of capitalization of InlinePanel labels and headings (Stefan Hammer)
 * Docs: Add missing tag library imports to footer template code in tutorial (Dimaco)
 * Docs: Improve documentation around securing user-uploaded files (Jake Howard)
 * Docs: Introduce search_fields in a dedicated tutorial section instead of the introduction (Matt Westcott)
 * Docs: Add note about PDF XSS to security page (Matt Westcott)
 * Docs: Add documentation for how to group blocks within the StreamField picker (Gaurav Verma)
 * Docs: Clarify the user bar does not have moderation features (Sage Abdullah)
 * Docs: Add experimental documentation for admin UI components and client-side code (Sage Abdullah)
 * Docs: Clean up JSDoc documentation comments, syntax, and update spelling where suitable (LB (Ben) Johnston)
 * Docs: Add more examples of all images settings and include `avif` in `WAGTAILIMAGES_EXTENSIONS` example (Thibaud Colas)
 * Docs: Add an example of using `data-edit-form` and interacting with the editor form and preview panel (Sage Abdullah)
 * Maintenance: Refactor `get_embed` to remove `finder` argument which was only used for mocking in unit tests (Jigyasu Rajput)
 * Maintenance: Simplify handling of `None` values in `TypedTableBlock` (Jigyasu Rajput)
 * Maintenance: Remove squash.io configuration (Sage Abdullah)
 * Maintenance: Use `utf8mb4` charset and collation for MySQL test database (Sage Abdullah)
 * Maintenance: Add `django.contrib.postgres` to test settings `INSTALLED_APPS` (Sage Abdullah)
 * Maintenance: Add integrity & resolved checksums to package-lock.json (Sylvain Fankhauser)
 * Maintenance: Replace `SlugController` with more generic and reusable `CleanController` (LB (Ben) Johnston)
 * Maintenance: Remove outdated nginx / uWSGI example config files from `/etc` (LB (Ben) Johnston)
 * Maintenance: Use browser built-in `EventTarget` instead of `events.EventEmitter` from Webpack (Sage Abdullah)
 * Maintenance: Split code from `telepath/widgets.js` into separate files (Matt Westcott)
 * Maintenance: Update development UI guidelines to adopt best practices for image handling within the admin interface (Thibaud Colas)
 * Maintenance: Bump minimum Willow version to v1.11.0 to use Pillow's built-in AVIF support (Sage Abdullah)
 * Maintenance: Add overridable blocks in comments and checks side panel templates (Sage Abdullah)
 * Maintenance: Rewrite Tabs component frontend to use Stimulus and TypeScript (Sai Srikar Dumpeti, LB (Ben) Johnston, Sage Abdullah)
 * Maintenance: Upgrade django-tasks to 0.8.x (Jake Howard)
 * Maintenance: Refresh accessibility targets in contributing docs (Thibaud Colas)

7.0.7 (05.05.2026)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2026-44197: Improper permission handling when comparing revisions (Seoyoung Kang, Jake Howard)
 * Fix: CVE-2026-44198: Improper permission handling when viewing page history (Seoyoung Kang, Jake Howard, Dan Braghis)
 * Fix: CVE-2026-44199: Improper permission handling when deleting form submissions (Vishal Shukla, Jake Howard)
 * Fix: CVE-2026-44200: Improper permission handling when copying pages (Sanjok Karki, Matt Westcott)
 * Fix: CVE-2026-44201: Improper restriction handling on Documents and Images API (Sanjok Karki, Jake Howard)
 * Fix: Index the contents of image descriptions as well as titles, for CMS search (Advik Sharma)
 * Fix: Correctly escape the `sizes` attribute in responsive image template tags (Jake Howard)
 * Fix: Add accessible label to userbar aside element for accessibility (Kalash Kumari Thakur)
 * Fix: Prevent incorrect concurrent editing conflict notifications when doing a manual save (Sage Abdullah)

7.0.6 (03.03.2026)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2026-28222: Improper escaping of HTML (Cross-site Scripting) on TableBlock class attributes (Guan Chenxian, Matt Westcott)
 * Fix: CVE-2026-28223: Improper escaping of HTML (Cross-site Scripting) in simple_translation admin interface (Guan Chenxian, Matt Westcott)


7.0.5 (12.02.2026)
~~~~~~~~~~~~~~~~~~

 * Remove upper bound on Pillow dependency (Kunal Hemnani)

7.0.4 (03.02.2026)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent error on custom generic create and edit views without a header icon (Sage Abdullah)
 * Fix: CVE-2026-25517: Improper permission handling on admin preview endpoints (thxtech, Matt Westcott, Jake Howard)

7.0.3 (28.08.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent crash when previewing a form page with an empty field type (Sage Abdullah)


7.0.2 (24.07.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent error when restoring scroll position for cross-domain preview iframe (Sage Abdullah)
 * Fix: Remove ngram parser on MySQL that prevented autocomplete search from returning results (Vince Salvino)
 * Fix: Ensure the editing of translation alias pages correctly shows links to the source page if the alias was created from a draft (Dan Braghis)


7.0.1 (12.06.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Fix type hints for `register_filter_adapter_class` parameters (Sébastien Corbin)
 * Fix: Use correct URL when redirecting back to the listing after filtering and deleting form submissions (Sage Abdullah)
 * Fix: Fix broken migration when ListBlock is defined with a `child_block` kwarg (Matt Westcott)
 * Fix: Fix saving of empty values in EmbedBlock (Matt Westcott)
 * Fix: Sanitize request data when logging method not allowed (Jake Howard)
 * Docs: Use tuple instead of set in `UniqueConstraint` examples for a custom rendition model to avoid spurious migrations (Alec Baron)
 * Docs: Document how to turn off StreamField block previews (Shlomo Markowitz)
 * Maintenance: Use `utf8mb4` charset and collation for MySQL test database (Sage Abdullah)


7.0 LTS (06.05.2025)
~~~~~~~~~~~~~~~~~~~~

 * Add formal support for Django 5.2 (Matt Westcott)
 * Allow validation of required fields to be deferred on saving drafts (Matt Westcott, Sage Abdullah)
 * Add `WAGTAIL_` prefix to Wagtail-specific tag settings (Aayushman Singh)
 * Implement `normalize` on `TypedTableBlock` to assist with setting `default` and `preview_value` (Sage Abdullah)
 * Apply normalization when modifying a `StreamBlock`'s value to assist with programmatic changes to `StreamField` (Matt Westcott)
 * Allow a custom image rendition model to define its unique constraint with `models.UniqueConstraint` instead of `unique_together` (Oliver Parker, Cynthia Kiser, Sage Abdullah)
 * Default to the `standard` tokenizer on Elasticsearch, to correctly handle numbers as tokens (Matt Westcott)
 * Add color-scheme meta tag to Wagtail admin (Ashish Nagmoti)
 * Add the ability to set the default privacy restriction for new pages using `get_default_privacy_setting` (Shlomo Markowitz)
 * Improve performance of batch purging page urls in the frontend cache, avoiding n+1 query issues (Andy Babic)
 * Add better support and documentation for overriding or extending icons used in the in the userbar (Sébastien Corbin)
 * List the comments action, if comments are enabled, within the admin keyboard shortcuts dialog (Dhruvi Patel)
 * Add better support and documentation for overriding the default field widgets used within form pages (Baptiste Mispelon)
 * Allow workflow tasks to specify a template for the action modal via `get_template_for_action` (Sage Abdullah)
 * Change 'Publish' button label to 'Schedule to publish' if go-live schedule is set (Sage Abdullah)
 * Exclude snippets that have their own menu items from the "Snippets" menu (Andy Chosak, Matt Westcott)
 * Introduce new designs for listings and chooser pagination (except page chooser) (Jordan Teichmann, Sage Abdullah)
 * Add default "Locale" column to listings and choosers of translatable models (Dan Braghis, Sage Abdullah)
 * Apply current content's locale in choosers by default and add the ability to clear the locale filter (Dan Braghis)
 * Hide add locale button when no more languages are available (Dan Braghis)
 * Allow customizing `InspectView` field display value via methods on the view (Dan Braghis)
 * Make rendering of active listing filters extensible, to support additional filter types (Sage Abdullah)
 * Fix: Take preferred language into account for translatable strings in client-side code (Bernhard Bliem, Sage Abdullah)
 * Fix: Do not show the content type column as sortable when searching pages (Srishti Jaiswal, Sage Abdullah)
 * Fix: Support simple subqueries for `in` and `exact` lookup on Elasticsearch (Sage Abdullah)
 * Fix: Force preview panel scroll behavior to instant to avoid flickering (Sage Abdullah)
 * Fix: Support translating with the preferred language for rich text formatting labels (Bernhard Bliem, Sage Abdullah)
 * Fix: Make "Actions" label translatable within the rich text toolbar (Bernhard Bliem, Sage Abdullah)
 * Fix: Fix incorrect "Views (past week)" heading on promoted search results listing (Baptiste Mispelon)
 * Fix: Ensure `InlinePanel` will be correctly ordered after the first save when `min_num` is used (Elhussein Almasri, Joel William)
 * Fix: Avoid deprecation warnings about URLField `assume_scheme` on Django 5.x (Sage Abdullah)
 * Fix: Fix setup.cfg syntax for setuptools v78 (Sage Abdullah)
 * Fix: Ensure `ImproperlyConfigured` is thrown from `db_field` on unbound `FieldPanel`s as intended (Matt Westcott)
 * Fix: Refine the positioning of the add comment button next to select, radio, checkbox fields and between field row columns (Srishti Jaiswal)
 * Fix: Show the correct privacy status for child collections of private collections (Shlomo Markowitz)
 * Fix: Ensure reference index correctly handles models with primary keys not named `id` (Sage Abdullah)
 * Fix: On "move page" bulk action, do not prefill the destination with the root page (Stefan Hammer)
 * Fix: Ensure the default preferred language respects the `WAGTAILADMIN_PERMITTED_LANGUAGES` setting (Sébastien Corbin)
 * Fix: Ensure there is consistent padding in homepage panels table headers (Aditya (megatrron))
 * Fix: Prevent redundant calls to context processors when rendering userbar (Ihor Marhitych)
 * Fix: Fix validation of duplicate field names in form builder when fields have been deleted (Ian Meigh)
 * Fix: Fix font size of footer action buttons when there is only one item (Sage Abdullah)
 * Docs: Add missing `django.contrib.admin` to list of apps in "add to Django project" guide (Mohamed Rabiaa)
 * Docs: Add tutorial on deploying on Ubuntu to third-party tutorials (Mohammad Fathi Rahman)
 * Docs: Document that request_or_site is optional on BaseGenericSetting.load (Matt Westcott)
 * Docs: Mention third-party StreamField based form builder packages in the form builder documentation (Matt Westcott)
 * Docs: Clarify that `insert_editor_js` hook applies to all core editing/creation views (LB (Ben) Johnston)
 * Docs: Clarify requirement for non-page models using model mixins to be registered as snippets (Sage Abdullah)
 * Docs: Clarify that `Page.get_url_parts` will return a tuple, not `None` for `NoReverseMatch` errors (Arthur Tripp)
 * Docs: Add how-to Django Ninja to API documentation (Thibaud Colas)
 * Docs: Document the `expand_db_html` utility function to create HTML ready for display (Thibaud Colas)
 * Docs: Mention `expand_db_html` usage for rich text in REST framework API (Thibaud Colas)
 * Docs: Further document usage of API `?limit` with `WAGTAILAPI_LIMIT_MAX` (Thibaud Colas)
 * Maintenance: Migrate away from deprecated Sass import rules to module system (Srishti Jaiswal)
 * Maintenance: Apply Sass mixed declarations migration in preparation for CSS nesting (Prabhpreet Kaur)
 * Maintenance: Refactor styles for Draftail, minimap, and comments to fix remaining Sass migration warnings (Thibaud Colas)
 * Maintenance: npm package updates; `downshift`, `focus-trap-react`, `immer`, `redux`, `uuid` (LB (Ben) Johnston)
 * Maintenance: Validate against invalid characters in Lexeme values (Matt Westcott)
 * Maintenance: Split up `wagtail.models` module into submodules (Matt Westcott)
 * Maintenance: Update `ruff` to 0.9.6 (Sage Abdullah)
 * Maintenance: Fix up `stubs` & `adapter` contents to better support Jest testing (LB (Ben) Johnston)
 * Maintenance: Cleanup Stimulus controller imports, JSDoc & linting (LB (Ben) Johnston)
 * Maintenance: Rename `SkipLinkController` to `FocusController` with improved reusability, updated unit tests, and added story (LB (Ben) Johnston)
 * Maintenance: Fix CI testing issues with the Stimulus `LocaleController` time zones & non-deterministic page ordering tests (Sage Abdullah)
 * Maintenance: Make GitHub highlight `.html` files as Django templates (Jake Howard)
 * Maintenance: Remove admin JavaScript imports from shared template includes, moving the imports to the appropriate core admin inclusion locations (Sai Srikar Dumpeti)
 * Maintenance: Remove non-editing view inclusions of the `insert_editor_js` hook output, deprecate the wrapper template tag `_editor_js.html` (Sai Srikar Dumpeti, LB (Ben) Johnston)
 * Maintenance: Remove upper bound on Django dependency (Matt Westcott)
 * Maintenance: Add `default_auto_field` setting to home app in project template (Sylvain Boissel)
 * Maintenance: Migrate setuptools configuration from `setup.py` and `setup.cfg` to `pyproject.toml` (Sage Abdullah)
 * Maintenance: Refactor `move_choose_destination` to a class-based view (Chiemezuo Akujobi)
 * Maintenance: Remove deprecated `wagtailadmin/shared/ajax_pagination_nav.html` template (Sage Abdullah)
 * Maintenance: Formally deprecate support for listing views with no breadcrumbs (Sage Abdullah)
 * Maintenance: Update `django-tasks` to 0.7.x (Jake Howard)


6.4.2 (12.06.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Do not show upgrade notification if the installed version is the latest (Sage Abdullah)
 * Fix: Use correct URL when redirecting back to the listing after filtering and deleting form submissions (Sage Abdullah)
 * Fix: Fix broken migration when ListBlock is defined with a `child_block` kwarg (Matt Westcott)
 * Fix: Sanitize request data when logging method not allowed (Jake Howard)
 * Maintenance: Use `utf8mb4` charset and collation for MySQL test database (Sage Abdullah)


6.4.1 (21.02.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent error when filtering by locale and searching with Elasticsearch (Sage Abdullah)
 * Fix: Support searching `none()` querysets (Matt Westcott)
 * Fix: Correctly handle UUID primary keys when invoking background tasks (Matt Westcott)
 * Fix: Fix regression where nested sub-menu items would not be visible (Sage Abdullah)
 * Fix: Ensure the top of the minimap correctly adjusts when resizing the browser viewport (Thibaud Colas)
 * Fix: Remove obsolete SubqueryConstraint check in search backends, for provisional Django 5.2 compatibility (Sage Abdullah)
 * Fix: Add missing “Close” label to the upgrade notification dismiss button (Sage Abdullah)
 * Fix: Fix white text on white background in previews for sites that use color-scheme without a background-color (Sage Abdullah)
 * Docs: Fix typo in the headless documentation page (Mahmoud Nasser)
 * Docs: Fix typo in `Page.get_route_paths` docstring (Baptiste Mispelon)
 * Docs: Upgrade sphinx-wagtail-theme to v6.5.0 (Sage Abdullah)
 * Maintenance: Remove upper version boundary for django-filter (Dan Braghis)
 * Maintenance: Relax upper version boundaries for django-taggit and beautifulsoup4 (Matt Westcott)


6.4 (03.02.2025)
~~~~~~~~~~~~~~~~

 * Support for background tasks using `django-tasks` (Jake Howard)
 * Add search terms report (Noah van der Meer, Sage Abdullah)
 * Add the ability to apply basic Page QuerySet optimizations to `specific()` sub-queries using `select_related` & `prefetch_related` (Andy Babic)
 * Increase `DATA_UPLOAD_MAX_NUMBER_FIELDS` in project template (Matt Westcott)
 * Stop invalid Site hostname records from breaking preview (Matt Westcott)
 * Set sensible defaults for InlinePanel heading and label (Matt Westcott)
 * Limit tags autocompletion to 10 items and add delay to avoid performance issues with large number of matching tags (Aayushman Singh)
 * Add the ability to restrict what types of requests a Pages supports via `allowed_http_methods` (Andy Babic)
 * Allow plain strings in panel definitions as shorthand for `FieldPanel` / `InlinePanel` (Matt Westcott)
 * Only allow selection of valid new parents within the copy Page view (Mauro Soche)
 * Add `on_serve_page` hook to modify the serving chain of pages (Krystian Magdziarz, Dawid Bugajewski)
 * Add support for `WAGTAIL_GRAVATAR_PROVIDER_URL` URLs with query string parameters (Ayaan Qadri, Guilhem Saurel)
 * Add `get_avatar_url` hook to customise user avatars (James Harrington)
 * Set content security policy (CSP) headers to block embedded content when serving images and documents (Jake Howard, with thanks to Ali İltizar for the initial report)
 * Add `page` as a third parameter to the `construct_wagtail_userbar` hook (claudobahn)
 * Enable breadcrumbs in revisions compare view (Sage Abdullah)
 * Skip loading of unused JavaScript to speed up 404 page rendering (Sage Abdullah)
 * Replace l18n library with JavaScript Intl API for time zone options in Account view (Sage Abdullah)
 * Use explicit label for defaulting to server language in account settings (Sage Abdullah)
 * Add support for specifying an operator on `Fuzzy` queries (Tom Usher)
 * Remove support for Safari 15 (Thibaud Colas)
 * Populate the ImageBlock alt text from the image’s default alt text when selecting a new image (Matt Westcott)
 * Prevent main menu from re-rendering when clicking outside while the menu is closed (Sage Abdullah)
 * Fill in the ImageBlock alt text from the image’s default alt text when converting from ImageChooserBlock (Cynthia Kiser)
 * Make sure typing text at the bottom of the page editor always scrolls enough to keep the text into view (Jatin Bhardwaj)
 * Add StreamField and InlinePanel interfaces support for drag-and-drop reordering of items (Thibaud Colas, Sage Abdullah)
 * Add previews support for StreamField blocks inside the block picker (Sage Abdullah, Thibaud Colas)
 * Fix: Improve handling of translations for bulk page action confirmation messages (Matt Westcott)
 * Fix: Ensure custom rich text feature icons are correctly handled when provided as a list of SVG paths (Temidayo Azeez, Joel William, LB (Ben) Johnston)
 * Fix: Prevent error on lazily loading StreamField blocks after the stream has been modified (Stefan Hammer)
 * Fix: Fix sub-menus within the main menu cannot be closed on mobile (Bojan Mihelac)
 * Fix: Fix animation overflow transition when navigating through subpages in the sidebar page explorer (manu)
 * Fix: Ensure form builder supports custom admin form validation (John-Scott Atlakson, LB (Ben) Johnston)
 * Fix: Ensure form builder correctly checks for duplicate field names when using a custom related name (John-Scott Atlakson, LB (Ben) Johnston)
 * Fix: Normalize `StreamField.get_default()` to prevent creation forms from breaking (Matt Westcott)
 * Fix: Prevent out-of-order migrations from skipping creation of image/document choose permissions (Matt Westcott)
 * Fix: Use correct connections on multi-database setups in database search backends (Jake Howard)
 * Fix: Ensure CloudFront cache invalidation is called with a list, for compatibility with current botocore versions (Jake Howard)
 * Fix: Show the correct privacy status in the sidebar when creating a new page (Joel William)
 * Fix: Prevent generic model edit view from unquoting non-integer primary keys multiple times (Matt Westcott)
 * Fix: Ensure comments are functional when editing Page models with `read_only` `Fieldpanel`s in use (Strapchay)
 * Fix: Ensure the accessible labels and tooltips reflect the correct private/public status on the live link button within pages after changing the privacy (Ayaan Qadri)
 * Fix: Fix empty `th` (table heading) elements that are not compliant with accessibility standards (Jai Vignesh J)
 * Fix: Ensure `MultipleChooserPanel` using images or documents work when nested within an `InlinePanel` when no other choosers are in use within the model (Elhussein Almasri)
 * Fix: Ensure `MultipleChooserPanel` works after doing a search in the page chooser modal (Matt Westcott)
 * Fix: Ensure new `ListBlock` instances get created with unique IDs in the admin client for accessibility and mini-map element references (Srishti Jaiswal)
 * Fix: Return never-cache HTTP headers when serving pages and documents with view restrictions (Krystian Magdziarz, Dawid Bugajewski)
 * Fix: Implement `get_block_by_content_path` on `ImageBlock` to prevent errors on commenting (Matt Westcott)
 * Fix: Add `aria-expanded` attribute to new column button on `TypedTableBlock` to reflect menu state (Ayaan Qadri, Scott Cranfill)
 * Fix: Allow page models to extend base `Page` panel definitions without importing `wagtail.admin` (Matt Westcott)
 * Fix: Fix crash when loading the dashboard with only the "unlock" or "bulk delete" page permissions (Unyime Emmanuel Udoh, Sage Abdullah)
 * Fix: Improve deprecation warning for `WidgetWithScript` by raising it with `stacklevel=3` (Joren Hammudoglu)
 * Fix: Correctly place comment buttons next to date / datetime / time fields. (Srishti Jaiswal)
 * Fix: Add missing heading and breadcrumbs in Account view (Sage Abdullah)
 * Fix: Reduce confusing spacing below StreamField blocks help text (Rishabh Sharma)
 * Fix: Prevent redundant calls to `Site.find_for_request()` from `Page.get_url_parts()` (Andy Babic)
 * Fix: Prevent error on listings when searching and filtering by locale (Matt Westcott, Sage Abdullah)
 * Fix: Add missing space in panels check warning message (Stéphane Blondon)
 * Fix: Make sure alt text quality check is on by default as documented (Thibaud Colas)
 * Fix: Prevent `StreamChildrenToListBlockOperation` from duplicating data across multiple StreamField instances (Joshua Munn)
 * Fix: Prevent database error when calling permission_order.register on app ready (Daniel Kirkham, Matt Westcott)
 * Fix: Prevent syntax error on MySQL search when query includes symbols (Matt Westcott)
 * Docs: Move the model reference page from reference/pages to the references section as it covers all Wagtail core models (Srishti Jaiswal)
 * Docs: Move the panels reference page from references/pages to the references section as panels are available for any model editing, merge panels API into this page (Srishti Jaiswal)
 * Docs: Move the tags documentation to standalone advanced topic, instead of being inside the reference/pages section (Srishti Jaiswal)
 * Docs: Refine the adding reports page so that common (page/non-page) class references are at the top and the full page only example has correct heading nesting (Alessandro Chitarrini)
 * Docs: Add the `wagtail start` command to the management commands reference page (Damilola Oladele)
 * Docs: Refine the project template page sections and document common issues encountered when creating custom templates (Damilola Oladele)
 * Docs: Refine titles, references and URLs to better align with the documentation style guide, including US spelling (Srishti Jaiswal)
 * Docs: Recommend a larger `DATA_UPLOAD_MAX_NUMBER_FIELDS` when integrating Wagtail into Django (Matt Westcott)
 * Docs: Improve code highlighting and formatting for Python docstrings in core models (Srishti Jaiswal)
 * Docs: Update all JavaScript inline scripts & some CSS inline style tags to a CSP compliant approach by using external scripts/styles (Aayushman Singh)
 * Docs: Update usage of `mark_safe` to `format_html` for any script inclusions, to better avoid XSS issues from example code (Aayushman Singh)
 * Docs: Update documentation writing guidelines to encourage better considerations of security, accessibility and good practice when writing code examples (Aayushman Singh, LB (Ben) Johnston)
 * Docs: Update documentation guidelines on writing links and API reference (Sage Abdullah)
 * Docs: Replace absolute URLs with intersphinx links where possible to avoid broken links (Sage Abdullah)
 * Docs: Update upgrading guide and release process to better reflect the current practices (Sage Abdullah)
 * Docs: Document usage of custom validation for admin form pages when using `AbstractEmailForm` or `AbstractForm` pages (John-Scott Atlakson, LB (Ben) Johnston)
 * Docs: Reword `BlogTagIndexPage` example for clarity (Clifford Gama)
 * Docs: Change title of blog index page in tutorial to avoid slug issues (Thibaud Colas)
 * Docs: Fix `wagtailcache` and `wagtailpagecache` examples to not use quotes for the `fragment_name` (Shiv)
 * Docs: Update tutorial to reflect the move of the "Add child page" action to a top-level button in the header as a '+' icon (Clifford Gama)
 * Docs: Fix link to `HTTPMethod` in `Page.handle_options_request()` docs (Sage Abdullah)
 * Docs: Improve the Pages Theory page with added & more consistent section headings and admonitions to aid in readability (Clifford Gama)
 * Docs: Fix non-functional link to the community guidelines in the Your first contribution page (Ankit Kumar)
 * Docs: Introduce tags and filters by name in "Writing templates" docs (Clifford Gama)
 * Docs: Add a new headless section to the documentation, incorporating parts of the 'are we headless' website content (Sævar Öfjörð Magnússon, Alex Fulcher)
 * Docs: Fix Django HTML syntax formatting issue on the documents overview page (LB (Ben) Johnston)
 * Docs: Separate virtual environment creation and activation steps in tutorial (Ankit Kumar)
 * Docs: Update tutorial to use plain strings in place of `FieldPanel` / `InlinePanel` where appropriate (Unyime Emmanuel Udoh)
 * Docs: Update example for customizing "p-as-heading" accessibility check without overriding built-in checks (Cynthia Kiser)
 * Docs: Document `get_template` method on StreamField blocks (Matt Westcott)
 * Docs: Update accessibility considerations on alt text in light of contextual alt text improvements (Cynthia Kiser)
 * Docs: Revert incorrect example of appending a `RichTextBlock` to a `StreamField` (Matt Westcott)
 * Maintenance: Close open files when reading within utils/setup.py (Ataf Fazledin Ahamed)
 * Maintenance: Avoid redundant `ALLOWED_HOSTS` check in `Site.find_for_request` (Jake Howard)
 * Maintenance: Update `CloneController` to ensure that `added`/`cleared` events are not dispatched as cancelable (LB (Ben) Johnston)
 * Maintenance: Remove unused `uuid` UMD module as all code is now using the NPM module (LB (Ben) Johnston)
 * Maintenance: Clean up JS comments throughout codebase to be aligned to JSDoc where practical (LB (Ben) Johnston)
 * Maintenance: Replace `eslint-disable no-undef` linter directives with `global` comments (LB (Ben) Johnston)
 * Maintenance: Upgrade Node tooling to active LTS version 22 (LB (Ben) Johnston)
 * Maintenance: Remove defunct oEmbed providers (Rahul Samant)
 * Maintenance: Remove obsolete non-upsert-based code for Postgres search indexing (Jake Howard)
 * Maintenance: Remove unused Rangy JS library (LB (Ben) Johnston)
 * Maintenance: Update `PreviewController` usage to leverage Stimulus actions instead of calling `preventDefault` manually (Ayaan Qadri)
 * Maintenance: Various performance optimizations to page publishing (Jake Howard)
 * Maintenance: Remove unnecessary DOM canvas.toBlob polyfill (LB (Ben) Johnston)
 * Maintenance: Ensure Storybook core files are correctly running through Eslint (LB (Ben) Johnston)
 * Maintenance: Add a new Stimulus `ZoneController` (`w-zone`) to support dynamic class name changes & event handling on container elements (Ayaan Qadri)
 * Maintenance: Migrate jQuery class toggling & drag/drop event handling within the multiple upload views to the Stimulus ZoneController usage (Ayaan Qadri)
 * Maintenance: Test project template for warnings when run against Django pre-release versions (Sage Abdullah)
 * Maintenance: Refactor redirects create/delete views to use generic views (Sage Abdullah)
 * Maintenance: Add JSDoc description, adopt linting recommendations, and add more unit tests for `ModalWorkflow` (LB (Ben) Johnston)
 * Maintenance: Add support for a `delay` value in `TagController` to debounce async autocomplete tag fetch requests (Aayushman Singh)
 * Maintenance: Add unit tests, Storybook stories & JSDoc items for the Stimulus `DrilldownController` (Srishti Jaiswal)
 * Maintenance: Enhance sidebar preview performance by eliminating duplicate asset loads on preview error (Sage Abdullah)
 * Maintenance: Remove unused `LinkController` (`w-link`) (Sage Abdullah)
 * Maintenance: Refactor settings `EditView` to make better use of generic `EditView` (Sage Abdullah)
 * Maintenance: Add a new Stimulus `RulesController` (`w-rules`) to support declarative conditional field enabling from other field values in a form (LB (Ben) Johnston)
 * Maintenance: Migrate the conditional enabling of fields in the image URL builder view away from ad-hoc jQuery to use the `RulesController` (`w-rules`) approach (LB (Ben) Johnston)
 * Maintenance: Enhance the Stimulus `ZoneController` (`w-zone`) to support inactive class and a mechanism to switch the mode based on data within events (Ayaan Qadri)
 * Maintenance: Use the Stimulus `ZoneController` (`w-zone`) to remove ad-hoc jQuery for the privacy switch when toggling visibility of private/public elements (Ayaan Qadri)
 * Maintenance: Remove unused `is_active` & `active_menu_items` from `wagtail.admin.menu.MenuItem` (Srishti Jaiswal)
 * Maintenance: Only call `openpyxl` at runtime to improve performance for projects that do not use `ReportView`, `SpreadsheetExportMixin` and `wagtail.contrib.redirects` (Sébastien Corbin)
 * Maintenance: Adopt the update value `mp` instead of `mm` for 'mystery person' as the default Gravatar if no avatar found (Harsh Dange)
 * Maintenance: Refactor search promotions views to use generic views and templates (Sage Abdullah, Rohit Sharma)
 * Maintenance: Use built-in `venv` instead of `pipenv` in CircleCI (Sage Abdullah)
 * Maintenance: Add a new Stimulus `FormsetController` (`w-formset`) to support dynamic formset insertion/deletion behavior (LB (Ben) Johnston)
 * Maintenance: Enable breadcrumbs by default on admin views using generic templates (Sage Abdullah)
 * Maintenance: Refactor pages `revisions_revert` view to be a subclass of `EditView` (Sage Abdullah)
 * Maintenance: Move images and documents `get_usage().count()` call to view code (Sage Abdullah)
 * Maintenance: Upgrade sass-loader to resolve Sass deprecation warnings (Ayaan Qadri)

6.3.9 (xx.xx.xxxx) - IN DEVELOPMENT
~~~~~~~~~~~~~~~~~~

 * Fix: Index the contents of image descriptions as well as titles, for CMS search (Advik Sharma)

6.3.8 (03.03.2026)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2026-28222: Improper escaping of HTML (Cross-site Scripting) on TableBlock class attributes (Guan Chenxian, Matt Westcott)
 * Fix: CVE-2026-28223: Improper escaping of HTML (Cross-site Scripting) in simple_translation admin interface (Guan Chenxian, Matt Westcott)


6.3.7 (12.02.2026)
~~~~~~~~~~~~~~~~~~

 * Remove upper bound on Pillow dependency


6.3.6 (03.02.2026)
~~~~~~~~~~~~~~~~~~

 * Fix: Remove ngram parser on MySQL that prevented autocomplete search from returning results (Vince Salvino)
 * Fix: CVE-2026-25517: Improper permission handling on admin preview endpoints (thxtech, Matt Westcott, Jake Howard)


6.3.5 (12.06.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Use correct URL when redirecting back to the listing after filtering and deleting form submissions (Sage Abdullah)
 * Fix: Fix broken migration when ListBlock is defined with a `child_block` kwarg (Matt Westcott)
 * Maintenance: Use `utf8mb4` charset and collation for MySQL test database (Sage Abdullah)


6.3.4 (24.04.2025)
~~~~~~~~~~~~~~~~~~

 * Added support for Django 5.2
 * Fix: Add missing “Close” label to the upgrade notification dismiss button (Sage Abdullah)
 * Fix: Fix white text on white background in previews for sites that use color-scheme without a background-color (Sage Abdullah)
 * Maintenance: Remove upper version boundary for django-filter (Dan Braghis)


6.3.3 (03.02.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Correctly place comment buttons next to date / datetime / time fields. (Srishti Jaiswal)
 * Fix: Reduce confusing spacing below StreamField blocks help text (Rishabh Sharma)
 * Fix: Make sure alt text quality check is on by default as documented (Thibaud Colas)
 * Fix: Prevent `StreamChildrenToListBlockOperation` from duplicating data across multiple StreamField instances (Joshua Munn)
 * Fix: Prevent database error when calling permission_order.register on app ready (Daniel Kirkham, Matt Westcott)
 * Fix: Prevent error on lazily loading StreamField blocks after the stream has been modified (Stefan Hammer)
 * Fix: Prevent syntax error on MySQL search when query includes symbols (Matt Westcott)
 * Docs: Update example for customizing "p-as-heading" accessibility check without overriding built-in checks (Cynthia Kiser)
 * Docs: Update accessibility considerations on alt text in light of contextual alt text improvements (Cynthia Kiser)
 * Docs: Revert incorrect example of appending a `RichTextBlock` to a `StreamField` (Matt Westcott)


6.3.2 (02.01.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Ensure CloudFront cache invalidation is called with a list, for compatibility with current botocore versions (Jake Howard)
 * Fix: Ensure Draftail features wrap when a large amount of features are added (Bart Cieliński)
 * Fix: Implement `get_block_by_content_path` on `ImageBlock` to prevent errors on commenting (Matt Westcott)
 * Docs: Update tutorial to reflect the move of the "Add child page" action to a top-level button in the header as a '+' icon (Clifford Gama)


6.3.1 (19.11.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Restore ability to upload profile picture through account settings (Sage Abdullah)
 * Fix: Correctly handle `ImageChooserBlock` to `ImageBlock` data conversions where all inputs to `bulk_to_python` are null (Storm Heg, Matt Westcott)
 * Fix: Improve spacing of page / collection permissions table in Group settings (Sage Abdullah)
 * Fix: Remove forced capitalization of site name on admin dashboard (Thibaud Colas)
 * Docs: Reword `BlogTagIndexPage` example for clarity (Clifford Gama)
 * Docs: Change title of blog index page in tutorial to avoid slug issues (Thibaud Colas)
 * Docs: Fix `wagtailcache` and `wagtailpagecache` examples to not use quotes for the `fragment_name` (Shiv)
 * Docs: Lower search result ranking for release notes on readthedocs search (Sage Abdullah)


6.3 LTS (01.11.2024)
~~~~~~~~~~~~~~~~~~~~

 * Add support for Python 3.13 (Matt Westcott)
 * Add formal support for Django 5.1 (Matt Westcott)
 * Add `ImageBlock` with alt text support (Chiemezuo Akujobi for Google Summer of Code, mentored by Storm Heg, Saptak Sengupta, Thibaud Colas and Matt Westcott)
 * Implement incremental dashboard design enhancements (Albina Starykova, Ben Enright)
 * Add a new enhanced contrast admin theming option for the admin interface (Albina Starykova, Victoria Ottah)
 * Migrate workflow history views to universal listings (Sage Abdullah)
 * Refactor documents views to use universal designs (Sage Abdullah)
 * Refactor images views to use universal designs (Sage Abdullah)
 * Implement universal listings for workflow usage and page type usage views (Sage Abdullah)
 * Add search and filters to form pages listing (Sage Abdullah)
 * Add support for uploading HEIC / HEIF images (Matt Westcott)
 * Allow customization of preview device sizes in the live preview panel (Bart Cieliński, alexkiro, Sage Abdullah)
 * Formalize support for MariaDB (Sage Abdullah, Daniel Black)
 * Redirect to the last viewed listing page after deleting form submissions (Matthias Brück)
 * Provide `getTextLabel` method on date / time StreamField blocks (Vaughn Dickson)
 * Purge frontend cache when modifying redirects (Jake Howard)
 * Deprecate the `WAGTAIL_AUTO_UPDATE_PREVIEW` setting, use `WAGTAIL_AUTO_UPDATE_PREVIEW_INTERVAL = 0` instead (Sage Abdullah)
 * Consistently use `capfirst` for title-casing model verbose names (Sébastien Corbin)
 * Fire `copy_for_translation_done` signal when copying translatable models as well as pages (Coen van der Kamp)
 * Add support for an image `description` field across all images, to better support accessible image descriptions (Chiemezuo Akujobi)
 * Prompt the user about unsaved changes when editing snippets (Sage Abdullah)
 * Make dashboard upgrade banners dismissible (Sage Abdullah)
 * Add support for specifying different preview modes to the "View draft" URL for pages (Robin Varghese)
 * Implement new designs for the footer actions dropdown with more contrast and larger text (Sage Abdullah)
 * All create/edit admin forms now use a sticky submit button, for consistency and to speed up edits (Sage Abdullah)
 * Secondary form actions such as "Delete" are now in the header actions menu (Sage Abdullah)
 * Allow setting page privacy rules when a restriction already exists on an ancestor page (Bojan Mihelac)
 * Automatically create links when pasting content that contains URLs into a rich text input (Thibaud Colas)
 * Add Uyghur language support
 * Fix: Prevent page type business rules from blocking reordering of pages (Andy Babic, Sage Abdullah)
 * Fix: Improve layout of object permissions table (Sage Abdullah)
 * Fix: Fix typo in aria-label attribute of page explorer navigation link (Sébastien Corbin)
 * Fix: Reinstate transparency indicator on image chooser widgets (Sébastien Corbin)
 * Fix: Remove table headers that have no text (Matt Westcott)
 * Fix: Fix broken link to user search (Shlomo Markowitz)
 * Fix: Ensure that JS slugify function strips Unicode characters disallowed by Django slug validation (Atif Khan)
 * Fix: Do not show notices about root / unroutable pages when searching or filtering in the page explorer (Matt Westcott)
 * Fix: Resolve contrast issue for page deletion warning (Sanjeev Holla S)
 * Fix: Make sure content metrics falls back to body element only when intended (Sage Abdullah)
 * Fix: Remove wrongly-added filters from redirects index (Matt Westcott)
 * Fix: Prevent popular tags filter from generating overly complex queries when not filtering (Matt Westcott)
 * Fix: Fix content path links in usage view to scroll to the correct element (Sage Abdullah)
 * Fix: Always show the minimap toggle button (Albina Starykova)
 * Fix: Ensure that dropdown button toggles show with a border in high contrast mode (Ishwari8104, LB (Ben) Johnston)
 * Fix: Update email notification header to the new logo design (Rahul Samant)
 * Fix: Change `file_size` field on document model to avoid artificial 2Gb limit (Gabriel Getzie)
 * Fix: Ensure that `TypedTableBlock` uses the correct API representations of child blocks (Matt Westcott)
 * Fix: Footer action buttons now include their `media` definitions (Sage Abdullah)
 * Fix: Improve the text contrast of the bulk actions "Select all" button (Sage Abdullah)
 * Fix: Fix error on workflow settings view with multiple snippet types assigned to the same workflow on Postgres (Sage Abdullah)
 * Fix: Fix datetime fields overflowing its parent wrapper in listing filters (Rohit Singh)
 * Fix: Prevent multiple URLs from being combined into one when pasting links into a rich text input (Thibaud Colas)
 * Fix: Improve layout of report listing tables (Sage Abdullah)
 * Fix: Fix regression from creation of `AbstractGroupApprovalTask` to ensure `can_handle` checks for the abstract class correctly (Sumana Sree Angajala)
 * Docs: Upgrade Sphinx to 7.3 (Matt Westcott)
 * Docs: Upgrade sphinx-wagtail-theme to v6.4.0, with a new search integration and Read the Docs Addons bug fixes (Thibaud Colas)
 * Docs: Document how to customize date/time format settings (Vince Salvino)
 * Docs: Create a new documentation section for deployment and move fly.io deployment from the tutorial to this section (Vince Salvino)
 * Docs: Clarify process for UserViewSet customization (Sage Abdullah)
 * Docs: Correct `WAGTAIL_WORKFLOW_REQUIRE_REAPPROVAL_ON_EDIT` documentation to state that it defaults to `False` (Matt Westcott)
 * Docs: Add an example of customizing a default accessibility check (Cynthia Kiser)
 * Docs: Demonstrate access protection with `TokenAuthentication` in the Wagtail API v2 Configuration Guide (Krzysztof Jeziorny)
 * Docs: Replace X links with Mastodon in the README (Alex Morega)
 * Docs: Re-enable building offline formats in online documentation (Read the docs) for EPUB/PDF/HTML downloads (Joel William, Sage Abdullah)
 * Docs: Resolve multiple output errors in the documentation ePub format (Sage Abdullah)
 * Docs: Update social media examples to use LinkedIn, Reddit, Facebook (Ayaan Qadri)
 * Maintenance: Removed support for Python 3.8 (Matt Westcott)
 * Maintenance: Drop pytz dependency in favour of `zoneinfo.available_timezones` (Sage Abdullah)
 * Maintenance: Relax django-taggit dependency to allow 6.0 (Matt Westcott)
 * Maintenance: Improve page listing performance (Sage Abdullah)
 * Maintenance: Phase out usage of SECRET_KEY in version and icon hashes (Jake Howard)
 * Maintenance: Audit all use of localized and non-localized numbers in templates (Matt Westcott)
 * Maintenance: Refactor StreamField `get_prep_value` for closer alignment with JSONField (Sage Abdullah)
 * Maintenance: Move search implementation logic from generic `IndexView` to `BaseListingView` (Sage Abdullah)
 * Maintenance: Upgrade Puppeteer integration tests for reliability (Matt Westcott)
 * Maintenance: Restore ability to use `.in_bulk()` on specific querysets under Django 5.2a0 (Sage Abdullah)
 * Maintenance: Add generated `test-media` to .gitignore (Shlomo Markowitz)
 * Maintenance: Improve `debounce` util's return type for better TypeScript usage (Sage Abdullah)
 * Maintenance: Ensure the side panel's show event is dispatched after any hide events (Sage Abdullah)
 * Maintenance: Migrate preview-panel JavaScript to Stimulus & TypeScript, add full unit testing (Sage Abdullah)
 * Maintenance: Move `wagtailConfig` values from inline scripts to the `wagtail_config` template tag (LB (Ben) Johnston, Sage Abdullah)
 * Maintenance: Deprecate the `{% locales %}` and `{% js_translation_strings %}` template tags (LB (Ben) Johnston, Sage Abdullah)
 * Maintenance: Ensure multi-line comments are cleaned from custom icons in addition to just single line comments (Jake Howard)
 * Maintenance: Deprecate `window.wagtailConfig.BULK_ACTION_ITEM_TYPE` usage in JavaScript to reduce reliance on inline scripts (LB (Ben) Johnston)
 * Maintenance: Remove `window.fileupload_opts` usage in JavaScript, use data attributes on fields instead to reduce reliance on inline scripts (LB (Ben) Johnston)
 * Maintenance: Remove `image_format_name_to_content_type` helper function that duplicates Willow functionality (Matt Westcott)
 * Maintenance: Improve code reuse for footer actions markup across generic views (Sage Abdullah)
 * Maintenance: Deprecate internal `DeleteMenuItem` API for footer actions (Sage Abdullah)
 * Maintenance: Update Pillow dependency to allow 11.x (Storm Heg)


6.2.4 (12.06.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Fix broken migration when ListBlock is defined with a `child_block` kwarg (Matt Westcott)


6.2.3 (01.11.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent multiple URLs from being combined into one when pasting links into a rich text input (Thibaud Colas)
 * Fix: Fix error on workflow settings view with multiple snippet types assigned to the same workflow on Postgres (Sage Abdullah)
 * Fix: Prevent history view from breaking if a log entry's revision is missing (Matt Westcott)
 * Docs: Upgrade sphinx-wagtail-theme to v6.4.0, with a new search integration and Read the Docs Addons bug fixes (Thibaud Colas)


6.2.2 (24.09.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Fix various instances of `USE_THOUSAND_SEPARATOR` formatting numbers where formatting is invalid (Sébastien Corbin, Matt Westcott)
 * Fix: Fix broken link to user search (Shlomo Markowitz)
 * Fix: Make sure content metrics falls back to body element only when intended (Sage Abdullah)
 * Fix: Remove wrongly-added filters from redirects index (Matt Westcott)
 * Fix: Prevent popular tags filter from generating overly complex queries when not filtering (Matt Westcott)
 * Docs: Clarify process for UserViewSet customization (Sage Abdullah)


6.2.1 (20.08.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Handle `child_block` being passed as a kwarg in ListBlock migrations (Matt Westcott)
 * Fix: Fix broken task type filter in workflow task chooser modal (Sage Abdullah)
 * Fix: Prevent circular imports between `wagtail.admin.models` and custom user models (Matt Westcott)
 * Fix: Ensure that concurrent editing check works for users who only have edit access via workflows (Matt Westcott)


6.2 (01.08.2024)
~~~~~~~~~~~~~~~~

 * Optimize and consolidate redirects report view into the index view (Jake Howard, Dan Braghis)
 * Support a `HOSTNAMES` parameter on `WAGTAILFRONTENDCACHE` to define which hostnames a backend should respond to (Jake Howard, sponsored by Oxfam America)
 * Refactor redirects edit view to use the generic `EditView` and breadcrumbs (Rohit Sharma)
 * Allow custom permission policies on snippets to prevent superusers from creating or editing them (Sage Abdullah)
 * Do not link to edit view from listing views if user has no permission to edit (Sage Abdullah)
 * Allow access to snippets and other model viewsets to users with "View" permission (Sage Abdullah)
 * Skip `ChooseParentView` if only one possible valid parent page is available (Matthias Brück)
 * Add `copy_for_translation_done` signal when a page is copied for translation (Arnar Tumi Þorsteinsson)
 * Remove reduced opacity for draft page title in listings (Inju Michorius)
 * Adopt more compact representation for StreamField definitions in migrations (Matt Westcott)
 * Implement a new design for locale labels in listings (Albina Starykova)
 * Add alt text validation rule in the accessibility checker (Albina Starykova)
 * Add a `deactivate()` method to `ProgressController` (Alex Morega)
 * Allow manually specifying credentials for CloudFront frontend cache backend (Jake Howard)
 * Automatically register permissions for models registered with a `ModelViewSet` (Sage Abdullah)
 * Implement universal listings UI for report views (Sage Abdullah)
 * Make `routable_resolver_match` attribute available on RoutablePageMixin responses (Andy Chosak)
 * Support customizations to `UserViewSet` via the app config (Sage Abdullah)
 * Add word count and reading time metrics within the page editor (Albina Starykova. Sponsored by The Motley Fool)
 * Implement a new design for accessibility checks (Albina Starykova)
 * Allow changing available privacy options per page model (Shlomo Markowitz)
 * Add concurrent editing notifications for pages and snippets (Matt Westcott, Sage Abdullah)
 * Add "soft" client-side validation for `StreamBlock` / `ListBlock` `min_num` / `max_num` (Matt Westcott)
 * Log accessibility checker results in the console to help developers with troubleshooting (Thibaud Colas)
 * Disable pointer events on checker highlights to simplify DevTools inspections (Thibaud Colas)
 * `StaticBlock` now renders nothing by default when no template is specified (Sævar Öfjörð Magnússon)
 * Fix: Make `WAGTAILIMAGES_CHOOSER_PAGE_SIZE` setting functional again (Rohit Sharma)
 * Fix: Enable `richtext` template tag to convert lazy translation values (Benjamin Bach)
 * Fix: Ensure permission labels on group permissions page are translated where available (Matt Westcott)
 * Fix: Preserve whitespace in comment replies (Elhussein Almasri)
 * Fix: Address layout issues in the title cell of universal listings (Sage Abdullah)
 * Fix: Support SVG icon id attributes with single quotes in the styleguide (Sage Abdullah)
 * Fix: Do not show delete button on model edit views if per-instance permissions prevent deletion (Matt Westcott)
 * Fix: Remove duplicate header in privacy dialog when a privacy setting is set on a parent page or collection (Matthias Brück)
 * Fix: Allow renditions of `.ico` images (Julie Rymer)
 * Fix: Handle choice groups as dictionaries in active filters (Sébastien Corbin)
 * Fix: Add separators when displaying multiple error messages on a StructBlock (Kyle Bayliss)
 * Fix: Specify `verbose_name` on `TranslatableMixin.locale` so that it is translated when used as a label (Romein van Buren)
 * Fix: Disallow null characters in API filter values (Jochen Wersdörfer)
 * Fix: Fix image preview when Willow optimizers are enabled (Alex Tomkins)
 * Fix: Ensure external-to-internal link conversion works when the `wagtail_serve` view is on a non-root path (Sage Abdullah)
 * Fix: Add missing `for_instance` method to `PageLogEntryManager` (Matt Westcott)
 * Fix: Ensure that "User" column on history view is translatable (Romein van Buren)
 * Fix: Handle StreamField migrations where the field value is null (Joshua Munn)
 * Fix: Prevent incorrect menu ordering when order value is 0 (Ben Dickinson)
 * Fix: Fix dynamic image serve view with certain backends (Sébastien Corbin)
 * Fix: Show not allowed extension in error message (Sahil Jangra)
 * Fix: Fix focal point chooser when localization enabled (Sébastien Corbin)
 * Fix: Ensure that system checks for `WAGTAIL_DATE_FORMAT`, `WAGTAIL_DATETIME_FORMAT` and `WAGTAIL_TIME_FORMAT` take `FORMAT_MODULE_PATH` into account (Sébastien Corbin)
 * Fix: Prevent rich text fields inside choosers from being duplicated when opened repeatedly (Sage Abdullah)
 * Fix: Prevent history view from breaking if a log entry's revision is missing (Matt Westcott)
 * Fix: Prevent long filenames from breaking layout on document chooser listings (Frank Yiu, Shaurya Panchal)
 * Docs: Remove duplicate section on frontend caching proxies from performance page (Jake Howard)
 * Docs: Document `restriction_type` field on PageViewRestriction (Shlomo Markowitz)
 * Docs: Document Wagtail's bug bounty policy (Jake Howard)
 * Docs: Fix incorrect Sphinx-style code references to use MyST style (Byron Peebles)
 * Docs: Document the fact that `Orderable` is not required for inline panels (Bojan Mihelac)
 * Docs: Add note about `prefers-reduced-motion` to the accessibility documentation (Roel Koper)
 * Docs: Update deployment instructions for Fly.io (Jeroen de Vries)
 * Docs: Add better docs for generating URLs on creating admin views (Shlomo Markowitz)
 * Docs: Document the `vary_fields` property for custom image filters (Daniel Kirkham)
 * Docs: Fix documentation build errors (Himanshu Garg, Chris Shenton)
 * Docs: Fix PDF export (Nathanaël Jourdane)
 * Maintenance: Use `DjangoJSONEncoder` instead of custom `LazyStringEncoder` to serialize Draftail config (Sage Abdullah)
 * Maintenance: Refactor image chooser pagination to check `WAGTAILIMAGES_CHOOSER_PAGE_SIZE` at runtime (Matt Westcott)
 * Maintenance: Exclude the `client/scss` directory in Tailwind content config to speed up CSS compilation (Sage Abdullah)
 * Maintenance: Split `contrib.frontend_cache.backends` into dedicated sub-modules (Andy Babic)
 * Maintenance: Remove unused `docs/autobuild.sh` script (Sævar Öfjörð Magnússon)
 * Maintenance: Replace `urlparse` with `urlsplit` to improve performance (Jake Howard)
 * Maintenance: Optimize embed finder lookups (Jake Howard)
 * Maintenance: Improve performance of initial admin loading by moving sprite hashing out of module import time (Jake Howard)
 * Maintenance: Remove workaround and inline scripts for activating workflow actions (Sage Abdullah)
 * Maintenance: Prevent `'BlockWidget' object has no attribute '_block_json'` from masking errors during StreamField serialization (Matt Westcott)


6.1.3 (11.07.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2024-39317: Regular expression denial-of-service via search query parsing (Jake Howard)
 * Fix: Allow renditions of `.ico` images (Julie Rymer)
 * Fix: Handle choice groups as dictionaries in active filters (Sébastien Corbin)
 * Fix: Fix image preview when Willow optimizers are enabled (Alex Tomkins)
 * Fix: Fix dynamic image serve view with certain backends (Sébastien Corbin)


6.1.2 (30.05.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Fix client-side handling of select inputs within `ChoiceBlock` (Matt Westcott)
 * Fix: Support SVG icon id attributes with single quotes in the styleguide (Sage Abdullah)
 * Fix: CVE-2024-35228: Improper handling of insufficient permissions in `wagtail.contrib.settings` (Victor Miti, Matt Westcott, Jake Howard)


6.1.1 (21.05.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Fix form action URL in user edit and delete views for custom user models (Sage Abdullah)
 * Fix: Fix snippet copy view not prefilling form data (Sage Abdullah)
 * Fix: Address layout issues in the title cell of universal listings (Sage Abdullah)
 * Fix: Fix incorrect rich text to HTML conversion when multiple link / embed types are present (Andy Chosak, Matt Westcott)
 * Fix: Restore ability for custom widgets in StreamField blocks to have multiple top-level nodes (Sage Abdullah, Matt Westcott)


6.1 (01.05.2024)
~~~~~~~~~~~~~~~~

 * Refine wording of page & collection privacy using password is a shared password and should not be used for secure content (Rohit Sharma, Jake Howard)
 * Add RelatedObjectsColumn to the table UI framework (Matt Westcott)
 * Reduce memory usage when rebuilding search indexes (Jake Howard)
 * Support creating images in .ico format (Jake Howard)
 * Add the ability to disable the usage of a shared password for enhanced security for the private pages and collections (documents) feature (Salvo Polizzi, Jake Howard)
 * Add system checks to ensure that `WAGTAIL_DATE_FORMAT`, `WAGTAIL_DATETIME_FORMAT`, `WAGTAIL_TIME_FORMAT` are correctly configured (Rohit Sharma, Coen van der Kamp)
 * Allow custom permissions with the same prefix as built-in permissions (Sage Abdullah)
 * Allow displaying permissions linked to the Admin model's content type (Sage Abdullah)
 * Add support for Draftail's JavaScript to use chooserUrls provided by entity options & for the Draftail widget to encode lazy URLs/ translations (Elhussein Almasri)
 * Reimplement search promotions `IndexView` using the `generic.IndexView` (Rohit Sharma, Sage Abdullah, Storm Heg)
 * Reimplement redirects `IndexView` using the `generic.IndexView` (Rohit Sharma, Sage Abdullah, Temidayo Azeez)
 * Add `PageListingViewSet` for custom per-page-type page listings (Matt Westcott)
 * Add `ChooseParentView` to `PageListingViewSet` to allow creating pages from custom page listings (Abdelrahman Hamada, Sage Abdullah)
 * Implement new universal listings design for image listing view (Sage Abdullah)
 * Implement new universal listings design for document listing view (Sage Abdullah)
 * Implement new universal listings design for site and locale listing views (Sage Abdullah)
 * Implement new universal listings design for page and snippet history view (Sage Abdullah)
 * Implement new universal listings design for form builder submissions view (Sage Abdullah)
 * Implement new universal listings design for collections listing view (Sage Abdullah)
 * Implement new universal listings design for groups views (Sage Abdullah)
 * Implement new universal listings design for users views (Sage Abdullah)
 * Implement new universal listings design for workflow and task views (Sage Abdullah)
 * Refine slim header button style to match designs (Sage Abdullah)
 * Add simple admin keyboard shortcuts overview dialog, available in the help sub-menu (Karthik Ayangar, Rohit Sharma)
 * Add ability to bulk toggle permissions in the user group editing view, including shift+click for multiple selections (LB (Ben) Johnston, Kalob Taulien)
 * Update the minimum version of `djangorestframework` to 3.15.1 (Sage Abdullah)
 * Add support for related fields in generic `IndexView.list_display` (Abdelrahman Hamada)
 * Improve page fetching logic and cache route results per request (Gordon Pendleton)
 * Optimize rewriting of links / embeds in rich text using bulk database lookups (Andy Chosak)
 * Add normalization mechanism to StreamField so that assignments and defaults can be passed in a wider range of data types (Joshua Munn, Matt Westcott)
 * Allow specifying a `STORAGES` alias name for `WAGTAILIMAGES_RENDITION_STORAGE` (Alec Baron)
 * Update `PASSWORD_REQUIRED_TEMPLATE` setting to `WAGTAIL_PASSWORD_REQUIRED_TEMPLATE` with deprecation of previous naming (Saksham Misra, LB (Ben) Johnston)
 * Update `DOCUMENT_PASSWORD_REQUIRED_TEMPLATE` setting to `WAGTAILDOCS_PASSWORD_REQUIRED_TEMPLATE` with deprecation of previous naming (Saksham Misra, LB (Ben) Johnston)
 * When editing settings (contrib) use the same icon in the editing view that was declared when registering the setting (Vince Salvino, Rohit Sharma)
 * Populate django-treebeard cache during page routing to improve performance of `get_parent` (Nigel van Keulen)
 * Add a new user profile preference to configure user interface information density (Thibaud Colas)
 * Add additional field types to Elasticsearch mapping (scott-8)
 * Fix: CVE-2024-32882: Permission check bypass when editing a model with per-field restrictions through `wagtail.contrib.settings` or `ModelViewSet` (Ben Morse, Joshua Munn, Jake Howard, Sage Abdullah)
 * Fix: Fix typo in `__str__` for MySQL search index (Jake Howard)
 * Fix: Ensure that unit tests correctly check for migrations in all core Wagtail apps (Matt Westcott)
 * Fix: Correctly handle `date` objects on `human_readable_date` template tag (Jhonatan Lopes)
 * Fix: Ensure re-ordering buttons work correctly when using a nested InlinePanel (Adrien Hamraoui)
 * Fix: Consistently remove model's `verbose_name` in group edit view when listing custom permissions (Sage Abdullah, Neeraj Yetheendran, Omkar Jadhav)
 * Fix: Resolve issue local development of docs when running `make livehtml` (Sage Abdullah)
 * Fix: Resolve issue with unwanted padding in chooser modal listings (Sage Abdullah)
 * Fix: Ensure form builder emails that have date or datetime fields correctly localize dates based on the configured `LANGUAGE_CODE` (Mark Niehues)
 * Fix: Ensure the Stimulus `UnsavedController` checks for nested removal/additions of inputs so that the unsaved warning shows in more valid cases when editing a page (Karthik Ayangar)
 * Fix: Ensure `get_add_url()` is always used to re-render the add button when the listing is refreshed in viewsets (Sage Abdullah)
 * Fix: Ensure dropdown content cannot get higher than the viewport and add scrolling within content if needed (Chiemezuo Akujobi)
 * Fix: Prevent snippets model index view from crashing when a model does not have an `objects` manager (Jhonatan Lopes)
 * Fix: Fix `get_dummy_request`'s resulting host name when running tests with `ALLOWED_HOSTS = ["*"]` (David Buxton)
 * Fix: Fix timezone handling in the `timesince_last_update` template tag (Matt Westcott)
 * Fix: Fix Postgres phrase search to respect the language set in settings (Ihar Marhitych)
 * Fix: Retain query parameters when switching between locales in the page chooser (Abdelrahman Hamada, Sage Abdullah)
 * Fix: Add `w-kbd-scope-value` with support for `global` so that specific keyboard shortcuts (e.g. ctrl+s/cmd+s) trigger consistently even when focused on fields (Neeraj Yetheendran)
 * Fix: Improve exception handling when generating image renditions concurrently (Andy Babic)
 * Fix: Respect `WAGTAIL_ALLOW_UNICODE_SLUGS` setting when auto-generating slugs (LB (Ben) Johnston)
 * Fix: Use correct URL when redirecting back to page search results after an AJAX search (Sage Abdullah)
 * Fix: Reinstate missing static files in style guide (Sage Abdullah)
 * Fix: Provide `convert_mariadb_uuids` management command to assist with upgrading to Django 5.0+ on MariaDB (Matt Westcott)
 * Fix: Ensure invalid submissions are marked as dirty edits on load to trigger UI and browser warnings for unsaved changes, restoring previous behavior from Wagtail 5.2 (Sage Abdullah)
 * Fix: Update polldaddy oEmbed provider to use the crowdsignal URL (Matthew Scouten)
 * Fix: Remove polleverywhere oEmbed provider as it this application longer supports oEmbed (Matthew Scouten)
 * Docs: Add contributing development documentation on how to work with a fork of Wagtail (Nix Asteri, Dan Braghis)
 * Docs: Make sure the settings panel is listed in tabbed interface examples (Tibor Leupold)
 * Docs: Update content and page names to their US spelling instead of UK spelling (Victoria Poromon)
 * Docs: Update broken and incorrect links throughout the documentation (EK303)
 * Docs: Fix formatting of `--purge-only` in `wagtail_update_image_renditions` management command section (Pranith Beeram)
 * Docs: Update template components documentation to better explain the usage of the Laces library (Tibor Leupold)
 * Docs: Update Sphinx theme to `6.3.0` with a fix for the missing favicon (Sage Abdullah)
 * Docs: Document risk of XSS attacks on document upload (Matt Westcott, with thanks to Georgios Roumeliotis of TwelveSec for the original report)
 * Docs: Add clarity to how custom StreamField validation works (Tibor Leupold)
 * Docs: Add additional reference to the `wagtail_update_image_renditions` management command on the using images page (LB (Ben) Johnston)
 * Docs: Correct information about line endings in Window development docs (Sage Abdullah)
 * Docs: Improve code snippets for "Create a footer for all pages" tutorial section (Drikus Roor)
 * Docs: Update list of third-party tutorials (LB (Ben) Johnston)
 * Docs: Update "Integrating into Django" documentation to emphasise creating page models (Matt Westcott)
 * Maintenance: Move RichText HTML whitelist parser to use the faster, built in `html.parser` (Jake Howard)
 * Maintenance: Remove duplicate 'path' in default_exclude_fields_in_copy (Ramchandra Shahi Thakuri)
 * Maintenance: Update unit tests to always use the faster, built in `html.parser` & remove `html5lib` dependency (Jake Howard)
 * Maintenance: Adjust Eslint rules for TypeScript files (Karthik Ayangar)
 * Maintenance: Rename the React `Button` that only renders links (a element) to `Link` and remove unused prop & behavior that was non-compliant for aria role usage (Advik Kabra)
 * Maintenance: Set up an `wagtail.models.AbstractWorkflow` model to support future customizations around workflows (Hossein)
 * Maintenance: Improve `classnames` template tag to handle nested lists of strings, use template tag for admin `body` element (LB (Ben) Johnston)
 * Maintenance: Merge `UploadedDocument` and `UploadedImage` into new `UploadedFile` model for easier shared code usage (Advik Kabra, Karl Hobley)
 * Maintenance: Optimize queries in dashboard panels (Sage Abdullah)
 * Maintenance: Optimize queries in group create/edit view (Sage Abdullah)
 * Maintenance: Move modal-workflow.js script usage to base admin template instead of ad-hoc imports (Elhussein Almasri)
 * Maintenance: Update all Draftail chooserUrls to be passed in via the Entity options instead of using `window.chooserUrls` globals, removing the need for inline scripts (Elhussein Almasri)
 * Maintenance: Enhance `w-init` (InitController) to support a `detail` value to be dispatched on events (Chiemezuo Akujobi)
 * Maintenance: Remove usage of inline scripts and instead use event dispatching to instantiate standalone Draftail editor instances (Chiemezuo Akujobi)
 * Maintenance: Refactor `page_breadcrumbs` tag to use shared `breadcrumbs.html` template (Sage Abdullah)
 * Maintenance: Add `keyboard` icon to admin icon set (Rohit Sharma)
 * Maintenance: Remove dead code in the minimap when elements are not found (LB (Ben) Johnston)
 * Maintenance: Ensure untrusted data sources are logged correctly in the Stimulus `SwapController` (LB (Ben) Johnston)
 * Maintenance: Update Wagtail logo in admin sidebar & favicon plus documentation to the latest version (Osaf AliSayed, Albina Starykova, LB (Ben) Johnston)
 * Maintenance: Remove usage of inline scripts and instead use a new Stimulus controller (`w-block`/`BlockController`) to instantiate `StreamField` blocks (Karthik Ayangar)
 * Maintenance: Update NPM Babel, TypeScript and Webpack packages (Neeraj Yetheendran)
 * Maintenance: Replace ad-hoc JavaScript and vendor Mousetrap usage to a new Stimulus controller (`w-kbd`/`KeyboardController`) (Neeraj Yetheendran)
 * Maintenance: Update django-filter to 24.x (Sebastian Muthwill)
 * Maintenance: Remove jQuery usage in telepath widget classes (Matt Westcott)
 * Maintenance: Remove `xregexp` (IE11 polyfill) along with `window.XRegExp` global util (LB (Ben) Johnston)
 * Maintenance: Refactor the Django port of `urlify` to use TypeScript, officially deprecate `window.URLify` global util (LB (Ben) Johnston)
 * Maintenance: Adopt the modern best practice for `beforeunload` usage in `UnsavedController` to trigger a leave page warning when edits have been made (Shubham Mukati, Sage Abdullah)


6.0.6 (11.07.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2024-39317: Regular expression denial-of-service via search query parsing (Jake Howard)


6.0.5 (30.05.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2024-35228: Improper handling of insufficient permissions in `wagtail.contrib.settings` (Victor Miti, Matt Westcott, Jake Howard)


6.0.4 (21.05.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Fix snippet copy view not prefilling form data (Sage Abdullah)


6.0.3 (01.05.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2024-32882: Permission check bypass when editing a model with per-field restrictions through `wagtail.contrib.settings` or `ModelViewSet` (Ben Morse, Joshua Munn, Jake Howard, Sage Abdullah)
 * Fix: Respect `WAGTAIL_ALLOW_UNICODE_SLUGS` setting when auto-generating slugs (LB (Ben) Johnston)
 * Fix: Use correct URL when redirecting back to page search results after an AJAX search (Sage Abdullah)
 * Fix: Reinstate missing static files in style guide (Sage Abdullah)
 * Fix: Provide `convert_mariadb_uuids` management command to assist with upgrading to Django 5.0+ on MariaDB (Matt Westcott)
 * Fix: Fix generic CopyView for models with primary keys that need to be quoted (Sage Abdullah)


6.0.2 (03.04.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Ensure that modal tabs width are not impacted by side panel opening (LB (Ben) Johnston)
 * Fix: Resolve issue local development of docs when running `make livehtml` (Sage Abdullah)
 * Fix: Resolve issue with unwanted padding in chooser modal listings (Sage Abdullah)
 * Fix: Ensure `get_add_url()` is always used to re-render the add button when the listing is refreshed in viewsets (Sage Abdullah)
 * Fix: Move `modal-workflow.js` script usage to base admin template instead of ad-hoc imports so that choosers work in `ModelViewSet`s (Elhussein Almasri)
 * Fix: Ensure JavaScript for common widgets such as `InlinePanel` is included by default in `ModelViewSet`'s create and edit views (Sage Abdullah)
 * Fix: Reinstate styles for customizations of `extra_footer_actions` block in page create/edit templates (LB (Ben) Johnston, Sage Abdullah)
 * Fix: Prevent crash when loading an empty table block in the editor (Sage Abdullah)
 * Docs: Update Sphinx theme to `6.3.0` with a fix for the missing favicon (Sage Abdullah)


6.0.1 (15.02.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Ensure `BooleanRadioSelect` uses the same styles as `RadioSelect` (Thibaud Colas)
 * Fix: Prevent failure on `collectstatic` when `ManifestStaticFilesStorage` is in use (Matt Westcott)
 * Fix: Prevent error on submitting an empty search in the admin under Elasticsearch (Maikel Martens)


6.0 (07.02.2024)
~~~~~~~~~~~~~~~~

 * Added support for Django 5.0
 * Implemented universal listings – a unified listing and filtering interface for Pages, Snippets, Forms (Ben Enright, Matt Westcott, Thibaud Colas, Sage Abdullah)
 * Add the accessibility checker within the page and snippets editor (Thibaud Colas)
 * Added `search_index` option to StreamField blocks to control whether the block is indexed for searching (Vedant Pandey)
 * Remember previous location on returning from page add/edit actions (Robert Rollins)
 * Update settings file in project settings to address Django 4.2 deprecations (Sage Abdullah)
 * Improve layout and accessibility of the image URL generator page, reduce reliance on JavaScript (Temidayo Azeez)
 * Allow `UniqueConstraint` in place of `unique_together` for `TranslatableMixin`'s system check (Temidayo Azeez, Sage Abdullah)
 * Make use of `IndexView.get_add_url()` in snippets index view template (Christer Jensen, Sage Abdullah)
 * Allow `Page.permissions_for_user()` to be overridden by specific page types (Sébastien Corbin)
 * Improve visual alignment of explore icon in Page listings for longer content (Krzysztof Jeziorny)
 * Add `extra_actions` blocks to Snippets and generic index templates (Bhuvnesh Sharma)
 * Added page types usage report (Jhonatan Lopes)
 * Add support for defining `panels` / `edit_handler` on `ModelViewSet` (Sage Abdullah)
 * Use a single instance of `PagePermissionPolicy` in `wagtail.permissions` module (Sage Abdullah)
 * Add max tag length validation for multiple uploads (documents/images) (Temidayo Azeez)
 * Ensure expanded side panel does not overlap form content for most viewports (Chiemezuo Akujobi)
 * Add ability to modify the default ordering for the page explorer view (Shlomo Markowitz)
 * Remove overly verbose image captions in image listings for screen readers (Sage Abdullah)
 * Ensure screen readers and dictation tools can more easily navigate bulk actions in images, documents and page listings by streamlining labels and descriptions (Sage Abdullah)
 * Remove support for Safari 14 (Thibaud Colas)
 * Add ability to click to copy the URL in the image URL generator page (Sai Srikar Dumpeti)
 * Add ability to filter by page type and date updated in the page listing view (Matt Westcott)
 * Add ability to filter by owner and site in the page listing view (Matt Westcott)
 * Improve right-to-left support by using flow-relative float styles (Thibaud Colas)
 * Improve right-to-left support by mirroring Wagtail icons as needed (Sage Abdullah)
 * Add support for mirroring third-party icons added in Wagtail (Sage Abdullah)
 * Show edit as a main action in generic history and usage views (Sage Abdullah)
 * Make styles for header buttons consistent (Sage Abdullah)
 * Improve styles of slim header's search and filters (Sage Abdullah)
 * Change page listing's add button to icon-only (Sage Abdullah)
 * Add sublabel to breadcrumbs, including history, usage, and inspect views (Sage Abdullah)
 * Standardise search form placeholder to 'Search…' (Sage Abdullah)
 * Use SlugInput on all SlugFields by default (LB (Ben) Johnston)
 * Show character counts on RichTextBlock with `max_length` (Elhussein Almasri)
 * Move locale selector in generic IndexView to a filter (Sage Abdullah)
 * Add ability to customize a page's copy form (Neeraj Yetheendran)
 * Add optional caption field to `TypedTableBlock` (Tommaso Amici, Cynthia Kiser)
 * Switch the `TableBlock` header controls to a field that requires user input (Bhuvnesh Sharma, Aman Pandey, Cynthia Kiser)
 * Add `WAGTAILADMIN_LOGIN_URL` setting to allow customizing the login URL (Neeraj Yetheendran)
 * Replace legacy dropdown component with new Tippy dropdown-button (Thibaud Colas)
 * Add ability to filter by existence of child pages in the page listing view (Matt Westcott)
 * Polish dark theme styles and update color tokens (Thibaud Colas, Rohit Sharma)
 * Keep database state of pages and snippets updated while in draft state (Stefan Hammer)
 * Add `DrilldownController` and `w-drilldown` component to support drilldown menus (Thibaud Colas)
 * Add support for `caption` on admin UI Table component (Aman Pandey)
 * Add API support for a redirects (contrib) endpoint (Rohit Sharma, Jaap Roes, Andreas Donig)
 * Add the default ability for all `SnippetViewSet` & `ModelViewSet` to support being copied (Shlomo Markowitz)
 * Support dynamic Wagtail guide links in the admin that are based on the running version of Wagtail (Tidiane Dia)
 * Added `AbstractGroupApprovalTask` to simplify customizing behavior of custom `Task` models (John-Scott Atlakson)
 * Fix: Update system check for overwriting storage backends to recognize the `STORAGES` setting introduced in Django 4.2 (phijma-leukeleu)
 * Fix: Prevent password change form from raising a validation error when browser autocomplete fills in the "Old password" field (Chiemezuo Akujobi)
 * Fix: Ensure that the legacy dropdown options, when closed, do not get accidentally clicked by other interactions on wide viewports (CheesyPhoenix, Christer Jensen)
 * Fix: Add a fallback background for the editing preview iframe for sites without a background (Ian Price)
 * Fix: Preserve whitespace in rendered comments (Elhussein Almasri)
 * Fix: Remove search logging from project template so that new projects without the search promotions module will not error (Matt Westcott)
 * Fix: Ensure text-only email notifications for updated comments do not escape HTML characters (Rohit Sharma)
 * Fix: Use the latest draft when copying an unpublished page for translation (Andrey Nehaychik)
 * Fix: Make Workflow and Aging Pages reports only available to users with page-related permissions (Rohit Sharma)
 * Fix: Make searching on specific fields work correctly on Elasticsearch when boost is in use (Matt Westcott)
 * Fix: Use a visible border and background color to highlight active formatting in the rich text toolbar (Cassidy Pittman)
 * Fix: Ensure image focal point box can be removed (Gunnar Scherf)
 * Fix: Ensure that Snippets search results correctly use the `index_results.html` or `index_results_template_name` override on initial load (Stefan Hammer)
 * Fix: Avoid error when attempting to moderate a page drafted by a now deleted user (Dan Braghis)
 * Fix: Do not show multiple error messages when editing a Site to use existing hostname and port (Rohit Sharma)
 * Fix: Avoid error when exporting Aging Pages report where a page has an empty `last_published_by_user` (Chiemezuo Akujobi)
 * Fix: Ensure Page querysets support using `alias` and `specific` (Tomasz Knapik)
 * Fix: Ensure workflow dashboard panels work when the page/snippet is missing (Sage Abdullah)
 * Fix: Ensure `ActionController` explicitly checks for elements that allow select functionality (Nandini Arora)
 * Fix: Prevent a ValueError with `FormSubmissionsPanel` on Django 5.0 when creating a new form page (Matt Westcott)
 * Fix: Avoid duplicate entries in "Recent edits" panel when copying pages (Matt Westcott)
 * Fix: Prevent TitleFieldPanel from raising an error when the slug field is missing or read-only (Rohit Sharma)
 * Fix: Ensure that the close button on the new dialog designs is visible in the non-message variant (Nandini Arora)
 * Fix: Ensure the sidebar account toggle has no duplicate accessible labels (Nandini Arora)
 * Fix: Avoid text overflow issues in comment replies and scroll position issues for long comments (Rohit Sharma)
 * Fix: Ensure that page listing re-ordering messages and accessible labels can be translated (Aman Pandey, LB (Ben) Johnston)
 * Fix: Resolve multiple issues with page listing re-ordering using keyboard and screen readers (Aman Pandey)
 * Fix: Remove 'Page' from page types filter on aging pages report (Matt Westcott)
 * Fix: Prevent page types filter from showing other non-Page models that match by name (Matt Westcott)
 * Fix: Ensure `MultipleChooserPanel` modal works correctly when `USE_THOUSAND_SEPARATOR` is `True` for pages with ids over 1,000 (Sankalp, Rohit Sharma)
 * Fix: When using an empty table header (`th`) for visual spacing, ensure this is ignored by accessibility tooling (V Rohitansh)
 * Fix: Ensure the panel anchor button sizes meet accessibility guidelines for minimum dimensions (Nandini Arora)
 * Fix: Raise a 404 for bulk actions for models that don't exist instead of throwing a 500 error (Alex Tomkins)
 * Fix: Raise a `SiteSetting.DoesNotExist` error when retrieving settings for an unrecognized site (Nick Smith)
 * Fix: Ensure that defaulted or unique values declared in `exclude_fields_in_copy` are correctly excluded in new copies, resolving to the default value (Elhussein Almasri)
 * Fix: Ensure that `default_ordering` set on IndexView is preserved if ModelViewSet does not specify an explicit ordering (Cynthia Kiser)
 * Fix: Ensure that TableBlock cells are accessible when using keyboard control only (Elhussein Almasri)
 * Fix: Resolve issue where clicking Publish for a Page that was in workflow in Safari would block publishing and not trigger the workflow confirmation modal (Alex Morega)
 * Fix: Fix pagination links on model history and usage views (Matt Westcott)
 * Fix: Fix crash when accessing workflow reports with a deleted snippet (Sage Abdullah)
 * Docs: New developer tutorial (Damilola Oladele, Meagen Voss, Thibaud Colas)
 * Docs: Document, for contributors, the use of translate string literals passed as arguments to tags and filters using `_()` within templates (Chiemezuo Akujobi)
 * Docs: Document all features for the Documents app in one location (Neeraj Yetheendran)
 * Docs: Add section to testing docs about creating pages and working with page content (Mariana Bedran Lesche)
 * Docs: Add more nuance to the database recommendations in performance page (Jadesola Kareem)
 * Docs: Add clarity that MultipleChooserPanel may require a chooser viewset and how the functionality is expected to work (Andy Chosak)
 * Docs: Clarify where documentation build commands should be run (Nikhil S Kalburgi)
 * Docs: Add missing import to tutorial BlogPage example (Salvo Polizzi)
 * Docs: Update contributing guide documentation and GitHub templates to better support new contributors (Thibaud Colas)
 * Docs: Add more CSS authoring guidelines (Thibaud Colas)
 * Docs: Update MyST documentation parser library to 2.0.0 (Neeraj Yetheendran)
 * Docs: Add documentation writing guidelines for intersphinx / external links (LB (Ben) Johnston)
 * Docs: Add `Page` model reference `get_children` documentation (Salvo Polizzi)
 * Docs: Enforce CI build checks for documentation so that malformed links or missing images will not be allowed (Neeraj Yetheendran)
 * Docs: Update spelling on customizing admin template and page model section from British to American English (Victoria Poromon)
 * Docs: Add documentation for how to override the file locations for custom image models via `get_upload_to` methods (Osaf AliSayed, Dharmik Gangani)
 * Docs: Update documentation theme (Sphinx Wagtail Theme) to 6.2.0, fixing the incorrect favicon (LB (Ben) Johnston, Sahil Jangra)
 * Docs: Refactor promotion banner without jQuery and use sameSite cookies when storing if cleared (LB (Ben) Johnston)
 * Docs: Use cross-reference for compatible Python versions in tutorial instead of the out-of-date listing (mirusu400)
 * Maintenance: Update BeautifulSoup upper bound to 4.12.x (scott-8)
 * Maintenance: Migrate initialization of classes (such as `body.ready`) from multiple JavaScript implementations to one Stimulus controller `w-init` (Chiemezuo Akujobi)
 * Maintenance: Adopt the usage of translate string literals using `arg=_('...')` in all `wagtailadmin` module templates (Chiemezuo Akujobi)
 * Maintenance: Migrate the contrib styleguide index view to a class-based view (Chiemezuo Akujobi)
 * Maintenance: Update djhtml to 3.0.6 (Matt Westcott)
 * Maintenance: Migrate the contrib settings edit view to a class-based view (Chiemezuo Akujobi, Sage Abdullah)
 * Maintenance: Remove django-pattern-library upper bound in testing dependencies (Sage Abdullah)
 * Maintenance: Split up functions in Elasticsearch backend for easier extensibility (Marcel Kornblum, Cameron Lamb, Sam Dudley)
 * Maintenance: Relax draftjs_exporter dependency to allow using version 5.x (Sylvain Fankhauser)
 * Maintenance: Refine styling of listings, account settings panels and the block chooser (Meli Imelda)
 * Maintenance: Remove icon font support (Matt Westcott)
 * Maintenance: Remove deprecated SVG icons (Matt Westcott)
 * Maintenance: Remove icon font styles (Thibaud Colas)
 * Maintenance: Migrate account editing view to a class-based view (Kehinde Bobade)
 * Maintenance: Upgrade frontend tooling to use Node 20 (LB (Ben) Johnston)
 * Maintenance: Upgrade `ruff` and replace `black` with `ruff format` (John-Scott Atlakson)
 * Maintenance: Update Willow upper bound to 2.x (Dan Braghis)
 * Maintenance: Removed support for Django < 4.2 (Dan Braghis)
 * Maintenance: Refactor page explorer index template to extend generic index template (Sage Abdullah)
 * Maintenance: Replace template components implementation with standalone `laces` library (Tibor Leupold)
 * Maintenance: Refactor snippets index view and template to make better use of generic IndexView (Sage Abdullah)
 * Maintenance: Introduce an internal `{% formattedfield %}` tag to replace direct use of `wagtailadmin/shared/field.html` (Matt Westcott)
 * Maintenance: Update Telepath dependency to 0.3.1 (Matt Westcott)
 * Maintenance: Allow `ActionController` to have a `noop` method to more easily leverage standalone Stimulus action options (Nandini Arora)
 * Maintenance: Upgrade to latest TypeScript and Storybook (Thibaud Colas, Sage Abdullah)
 * Maintenance: Turn on `skipLibCheck` for TypeScript (LB (Ben) Johnston)
 * Maintenance: Refactor documents listing view to use generic IndexView (Sage Abdullah)
 * Maintenance: Support for the Stimulus `CloneController` to auto clear the added content after a set duration (LB (Ben) Johnston)
 * Maintenance: Refactor images listing view to use generic IndexView (Sage Abdullah)
 * Maintenance: Refactor form pages listing view to use generic IndexView (Sage Abdullah)
 * Maintenance: Update Stylelint, our linting configuration, Sass, and related code changes (LB (Ben) Johnston)
 * Maintenance: Simplify browserslist and browser support documentation (Thibaud Colas)
 * Maintenance: Relax django-taggit dependency to allow 5.0 (Sylvain Fankhauser)
 * Maintenance: Fix various warnings when building docs (Cynthia Kiser)
 * Maintenance: Upgrade sphinxcontrib-spelling to 7.x for Python 3.12 compatibility (Matt Westcott)
 * Maintenance: Move logic for django-filters filtering into `BaseListingView` (Matt Westcott)
 * Maintenance: Remove or replace legacy CSS classes: visuallyhidden, visuallyvisible, divider-after, divider-before, inline, inline-block, block, u-hidden, clearfix, reordering, overflow (Thibaud Colas)
 * Maintenance: Prevent future issues with icon.html end-of-file newlines (Thibaud Colas)
 * Maintenance: Rewrite styles using legacy `c-`, `o-`, `u-`, `t-`, `is-` prefixes (Thibaud Colas)
 * Maintenance: Remove invalid CSS styles / Sass selector concatenation (Thibaud Colas)
 * Maintenance: Refactor listing views to share more queryset ordering logic (Matt Westcott)
 * Maintenance: Remove `initTooltips` in favor of Stimulus controller (LB (Ben) Johnston)
 * Maintenance: Enhance the Stimulus `InitController` to allow for custom event dispatching when ready (Aditya, LB (Ben) Johnston)
 * Maintenance: Remove inline script usage for comment initialization and adopt an event listener/dispatch approach for better CSP compliance (Aditya, LB (Ben) Johnston)
 * Maintenance: Migrate styleguide ad-hoc JavaScript to use styles only to avoid CSP issues (LB (Ben) Johnston)
 * Maintenance: Update Jest version - frontend tooling (Nandini Arora)
 * Maintenance: Remove non-functional and inaccessible auto-focus on first field in page create forms (LB (Ben) Johnston)
 * Maintenance: Migrate the unsaved form checks & confirmation trigger to Stimulus `UnsavedController` (Sai Srikar Dumpeti, LB (Ben) Johnston)
 * Maintenance: Reduce gap between snippets and generic views/templates (Sage Abdullah)
 * Maintenance: Migrate page listing menu re-ordering (drag & drop) from jQuery inline scripts to `OrderableController` with a more accessible solution (Aman Pandey, LB (Ben) Johnston)
 * Maintenance: Clean up scss variable usage, remove unused variables and mixins, adopt more core token variables (Jai Vignesh J, Nandini Arora, LB (Ben) Johnston)
 * Maintenance: Migrate Image URL generator views to class-based views (Rohit Sharma)
 * Maintenance: Use Django's `FileResponse` when serving files such as Images or Documents (Jake Howard)
 * Maintenance: Deprecated `WidgetWithScript` base widget class (LB (Ben) Johnston)
 * Maintenance: Remove support for Django 4.1 and below (Sage Abdullah)


5.2.8 (03.02.2025)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent database error when calling permission_order.register on app ready (Daniel Kirkham, Matt Westcott)
 * Fix: Handle StreamField migrations where the field value is null (Joshua Munn)
 * Fix: Prevent `StreamChildrenToListBlockOperation` from duplicating data across multiple StreamField instances (Joshua Munn)
 * Fix: Prevent error on lazily loading StreamField blocks after the stream has been modified (Stefan Hammer)
 * Fix: Prevent syntax error on MySQL search when query includes symbols (Matt Westcott)


5.2.7 (01.11.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent multiple URLs from being combined into one when pasting links into a rich text input (Thibaud Colas)
 * Fix: Fix error on workflow settings view with multiple snippet types assigned to the same workflow on Postgres (Sage Abdullah)


5.2.6 (11.07.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2024-39317: Regular expression denial-of-service via search query parsing (Jake Howard)
 * Fix: Fix image preview when Willow optimizers are enabled (Alex Tomkins)
 * Maintenance: Remove django-pattern-library upper bound in testing dependencies (Sage Abdullah)


5.2.5 (01.05.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Respect `WAGTAIL_ALLOW_UNICODE_SLUGS` setting when auto-generating slugs (LB (Ben) Johnston)
 * Fix: Use correct URL when redirecting back to page search results after an AJAX search (Sage Abdullah)
 * Fix: Provide `convert_mariadb_uuids` management command to assist with upgrading to Django 5.0+ on MariaDB (Matt Westcott)


5.2.4 (03.04.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent TitleFieldPanel from raising an error when the slug field is missing or read-only (Rohit Sharma)
 * Fix: Fix pagination links on model history and usage views (Matt Westcott)
 * Fix: Fix crash when accessing workflow reports with a deleted snippet (Sage Abdullah)
 * Fix: Prevent error on submitting an empty search in the admin under Elasticsearch (Maikel Martens)


5.2.3 (23.01.2024)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent a ValueError with `FormSubmissionsPanel` on Django 5.0 when creating a new form page (Matt Westcott)
 * Fix: Specify telepath 0.3.1 as the minimum supported version, for Django 5.0 compatibility (Matt Westcott)


5.2.2 (06.12.2023)
~~~~~~~~~~~~~~~~~~

 * Added support for Django 5.0
 * Fix: Use a visible border and background color to highlight active formatting in the rich text toolbar (Cassidy Pittman)
 * Fix: Ensure image focal point box can be removed (Gunnar Scherf)
 * Fix: Ensure that Snippets search results correctly use the `index_results.html` or `index_results_template_name` override on initial load (Stefan Hammer)
 * Fix: Avoid error when attempting to moderate a page drafted by a now deleted user (Dan Braghis)
 * Fix: Ensure workflow dashboard panels work when the page/snippet is missing (Sage Abdullah)
 * Fix: Prevent custom controls from stacking on top of the comment button in Draftail toolbar (Ben Morse)


5.2.1 (16.11.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: Add a fallback background for the editing preview iframe for sites without a background (Ian Price)
 * Fix: Remove search logging from project template so that new projects without the search promotions module will not error (Matt Westcott)
 * Fix: Ensure text only email notifications for updated comments do not escape HTML characters (Rohit Sharma)
 * Fix: Use logical OR operator to combine search fields for Django ORM in generic IndexView (Varun Kumar)
 * Fix: Ensure that explorer_results views fill in the correct next_url parameter on action URLs (Matt Westcott)
 * Fix: Fix crash when accessing the history view for a translatable snippet (Sage Abdullah)
 * Fix: Prevent upload of SVG images from failing when image feature detection is enabled (Joshua Munn)
 * Fix: Fix crash when using the locale switcher on the snippets create view (Sage Abdullah)
 * Fix: Fix performance regression on reports from calling `decorate_paginated_queryset` before pagination / filtering (Alex Tomkins)
 * Fix: Make searching on specific fields work correctly on Elasticsearch when boost is in use (Matt Westcott)
 * Fix: Prevent snippet permission post-migrate hook from failing on multiple database configurations (Joe Tsoi)
 * Fix: Reinstate ability to filter on page type when searching on an empty query (Sage Abdullah)
 * Fix: Prevent error on locked pages report when a user has locked multiple pages (Matt Westcott)
 * Docs: Fix code example for `{% picture ... as ... %}` template tag (Rezyapkin)


5.2 LTS (01.11.2023)
~~~~~~~~~~~~~~~~~~~~

 * Redesigned page listing view (Ben Enright, Matt Westcott, Thibaud Colas, Sage Abdullah)
 * Support OpenSearch as an alternative to Elasticsearch (Matt Westcott)
 * Add support for Python 3.12 (Matt Westcott)
 * Add preview-aware and page-aware fragment caching template tags, `wagtailcache` & `wagtailpagecache` (Jake Howard)
 * Always set help text element ID for form fields with help text in `field.html` template (Sage Abdullah)
 * Move `SnippetViewSet` menu registration mechanism to base `ViewSet` class (Sage Abdullah)
 * Enable reference index tracking for models registered with `ModelViewSet` (Sage Abdullah)
 * When copying a page or creating an alias, copy its view restrictions to the destination (Sandeep Choudhary, Suyash Singh)
 * Support pickling of StreamField values (pySilver)
 * Move `SnippetViewSet` template override mechanism to `ModelViewSet` (Sage Abdullah)
 * Move `SnippetViewSet.list_display` to `ModelViewSet` (Sage Abdullah)
 * Remove `wagtail.publish` log action on aliases when they are created from live source pages or the source page is published (Dan Braghis)
 * Remove `wagtail.unpublish` log action on aliases when source page is unpublished (Dan Braghis)
 * Add compare buttons to workflow dashboard panel (Matt Westcott)
 * Add the ability to use filters and to export listings in generic `IndexView` (Sage Abdullah)
 * Move `list_filter`, `filterset_class`, `search_fields`, `search_backend_name`, `list_export`, `export_filename`, `list_per_page`, and `ordering` from `SnippetViewSet` to `ModelViewSet` (Sage Abdullah, Cynthia Kiser)
 * Add default header titles to generic `IndexView` and `CreateView` (Sage Abdullah)
 * Allow overriding `IndexView.export_headings` via `ModelViewSet` (Christer Jensen, Sage Abdullah)
 * Support specifying a `get_object_list` method on `ChooserViewSet` (Matt Westcott)
 * Add `linked_fields` mechanism on chooser widgets to allow choices to be limited by fields on the calling page (Matt Westcott)
 * Add support for merging cells within `TableBlock` with the `mergedCells` option (Gareth Palmer)
 * When adding a panel within `InlinePanel`, focus will now shift to that content similar to `StreamField` (Faishal Manzar)
 * Show the full first published at date within a tooltip on the Page status sidebar on the relative date (Rohit Sharma)
 * Extract generic breadcrumbs functionality from page breadcrumbs (Sage Abdullah)
 * Add support for `placement` in the `human_readable_date` tooltip template tag (Rohit Sharma)
 * Add breadcrumbs support to custom `ModelViewSet` views (Sage Abdullah)
 * Support passing extra context variables via the `{% component %}` tag (Matt Westcott)
 * Allow subclasses of `PagesAPIViewSet` override default Page model via the `model` attribute (Neeraj Yetheendran, Herbert Poul)
 * Allow `ModelViewSet` to be used with models that have non-integer primary keys (Sage Abdullah)
 * Add the ability to set an external link/text for promoted search result entries (TopDevPros, Brad Busenius)
 * Add support for subject and body in the Email link chooser form (TopDevPros, Alexandre Joly)
 * Extract generic `HistoryView` from snippets and add it to `ModelViewSet` (Sage Abdullah)
 * Add generic `UsageView` to `ModelViewSet` (Sage Abdullah)
 * Add the ability to define listing buttons on generic `IndexView` (Sage Abdullah)
 * Add a visual progress bar to the output of the `wagtail_update_image_renditions` management command (Faishal Manzar)
 * Increase the read buffer size to improve efficiency and performance when generating file hashes for document or image uploads, use `hashlib.file_digest` if available (Python 3.11+) (Jake Howard)
 * API ordering now supports multiple fields (Rohit Sharma, Jake Howard)
 * Pass block value to `Block.get_template` to allow varying template based on value (Florian Delizy)
 * Add `InlinePanel` DOM events for when ready and when items added or removed (Faishal Manzar)
 * Add a new `picture` template tag for Django Templates and Jinja (Thibaud Colas)
 * Add a new `srcset_image` template tag for Django Templates and Jinja (Thibaud Colas)
 * Support `Filter` instances as input for `AbstractImage.get_renditions()` (Thibaud Colas)
 * Improve error messages for image template tags (Thibaud Colas)
 * Do not render minimap if there are no panel anchors (Sage Abdullah)
 * Use dropdown buttons on listings in dashboard panels (Sage Abdullah)
 * Implement breadcrumbs design refinements (Thibaud Colas)
 * Support extending Wagtail client-side with Stimulus (LB (Ben) Johnston)
 * Update all `FieldPanel('title')` examples to use the recommended `TitleFieldPanel('title')` panel (Chinedu Ihedioha)
 * The `purge_revisions` management command now respects revisions that have a `on_delete=PROTECT` foreign key relation and won't delete them (Neeraj P Yetheendran, Meghana Reddy, Sage Abdullah, Storm Heg)
 * Add support for Shift + Click behavior in form submissions and simple translations submissions (LB (Ben) Johnston)
 * Improve filtering of audit logging based on the user's permissions (Stefan Hammer)
 * Fix: Ensure that StreamField's `FieldBlock`s correctly set the `required` and `aria-describedby` attributes (Storm Heg)
 * Fix: Avoid an error when the moderation panel (admin dashboard) contains both snippets and private pages (Matt Westcott)
 * Fix: When deleting collections, ensure the collection name is correctly shown in the success message (LB (Ben) Johnston)
 * Fix: Filter out comments on Page editing counts that do not correspond to a valid field / block path on the page such as when a field has been removed (Matt Westcott)
 * Fix: Allow `PublishMenuItem` to more easily support overriding its label via `construct_page_action_menu` (Sébastien Corbin)
 * Fix: Allow locale selection when creating a page at the root level (Sage Abdullah)
 * Fix: Ensure the admin login template correctly displays all `non_fields_errors` for any custom form validation (Sébastien Corbin)
 * Fix: Ensure 'mark as active' label in workflow bulk action set active form can be translated (Rohit Sharma)
 * Fix: Ensure the panel title for a user's settings correctly reflects the `WAGTAIL_EMAIL_MANAGEMENT_ENABLED` setting by not showing 'email' if disabled (Omkar Jadhav)
 * Fix: Update Spotify oEmbed provider URL parsing to resolve correctly (Dhrűv)
 * Fix: Update link colors within help blocks to meet accessible contrast requirements (Rohit Sharma)
 * Fix: Ensure the search promotions popular search terms picker correctly refers to the correct model (LB (Ben) Johnston)
 * Fix: Correctly quote non-numeric primary keys on snippet inspect view (Sage Abdullah)
 * Fix: Prevent crash on snippet inspect view when displaying a null foreign key to an image (Sage Abdullah)
 * Fix: Ensure that pages in moderation show as "Live + In Moderation" in the page explorer rather than "Live + Draft" (Sage Abdullah)
 * Fix: Prevent error when updating reference index for objects with a lazy ParentalKey-related object (Chris Shaw)
 * Fix: Ignore conflicts when inserting reference index entries to prevent race conditions causing uniqueness errors (Chris Shaw)
 * Fix: Populate the correct return value when creating a new snippet within the snippet chooser (claudobahn)
 * Fix: Reinstate missing filter by page type on page search (Matt Westcott)
 * Fix: Ensure very long words can wrap when viewing saved comments (Chiemezuo Akujobi)
 * Fix: Avoid forgotten password link text conflicting with the supplied aria-label (Thibaud Colas)
 * Fix: Fix log message to record the correct restriction type when removing a page view restriction (Rohit Sharma, Hazh. M. Adam)
 * Fix: Avoid potential race condition with new Page subscriptions on the edit view (Alex Tomkins)
 * Fix: Use the correct action log when creating a redirect (Thibaud Colas)
 * Fix: Ensure that all password fields consistently allow leading & trailing whitespace (Neeraj P Yetheendran)
 * Docs: Expand documentation on using `ViewSet` and `ModelViewSet` (Sage Abdullah)
 * Docs: Document `WAGTAILADMIN_BASE_URL` on "Integrating Wagtail into a Django project" page (Shreshth Srivastava)
 * Docs: Replace incorrect screenshot for authors listing on tutorial (Shreshth Srivastava)
 * Docs: Add documentation for building non-model-based choosers using the _queryish_ library (Matt Westcott)
 * Docs: Fix incorrect tag library import on focal points example (Hatim Makki Hoho)
 * Docs: Add reminder about including your custom Draftail feature in any overridden `WAGTAILADMIN_RICH_TEXT_EDITORS` setting (Charlie Sue)
 * Docs: Mention the need to install `python3-venv` on Ubuntu (Brian Mugo)
 * Docs: Document the use of the Google developer documentation style guide in documentation (Damilola Oladele)
 * Docs: Fix Inconsistent URL Format in Getting Started tutorial (Olumide Micheal)
 * Maintenance: Fix snippet search test to work on non-fallback database backends (Matt Westcott)
 * Maintenance: Update Eslint, Prettier, Jest, a11y-dialog, axe-core and js-cookie npm packages (LB (Ben) Johnston)
 * Maintenance: Add npm scripts for TypeScript checks and formatting SCSS files (LB (Ben) Johnston)
 * Maintenance: Run tests in parallel in some of the CI setup (Sage Abdullah)
 * Maintenance: Remove unused WorkflowStatus view, urlpattern, and workflow-status.js (Storm Heg)
 * Maintenance: Add support for options/attrs in Telepath widgets so that attrs render on the created DOM (Storm Heg)
 * Maintenance: Update pre-commit hooks to be in sync with latest changes to Eslint & Prettier for client-side changes (Storm Heg)
 * Maintenance: Add `WagtailTestUtils.get_soup()` method for testing HTML content (Storm Heg, Sage Abdullah)
 * Maintenance: Allow `ViewSet` subclasses to customize `url_prefix` and `url_namespace` logic (Matt Westcott)
 * Maintenance: Simplify `SnippetViewSet` registration code (Sage Abdullah)
 * Maintenance: Rename groups `IndexView.results_template_name` to `results.html` (Sage Abdullah)
 * Maintenance: Migrate form submission listing checkbox toggling to the shared `w-bulk` Stimulus implementation (LB (Ben) Johnston)
 * Maintenance: Allow viewsets to define a common set of view kwargs (Matt Westcott)
 * Maintenance: Migrate the editor unsaved messages popup to be driven by Stimulus using the shared `w-message` controller (LB (Ben) Johnston, Hussain Saherwala)
 * Maintenance: Do not use jest inside `stubs.js` to prevent Storybook from crashing (LB (Ben) Johnston)
 * Maintenance: Refactor snippets templates to reuse the shared `slim_header.html` template (Sage Abdullah)
 * Maintenance: Refactor `slim_header.html` template to reduce code duplication (Sage Abdullah)
 * Maintenance: Upgrade Willow to v1.6.2 to support MIME type data without reliance on `imghdr` (Jake Howard)
 * Maintenance: Replace `imghdr` with Willow's built-in MIME type detection (Jake Howard)
 * Maintenance: Migrate all other `data-tippy` HTML attribute usage to the Stimulus data-*-value attributes for w-tooltip & w-dropdown (Subhajit Ghosh, LB (Ben) Johnston)
 * Maintenance: Replace `@total_ordering` usage with comparison functions implementation (Virag Jain)
 * Maintenance: Replace `<script type="text/django-form-template"><-/script>` template approach with HTML `template` elements in InlinePanel and expanding formset (Mansi Gundre, Subhajit Ghosh, LB (Ben) Johnston)
 * Maintenance: Refactor side panels code for better reuse in pages and snippets (Sage Abdullah)
 * Maintenance: Deprecate legacy URL redirects in `ModelViewSet` and `SnippetViewSet` (Sage Abdullah)
 * Maintenance: Simplify code for registering page listing action buttons (Matt Westcott)
 * Maintenance: Removed the unused, legacy, Wagtail userbar views set up for an old iframe approach (Sage Abdullah)
 * Maintenance: Optimize `lru_cache` usage (Jake Howard)
 * Maintenance: Implement `date_since` in `get_most_popular` inside `search_promotions.models.Query` (TopDevPros)
 * Maintenance: Refactor generic view subclasses to better reuse the generic templates and breadcrumbs (Sage Abdullah)
 * Maintenance: Adopt consistent `classname` (not `classnames`) attributes for all `MenuItem` usage, including deprecation warnings (LB (Ben) Johnston)
 * Maintenance: Adopt consistent `classname` (not `classnames`) attribute within the `wagtail.images.formats.Format` instance, including deprecation warnings (LB (Ben) Johnston)
 * Maintenance: Deprecate `context` argument of `construct_snippet_listing_buttons` hook (Sage Abdullah)
 * Maintenance: Deprecate legacy moderation system (Sage Abdullah)
 * Maintenance: Update CI database versions (Jake Howard)
 * Maintenance: Add changelog and issue tracker links to the PyPI project page (Panagiotis H.M. Issaris)
 * Maintenance: Add better deprecation warnings to the `search.Query` & `search.QueryDailyHits` model, move final set of templates from the admin search module to the search promotions contrib module (LB (Ben) Johnston)
 * Maintenance: Add generic `InspectView` to `ModelViewSet` (Sage Abdullah)
 * Maintenance: Migrate select all on focus/click behavior to Stimulus, used on the image URL generator (Chiemezuo Akujobi)
 * Maintenance: Add support for a `reset` method to support Stimulus driven dynamic field resets via the `w-action` controller (Chiemezuo Akujobi)
 * Maintenance: Add support for a `notify` target on the Stimulus dialog for dispatching events internally (Chiemezuo Akujobi)
 * Maintenance: Migrate publishing schedule dialog field resets to Stimulus (Chiemezuo Akujobi)

5.1.3 (19.10.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2023-45809: Disclosure of user names via admin bulk action views (Matt Westcott)
 * Fix: Fix `SnippetBulkAction` not respecting `models` definition (Sandro Rodrigues)
 * Fix: Correctly quote non-numeric primary keys on snippet inspect view (Sage Abdullah)
 * Fix: Prevent crash on snippet inspect view when displaying a null foreign key to an image (Sage Abdullah)
 * Fix: Populate the correct return value when creating a new snippet within the snippet chooser (claudobahn)
 * Fix: Reinstate missing filter by page type on page search (Matt Westcott)
 * Fix: Use the correct action log when creating a redirect (Thibaud Colas)


5.1.2 (25.09.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: Avoid use of `ignore_conflicts` when creating extra permissions for snippets, for SQL Server compatibility (Sage Abdullah)
 * Fix: Ensure sequence on `wagtailsearchpromotions_query` table is correctly set after migrating data (Jake Howard)
 * Fix: Change spreadsheet export headings to match listing view column headings (Christer Jensen, Sage Abdullah)
 * Fix: Fix numbers, booleans, and `None` from being exported as strings (Christer Jensen)
 * Fix: Restore fallback on full-word search for snippet choosers and generic index views (Matt Westcott)
 * Fix: Restore compatibility with pre-7.15 versions of the Elasticsearch Python library, allowing use of Opensearch (Matt Westcott)
 * Fix: Fix error when pickling BaseSiteSetting instances (Matt Westcott)
 * Maintenance: For Python 3.13 support - upgrade Willow to v1.6.2, replace `imghdr` with Willow's built-in MIME type detection (Jake Howard)


5.1.1 (14.08.2023)
~~~~~~~~~~~~~~~~~~

 * Introduce `wagtail.admin.ui.tables.BooleanColumn` to display boolean values as icons (Sage Abdullah)
 * Fix: Show not-`None` falsy values instead of blank in generic table cell template (Sage Abdullah)
 * Fix: Fix `read_only` panels for fields with translatable choice labels (Florent Lebreton)


5.1 (01.08.2023)
~~~~~~~~~~~~~~~~

 * Add support for read-only FieldPanels (Andy Babic)
 * Add support for query-time boosting to Elasticsearch 6 and above (Shohan Dutta Roy)
 * Add support for Elasticsearch 8 (Matt Westcott, Wesley van Lee)
 * Mark calls to `md5` as not being used for secure purposes, to avoid flagging on FIPS-mode systems (Sean Kelly)
 * Return filters from `parse_query_string` as a `QueryDict` to support multiple values (Aman Pandey)
 * Explicitly specify `MenuItem.name` for all admin menu and submenu items (Justin Koestinger)
 * Add oEmbed provider patterns for YouTube Shorts and YouTube Live URLs (valnuro, Fabien Le Frapper)
 * Add initial implementation of `PagePermissionPolicy` (Sage Abdullah)
 * Refactor `UserPagePermissionsProxy` and `PagePermissionTester` to use `PagePermissionPolicy` (Sage Abdullah, Tidiane Dia)
 * Add a predictable default ordering of the "Object/Other permissions" in the Group Editing view, allow this ordering to be customized (Daniel Kirkham)
 * Add `AbstractImage.get_renditions()` for efficient generation of multiple renditions (Andy Babic)
 * Optimise queries in collection permission policies using cache on the user object (Sage Abdullah)
 * Phone numbers entered via a link chooser will now have any spaces stripped out, ensuring a valid href="tel:..." attribute (Sahil Jangra)
 * Auto-select the `StreamField` block when only one block type is declared (Sébastien Corbin)
 * Add support for more advanced Draftail customization APIs (Thibaud Colas)
 * Add the ability to export snippets listing via `SnippetViewSet.list_export` (Sage Abdullah)
 * Add support for adding HTML `attrs` on `FieldPanel`, `FieldRowPanel`, `MultiFieldPanel`, and others (Aman Pandey, Antoni Martyniuk, LB (Ben) Johnston)
 * Add support for `--template` option to `wagtail start` (Thibaud Colas)
 * Change to always cache renditions (Jake Howard)
 * Update link/document rich text tooltips for consistency with the inline toolbar (Albina Starykova)
 * Increase the contrast between the rich text / StreamField block picker and the page in dark mode (Albina Starykova)
 * Purge revisions of non-page models in `purge_revisions` command (Sage Abdullah)
 * Add support for AVIF images (Aman Pandey)
 * Change the default WebP quality to 80 to match AVIF (Aman Pandey)
 * Adopt optimized Wagtail logo in the admin interface (Albina Starykova)
 * Add support for presenting the userbar (Wagtail button) in dark mode (Albina Starykova)
 * Add Inspect view to snippets (Sage Abdullah)
 * Fix: Prevent choosers from failing when initial value is an unrecognized ID, e.g. when moving a page from a location where `parent_page_types` would disallow it (Dan Braghis)
 * Fix: Move comment notifications toggle to the comments side panel (Sage Abdullah)
 * Fix: Remove comment button on InlinePanel fields (Sage Abdullah)
 * Fix: Fix missing link to `UsageView` from `EditView` for snippets (Christer Jensen)
 * Fix: Prevent lowercase conversions of IndexView column headers (Virag Jain)
 * Fix: Ensure that `RichText` objects with the same values compare as equal (NikilTn)
 * Fix: Use `gettext_lazy` on generic model views so that language settings are correctly used (Matt Westcott)
 * Fix: Prevent JS error when reverting the spinner on a submit button after a validation error (LB (Ben) Johnston)
 * Fix: Prevent crash when comparing page revisions that include `MultipleChooserPanel` (Matt Westcott)
 * Fix: Ensure that title and slug continue syncing after entering non-URL-safe characters (LB (Ben) Johnston)
 * Fix: Ensure that title and slug are synced on keypress, not just on blur (LB (Ben) Johnston)
 * Fix: Add a more visible active state for side panel toggle buttons (Thibaud Colas)
 * Fix: Debounce and optimise live preview panel to prevent excessive requests (Sage Abdullah)
 * Fix: Use constant-time comparison for image serve URL signatures (Jake Howard)
 * Fix: Ensure taggit field type-ahead options show correctly in the dark mode theme (Sage Abdullah)
 * Fix: Fix the lock description message missing the model_name variable when locked only by system (Sébastien Corbin)
 * Fix: Fix empty blocks created in migration operations (Sandil Ranasinghe)
 * Fix: Ensure that gettext_lazy works correctly when using verbose_name on a generic Settings models (Sébastien Corbin)
 * Fix: Remove unnecessary usage of `innerHTML` when modifying DOM content (LB (Ben) Johnston)
 * Fix: Avoid `ValueError` when extending `PagesAPIViewSet` and setting `meta_fields` to an empty list (Henry Harutyunyan, Alex Morega)
 * Fix: Improve accessibility for header search, remove autofocus on page load, advise screen readers that content has changed when results update (LB (Ben) Johnston)
 * Fix: Fix incorrect override of `PagePermissionHelper.user_can_unpublish_obj()` in ModelAdmin (Sébastien Corbin)
 * Fix: Prevent memory exhaustion when updating a large number of image renditions (Jake Howard)
 * Fix: Add missing Time Zone conversions and date formatting throughout the admin (Stefan Hammer)
 * Fix: Ensure that audit logs and revisions consistently use UTC and add migration for existing entries (Stefan Hammer)
 * Fix: Make sure "critical" buttons have enough color contrast in dark mode (Albina Starykova)
 * Fix: Improve visibility of scheduled publishing errors in status side panel (Sage Abdullah)
 * Fix: Prevent 'choose' permission from being ignored when looking up 'choose', 'edit' and 'delete' permissions in combination (Sage Abdullah)
 * Fix: Take user's permissions into account for image / document counts on the admin dashboard (Sage Abdullah)
 * Fix: Avoid N+1 queries in users index view (Tidiane Dia)
 * Fix: Use a theme-agnostic color token for read-only panels support in dark mode (Thibaud Colas)
 * Fix: Ensure collapsible StreamBlocks expand as necessary to show validation errors (Storm Heg)
 * Fix: Ensure userbar dialog can sit above other website content (LB (Ben) Johnston)
 * Fix: Fix preview panel loading issues (Sage Abdullah)
 * Fix: Fix `search_promotions` `0004_copy_queries` migration for long-lived Wagtail instances (Sage Abdullah)
 * Fix: Guard against `TypeError` in `0088_fix_log_entry_json_timestamps` migration (Sage Abdullah)
 * Fix: Add migration to replace JSON null values with empty objects in log entries' data (Sage Abdullah)
 * Fix: Typo in the `page_header_buttons` template tag when accessing the context's request object (Robert Rollins)
 * Fix: Ensure `ActionController` explicitly checks for elements that allow select functionality (Nandini Arora)
 * Docs: Document how to add non-ModelAdmin views to a `ModelAdminGroup` (Onno Timmerman)
 * Docs: Document how to add StructBlock data to a StreamField (Ramon Wenger)
 * Docs: Update ReadTheDocs settings to v2 to resolve urllib3 issue in linkcheck extension (Thibaud Colas)
 * Docs: Update documentation for `log_action` parameter on `RevisionMixin.save_revision` (Christer Jensen)
 * Docs: Reorganise snippets documentation to cover customizations and optional features (Sage Abdullah)
 * Docs: Update color customizations guidance to include theme-agnostic options (Thibaud Colas)
 * Docs: Mark LTS releases in release note page titles (Thiago C. S. Tioma)
 * Docs: Revise main Getting started tutorial for clarity (Kevin Chung (kev-odin))
 * Docs: Revamp the start of the getting started section, with separate quick install page (Damilola Oladele)
 * Docs: Move the tutorial’s snippets section to come before tags (Damilola Oladele)
 * Docs: Rewrite the getting started tutorial to address identified friction points (Damilola Oladele)
 * Docs: Switch the Getting started tutorial’s snippets example to be more understandable (Damilola Oladele)
 * Docs: Update the deployment documentation page and remove outdated information (Jake Howard)
 * Docs: Add more items to performance page regarding pre-fetching images and frontend caching (Jake Howard)
 * Docs: Add docs for managing stored queries in `searchpromotions` (Scott Foster)
 * Docs: Add docs for migrating from ModelAdmin to Snippets (Sage Abdullah)
 * Maintenance: Removed support for Python 3.7 (Dan Braghis)
 * Maintenance: Switch to ruff for flake8 / isort code checking (Oliver Parker)
 * Maintenance: Deprecate `insert_editor_css` in favour of `insert_global_admin_css` (Ester Beltrami)
 * Maintenance: Optimise use of `specific` on Task and TaskState (Matt Westcott)
 * Maintenance: Use table UI component for workflow task index view (Matt Westcott)
 * Maintenance: Make header search available on generic index view (Matt Westcott)
 * Maintenance: Update pagination behavior to reject out-of-range / invalid page numbers (Matt Westcott)
 * Maintenance: Remove color tokens which are duplicates / unused (Thibaud Colas)
 * Maintenance: Add tests to help with maintenance of theme color tokens (Thibaud Colas)
 * Maintenance: Split out a base listing view from generic index view (Matt Westcott)
 * Maintenance: Update type hints in admin/ui/components.py so that `parent_context` is mutable (Andreas Nüßlein)
 * Maintenance: Deprecate `UserPagePermissionsProxy` (Sage Abdullah)
 * Maintenance: Optimise the Settings context processor to avoid redundantly finding a Site to improve cache ratios (Jake Howard)
 * Maintenance: Convert page listing to a class-based view (Matt Westcott)
 * Maintenance: Clean up page reports and type usage views to be independent of page listing views (Matt Westcott)
 * Maintenance: Migrate Tagit initialization to a Stimulus Controller (LB (Ben) Johnston)
 * Maintenance: Refactor GroupPagePermission to use Django's Permission model (Sage Abdullah)
 * Maintenance: Convert the CONTRIBUTORS file to Markdown (Dan Braghis)
 * Maintenance: Move `django-filter` version upper bound to v23 (Yuekui)
 * Maintenance: Update Pillow dependency to allow 10.x, only include support for >= 9.1.0 (Yuekui)
 * Maintenance: Migrate async header search and search within the Task chooser modal to `w-swap`, a Stimulus controller (LB (Ben) Johnston)
 * Maintenance: Replace Bootstrap tooltips with a new `w-tooltip` Stimulus controller (LB (Ben) Johnston)
 * Maintenance: Replace ModelAdmin history header human readable date template tag (LB (Ben) Johnston)
 * Maintenance: Update uuid to v9 and Jest to v29, with `jest-environment-jsdom` and new snapshot format (LB (Ben) Johnston)
 * Maintenance: Update test cases producing undesirable console output due to missing mocks, uncaught errors, warnings (LB (Ben) Johnston)
 * Maintenance: Remove unused snippets _header_with_history.html template (Thibaud Colas)
 * Maintenance: Migrate dialog instantiation to a new `w-dialog` Stimulus controller (Loveth Omokaro, LB (Ben) Johnston)
 * Maintenance: Support dialog template cloning using a new `w-teleport` Stimulus controller (Loveth Omokaro, LB (Ben) Johnston)
 * Maintenance: Migrate away from using the `"wagtailadmin/shared/field_as_li.html"` template include (Storm Heg)
 * Maintenance: Deprecate `wagtail.contrib.modeladmin` (Sage Abdullah)
 * Maintenance: Upgrade documentation theme `sphinx_wagtail_theme` to v6.1.1 which includes multiple styling fixes and always visible code copy buttons (LB (Ben) Johnston)
 * Maintenance: Don't update the reference index while deleting it (Andy Chosak)
* Maintenance: Allow `ActionController` to have a `noop` method to more easily leverage standalone Stimulus action options (Nandini Arora)


5.0.5 (19.10.2023)
~~~~~~~~~~~~~~~~~~

* Fix: CVE-2023-45809: Disclosure of user names via admin bulk action views (Matt Westcott)


5.0.4 (04.10.2023)
~~~~~~~~~~~~~~~~~~

 * Maintenance: Relax Willow / Pillow dependency to allow use of current Pillow versions with security fixes (Dan Braghis)


5.0.3 (25.09.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: Avoid use of `ignore_conflicts` when creating extra permissions for snippets, for SQL Server compatibility (Sage Abdullah)
 * Fix: Ensure sequence on `wagtailsearchpromotions_query` table is correctly set after migrating data (Jake Howard)
 * Fix: Update Pillow dependency to 9.1.0 (Daniel Kirkham)


5.0.2 (21.06.2023)
~~~~~~~~~~~~~~~~~~

 * Added `TitleFieldPanel` to support title / slug field synchronization (LB (Ben) Johnston)
 * Fix: Prevent JS error when reverting the spinner on a submit button after a validation error (LB (Ben) Johnston)
 * Fix: Prevent crash when comparing page revisions that include `MultipleChooserPanel` (Matt Westcott)
 * Fix: Ensure that title and slug continue syncing after entering non-URL-safe characters (LB (Ben) Johnston)
 * Fix: Ensure that title and slug are synced on keypress, not just on blur (LB (Ben) Johnston)
 * Fix: Add a more visible active state for side panel toggle buttons (Thibaud Colas)
 * Fix: Use custom dark theme colors for revision comparisons (Thibaud Colas)


5.0.1 (25.05.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: Rectify previous fix for TableBlock becoming uneditable after save (Sage Abdullah)
 * Fix: Ensure that copying page correctly picks up the latest revision (Matt Westcott)
 * Fix: Ensure comment buttons always respect `WAGTAILADMIN_COMMENTS_ENABLED` (Thibaud Colas)
 * Fix: Fix error when deleting a single snippet through the bulk actions interface (Sage Abdullah)
 * Fix: Pass the correct `for_update` value for `get_form_class` in `SnippetViewSet` edit views (Sage Abdullah)
 * Fix: Move comment notifications toggle to the comments side panel (Sage Abdullah)
 * Fix: Remove comment button on InlinePanel fields (Sage Abdullah)
 * Fix: Fix missing link to `UsageView` from `EditView` for snippets (Christer Jensen)
 * Fix: Prevent lowercase conversions of IndexView column headers (Virag Jain)
 * Fix: Fix various color issues in dark mode (Thibaud Colas)
 * Docs: Update documentation for `log_action` parameter on `RevisionMixin.save_revision` (Christer Jensen)


5.0 (02.05.2023)
~~~~~~~~~~~~~~~~

 * Added support for Django 4.2
 * Object usage information on deleting objects (Sage Abdullah)
 * Support for SVG images (Joshua Munn, with sponsorship from YouGov)
 * Custom validation support for StreamField (Matt Westcott)
 * Add `WAGTAILIMAGES_EXTENSIONS` setting to restrict image uploads to specific file types (Aman Pandey, Ananjan-R)
 * Update user list column level to `Access level` to be easier to understand (Vallabh Tiwari)
 * Migrate `.button-longrunning` behavior to a Stimulus controller with support for custom label element & duration (Loveth Omokaro)
 * Implement new simplified userbar designs (Albina Starykova)
 * Add more Axe rules to the accessibility checker (Albina Starykova)
 * Sort accessibility checker results by position on the page (Albina Starykova)
 * Highlight elements with errors in accessibility checker (Albina Starykova)
 * Add usage view for pages (Sage Abdullah)
 * Copy page form now updates the slug field dynamically with a slugified value on blur (Loveth Omokaro)
 * Ensure selected collection is kept when navigating from documents or images listings to add multiple views & upon upload (Aman Pandey, Bojan Mihelac)
 * Keep applied filters when downloading form submissions (Suyash Srivastava)
 * Messages added dynamically via JavaScript now have an icon to be consistent with those supplied in the page's HTML (Aman Pandey)
 * Switch lock/unlock side panel toggle to a switch, with more appropriate confirmation message status (Sage Abdullah)
 * Ensure that changed or cleared selection from choosers will dispatch a DOM `change` event (George Sakkis)
 * Add the ability to disable model indexing by setting `search_fields = []` (Daniel Kirkham)
 * Enhance `wagtail.search.utils.parse_query_string` to allow inner single quotes for key/value parsing (Aman Pandey)
 * Add helpful properties to `Locale` for more convenient usage within templates (Andy Babic)
 * Allow customizing icons for snippets via `SnippetViewSet.icon` (Daniel Kirkham, Sage Abdullah)
 * Allow customizing the base URL and URL namespace for snippet views (Sage Abdullah)
 * Allow customizing the default ordering and number of items per page for snippet listing views (Sage Abdullah)
 * Re-label "StreamField blocks" option in block picker to "Blocks" (Thibaud Colas)
 * Re-implement styleguide icons list as an auto-generated sequence of tables (Thibaud Colas)
 * Switch styleguide navigation to use panel components and minimap (Thibaud Colas)
 * Explicitly specify `MenuItem.name` for Snippets, Reports, and Settings menu items (Sage Abdullah)
 * Move the help text of fields and blocks directly below their label for easier reading (Thibaud Colas)
 * Allow filters on snippet and generic index views to be customized through the `list_filter` attribute (Sage Abdullah)
 * The select all checkbox in simple translation's submit translation page will now be in sync with other checkbox changes (Hanoon)
 * Update Wagtail’s default icon set to Font Awesome 6 (Thibaud Colas)
 * Allow admin templates for snippets to be overridden on a per-model or per-app basis (Sage Abdullah)
 * Allow overriding the base queryset to be used in snippet `IndexView` (Sage Abdullah)
 * Revise alignment and spacing of form fields and sections (Thibaud Colas)
 * Update Wagtail’s type scale so StreamField block labels and field labels are the same size (Thibaud Colas)
 * Allow customizing the `search_fields` and search backend via SnippetViewSet (Sage Abdullah)
 * Style comments as per page editor design, in side panel (Karl Hobley, Thibaud Colas)
 * Add support for custom panel icons, with defaults, displayed for top-level editor panels (Sage Abdullah)
 * Add new icons for StreamField blocks (Sage Abdullah)
 * Reveal the minimap on click rather than hover, keeping it expanded until dismissed, with state saved between page loads (Thibaud Colas)
 * Expand a collapsed form section when navigating to it with the minimap (Thibaud Colas)
 * The minimap and "Collapse all" button now appear next to side panels rather than underneath, so they can be used at any time (Thibaud Colas)
 * Allow `panels` / `edit_handler` to be specified via `SnippetViewSet` (Sage Abdullah)
 * Introduce dark mode support for the Wagtail admin interface, with a toggle in account preferences (Thibaud Colas)
 * Allow snippets to be registered into arbitrary admin menu items (Sage Abdullah)
 * Add configuration APIs in user bar accessibility checker for simpler customization of the checks performed
 * ReferenceIndex modified to only index Wagtail-related models, and allow other models to be explicitly registered (Daniel Kirkham)
 * Fix: Ensure `label_format` on StructBlock gracefully handles missing variables (Aadi jindal)
 * Fix: Adopt a no-JavaScript and more accessible solution for the 'Reset to default' switch to Gravatar when editing user profile (Loveth Omokaro)
 * Fix: Ensure `Site.get_site_root_paths` works on cache backends that do not preserve Python objects (Jaap Roes)
 * Fix: Ignore right clicks on side panel resizer (Sage Abdullah)
 * Fix: Resize in the correct direction for RTL languages with the side panel resizer (Sage Abdullah)
 * Fix: Support creating `StructValue` copies (Tidiane Dia)
 * Fix: Fix image uploads on storage backends that require file pointer to be at the start of the file (Matt Westcott)
 * Fix: Fix "Edit this page" missing from userbar (Satvik Vashisht)
 * Fix: No longer allow invalid duplicate site hostname creation as hostnames and domain names are a case insensitive (Coen van der Kamp)
 * Fix: Image and Document multiple upload update forms now correctly use the progress button (longrunning) behavior when clicked (Loveth Omokaro)
 * Fix: Prevent audit log report from failing on missing models (Andy Chosak)
 * Fix: Ensure that the privacy collection privacy edit button is styled as a button (Jatin Kumar)
 * Fix: Fix page/snippet cannot proceed a `GroupApprovalTask` if it's locked by someone outside of the group (Sage Abdullah)
 * Fix: Allow manual lock even if `WorkflowLock` is currently applied (Sage Abdullah)
 * Fix: Add missing log information for `wagtail.schedule.cancel` (Stefan Hammer)
 * Fix: Fix timezone activation leaking into subsequent requests in `require_admin_access()` (Stefan Hammer)
 * Fix: Fix dialog component's message to have rounded corners at the top side (Sam)
 * Fix: When multiple documents are uploaded and then subsequently updated, ensure that existing success messages are cleared correctly (Aman Pandey)
 * Fix: Prevent matches from unrelated models from leaking into SQLite FTS searches (Matt Westcott)
 * Fix: Prevent duplicate addition of StreamField blocks with the new block picker (Deepam Priyadarshi)
 * Fix: Enable partial search on images and documents index view where available (Mng)
 * Fix: Adopt a no-JavaScript and more accessible solution for option selection in reporting, using HTML only `radio` input fields (Mehul Aggarwal)
 * Fix: Ensure that document search results count shows the correct all matches, not the paginate total (Andy Chosak)
 * Fix: Fix radio and checkbox elements shrinking when using a long label (Sage Abdullah)
 * Fix: Fix select elements expanding beyond their container when using a long option label (Sage Abdullah)
 * Fix: Fix timezone handling of `TemplateResponse`s for users with a custom timezone (Stefan Hammer, Sage Abdullah)
 * Fix: Ensure TableBlock initialization correctly runs after load and its width is aligned with the parent panel (Dan Braghis)
 * Fix: Ensure that the JavaScript media files are loaded by default in Snippet index listings for date fields (Sage Abdullah)
 * Fix: Fix server-side caching of the icons sprite (Thibaud Colas)
 * Fix: Avoid showing scrollbars in the block picker unless necessary (Babitha Kumari)
 * Fix: Always show Add buttons, guide lines, Move up/down, Duplicate, Delete; in StreamField and Inline Panel (Thibaud Colas)
 * Fix: Make admin JS i18n endpoint accessible to non-authenticated users (Matt Westcott)
 * Fix: Fix incorrect API serialization for document `download_url` when `WAGTAILDOCS_SERVE_METHOD` is `direct` (Swojak-A)
 * Fix: Fix template configuration of snippets index results view (fidoriel, Sage Abdullah)
 * Fix: Prevent long preview mode names from making the select element overflow the side panel (Sage Abdullah)
 * Fix: Autosize text area field will now correctly resize when switching between comments toggle states (Suyash Srivastava)
 * Fix: When i18n is not enabled, avoid making a Locale query on every page view (Dan Braghis)
 * Fix: Fix initialisation of commenting widgets within StreamField (Thibaud Colas)
 * Fix: Fix various regressions in the commenting UI (Thibaud Colas)
 * Fix: Prevent TableBlock from becoming uneditable after save (Sage Abdullah)
 * Fix: Correctly show the "new item" badge within menu sections previously dismissed (Sage Abdullah)
 * Fix: Fix side panel stuck in resize state when pointer is released outside the grip (Sage Abdullah)
 * Docs: Add code block to make it easier to understand contribution docs (Suyash Singh)
 * Docs: Add new "Icons" page for icons customization and reuse across the admin interface (Coen van der Kamp, Thibaud Colas)
 * Docs: Fix broken formatting for MultiFieldPanel / FieldRowPanel permission kwarg docs (Matt Westcott)
 * Docs: Add helpful troubleshooting links and refine wording for getting started with development (Loveth Omokaro)
 * Docs: Ensure search autocomplete overlay on mobile does not overflow the viewport (Ayman Makroo)
 * Docs: Improve documentation for InlinePanel (Vallabh Tiwari)
 * Docs: Add contributor guidelines for building Stimulus Controllers (Thibaud Colas, Loveth Omokaro, LB (Ben) Johnston)
 * Docs: Fix typo in "Extending Draftail" documentation (Hans Kelson)
 * Docs: Clarify `ClusterableModel` requirements for using relations with `RevisionMixin`-enabled models (Sage Abdullah)
 * Docs: Add guide to making your first contribution (LB (Ben) Johnston)
 * Maintenance: Removed features deprecated in Wagtail 3.0 and 4.0 (Matt Westcott)
 * Maintenance: Update djhtml (html formatting) library to v 1.5.2 (Loveth Omokaro)
 * Maintenance: Re-enable `strictPropertyInitialization` in tsconfig (Thibaud Colas)
 * Maintenance: Refactor accessibility checker userbar item (Albina Starykova)
 * Maintenance: Removed unused `Page.get_static_site_paths` method (Yosr Karoui)
 * Maintenance: Provisional Django 5.0 compatibility fixes (Sage Abdullah)
 * Maintenance: Add unit tests for `CollapseAll` and `MinimapItem` components (Albina Starykova)
 * Maintenance: Code quality fixes (GLEF1X)
 * Maintenance: Refactor image / document / snippet usage views into a shared generic view (Sage Abdullah)
 * Maintenance: Rename the Stimulus `AutoFieldController` to the less confusing `SubmitController` (Loveth Omokaro)
 * Maintenance: Replace `script` tags with `template` tag for image/document bulk uploads (Rishabh Kumar Bahukhandi)
 * Maintenance: Remove unneeded float styles on 404 page (Fabien Le Frapper)
 * Maintenance: Convert userbar implementation to TypeScript (Albina Starykova)
 * Maintenance: Migrate slug field behavior to a Stimulus controller and create new `SlugInput` widget (Loveth Omokaro)
 * Maintenance: Refactor `status` HTML usage to shared template tag (Aman Pandey, LB (Ben) Johnston, Himanshu Garg)
 * Maintenance: Add curlylint and update djhtml, semgrep versions in pre-commit config (Himanshu Garg)
 * Maintenance: Use shared header template for `ModelAdmin` and Snippets type index header (Aman Pandey)
 * Maintenance: Move models and forms for `wagtailsearch.Query` to `wagtail.contrib.search_promotions` (Karl Hobley)
 * Maintenance: Migrate `initErrorDetection` (tabs error counts) to a Stimulus Controller `w-count` (Aman Pandey)
 * Maintenance: Migrate `window.addMessage` behavior to a global event listener & Stimulus Controller approach with `w-messages` (Aman Pandey)
 * Maintenance: Update Algolia DocSearch to use new application and correct versioning setup (Thibaud Colas)
 * Maintenance: Move snippet choosers and model check registration to `SnippetViewSet.on_register()` (Sage Abdullah)
 * Maintenance: Remove unused snippets delete-multiple view (Sage Abdullah)
 * Maintenance: Improve performance of determining live page URLs across the admin interface using `pageurl` template tag (Satvik Vashisht)
 * Maintenance: Migrate `window.initSlugAutoPopulate` behavior to a Stimulus Controller `w-sync` (Loveth Omokaro)
 * Maintenance: Rename `status` classes to `w-status` to align with preferred CSS class naming conventions (Mansi Gundre)
 * Maintenance: Include wagtail-factories in `wagtail.test.utils` to avoid cross-dependency issues (Matt Westcott)
 * Maintenance: Fix search tests to correctly reflect the behavior of search backends other than the fallback backend (Matt Westcott)
 * Maintenance: Migrate select all checkbox in simple translation's submit translation page to Stimulus controller `w-bulk`, remove inline script usage (Hanoon)
 * Maintenance: Refactor `SnippetViewSet` to extend `ModelViewSet` (Sage Abdullah)
 * Maintenance: Migrate initDismissibles behavior to a Stimulus controller `w-dismissible` (Loveth Omokaro)
 * Maintenance: Replace jQuery autosize v3 with Stimulus `w-autosize` controller using autosize npm package v6 (Suyash Srivastava)
 * Maintenance: Update `w-action` controller to support a click method (Suyash Srivastava)
 * Maintenance: Migrate the site settings switcher select from jQuery to a refined version of the `w-action` controller usage (Aadi jindal, LB (Ben) Johnston)
 * Maintenance: Always use expanded Sass output so CSS processing is identical in development and production builds (Thibaud Colas)
 * Maintenance: Refactor admin color palette to semantic, theme-agnostic design tokens (Thibaud Colas)


4.2.4 (25.05.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: Rectify previous fix for TableBlock becoming uneditable after save (Sage Abdullah)
 * Fix: Ensure that copying page correctly picks up the latest revision (Matt Westcott)
 * Fix: Adjust collection field alignment in multi-upload forms (LB (Ben) Johnston)
 * Fix: Prevent lowercase conversions of IndexView column headers (Virag Jain)
 * Docs: Update documentation for `log_action` parameter on `RevisionMixin.save_revision` (Christer Jensen)


4.2.3 (02.05.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent TableBlock from becoming uneditable after save (Sage Abdullah)


4.2.2 (03.04.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2023-28836 - Stored XSS attack via ModelAdmin views (Thibaud Colas)
 * Fix: CVE-2023-28837 - Denial-of-service via memory exhaustion when uploading large files (Jake Howard)
 * Fix: Fix radio and checkbox elements shrinking when using a long label (Sage Abdullah)
 * Fix: Fix select elements expanding beyond their container when using a long option label (Sage Abdullah)
 * Fix: Fix timezone handling of `TemplateResponse`s for users with a custom timezone (Stefan Hammer, Sage Abdullah)
 * Fix: Ensure TableBlock initialization correctly runs after load and its width is aligned with the parent panel (Dan Braghis)
 * Fix: Ensure that the JavaScript media files are loaded by default in Snippet index listings for date fields (Sage Abdullah)
 * Fix: Fix server-side caching of the icons sprite (Thibaud Colas)
 * Fix: Avoid showing scrollbars in the block picker unless necessary (Babitha Kumari)
 * Fix: Always show Add buttons, guide lines, Move up/down, Duplicate, Delete; in StreamField and Inline Panel (Thibaud Colas)
 * Fix: Ensure datetimepicker widget overlay shows over modals & drop-downs (LB (Ben) Johnston)
 * Docs: Fix module path for `MultipleChooserPanel` in panel reference docs
 * Maintenance: Render large image renditions to disk (Jake Howard)


4.2.1 (13.03.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: Support creating `StructValue` copies (Tidiane Dia)
 * Fix: Fix image uploads on storage backends that require file pointer to be at the start of the file (Matt Westcott)
 * Fix: Fix "Edit this page" missing from userbar (Satvik Vashisht)
 * Fix: Prevent audit log report from failing on missing models (Andy Chosak)
 * Fix: Fix page/snippet cannot proceed a `GroupApprovalTask` if it's locked by someone outside of the group (Sage Abdullah)
 * Fix: Add missing log information for `wagtail.schedule.cancel` (Stefan Hammer)
 * Fix: Fix timezone activation leaking into subsequent requests in `require_admin_access()` (Stefan Hammer)
 * Fix: Fix dialog component's message to have rounded corners at the top side (Sam)
 * Fix: Prevent matches from unrelated models from leaking into SQLite FTS searches (Matt Westcott)
 * Fix: Prevent duplicate addition of StreamField blocks with the new block picker (Deepam Priyadarshi)
 * Docs: Clarify `ClusterableModel` requirements for using relations with `RevisionMixin`-enabled models (Sage Abdullah)
 * Maintenance: Update Algolia DocSearch to use new application and correct versioning setup (Thibaud Colas)


4.2 (06.02.2023)
~~~~~~~~~~~~~~~~

 * Added StreamField data migration helpers (Sandil Ranasinghe, Jacob Topp-Mugglestone, Joshua Munn, Karl Hobley)
 * Added ability to lock snippet models with `LockableMixin` (Sage Abdullah)
 * Added ability to submit snippets for moderation with `WorkflowMixin` (Sage Abdullah)
 * Create `{% fullpageurl %}` tag for getting the absolute URL of a page (Jake Howard)
 * Added `MultipleChooserPanel`, a variant of `InlinePanel` with improved editor experience when inserting multiple linked objects (Matt Westcott)
 * Test assertion util `WagtailPageTestCase.assertCanCreate` now supports the kwarg `publish=True` to determine whether to publish the page (Harry Percival, Akua Dokua Asiedu, Matt Westcott)
 * Ensure that the `rebuild_references_index` command can run without console output if called with `--verbosity 0` (Omerzahid Ali, Aman Pandey)
 * Add full support for secondary buttons with icons in the Wagtail design system - `button bicolor button--icon button-secondary` including the `button-small` variant (Seremba Patrick)
 * Add `purge_embeds` management command to delete all the cached embed objects in the database (Aman Pandey)
 * Make it possible to resize the page editor’s side panels (Sage Abdullah)
 * Add ability to include `form_fields` as an APIField on `FormPage` (Sævar Öfjörð Magnússon, Suyash Singh, LB (Ben) Johnston)
 * Ensure that images listings are more consistently aligned when there are fewer images uploaded (Theresa Okoro)
 * Add more informative validation error messages for non-unique slugs within the admin interface and for programmatic page creation (Benjamin Bach)
 * Always show the page editor title field’s border when the field is empty (Thibaud Colas)
 * Snippet models extending `DraftStateMixin` now automatically define a "Publish" permission type (Sage Abdullah)
 * Users now remain on the edit page after saving a snippet as draft (Sage Abdullah)
 * Base project template now populates the meta description tag from the search description field (Aman Pandey)
 * Added support for `azure-mgmt-cdn` version >= 10 and `azure-mgmt-frontdoor` version >= 1 in the frontend cache invalidator (Sylvain Fankhauser)
 * Add a system check to warn when a `django-storages` backend is configured to allow overwriting (Rishabh jain)
 * Update admin focus outline color to have higher contrast against white backgrounds (Thibaud Colas)
 * Implement latest design for the admin dashboard header (Thibaud Colas, Steven Steinwand)
 * Add Axe accessibility checker integration within userbar, with count and list of errors (Albina Starykova)
 * Restyle the userbar to follow the visual design of the Wagtail admin (Albina Starykova)
 * Allow configuring Axe accessibility checker integration via `construct_wagtail_userbar` hook (Sage Abdullah)
 * Support pinning and un-pinning the rich text editor toolbar depending on user preference (Thibaud Colas)
 * Make the rich text block trigger and slash-commands always available regardless of where the cursor is (Thibaud Colas)
 * Adjust the size of panel labels on the "Account" form (Thibaud Colas)
 * Delay hiding the contents of the side panels when closing, so the animation is smoother (Thibaud Colas)
 * ListBlock now shows item-by-item differences when comparing versions (Tidiane Dia)
 * Implement a new design for chooser buttons with better accessibility (Thibaud Colas)
 * Fix: Make sure workflow timeline icons are visible in high-contrast mode (Loveth Omokaro)
 * Fix: Ensure authentication forms (login, password reset) have a visible border in Windows high-contrast mode (Loveth Omokaro)
 * Fix: Ensure visual consistency between buttons and links as buttons in Windows high-contrast mode (Albina Starykova)
 * Fix: references extraction for ChooserBlock (Alex Tomkins)
 * Fix: Incorrectly formatted link in the documentation for Wagtail community support (Bolarinwa Comfort Ajayi)
 * Fix: Text within status tags text will now resize correctly when customizing browser font size (Mary Ojo)
 * Fix: Ensure logo shows correctly on log in page in Windows high-contrast mode (Loveth Omokaro)
 * Fix: Comments notice background overflows its container (Yekasumah)
 * Fix: Ensure links within help blocks meet color contrast guidelines for accessibility (Theresa Okoro)
 * Fix: Ensure the skip link (used for keyboard control) meets color contrast guidelines for accessibility (Dauda Yusuf)
 * Fix: Ensure tag fields correctly show in both dark and light Windows high-contrast modes (Albina Starykova)
 * Fix: Ensure new tooltips & tooltip menus have visible borders and tip triangle in Windows high-contrast mode (Juliet Adeboye)
 * Fix: Ensure there is a visual difference of 'active/current link' vs normal links in Windows high-contrast mode (Mohammad Areeb)
 * Fix: Avoid issues where trailing whitespace could be accidentally removed in translations for new page & snippet headers (Florian Vogt)
 * Fix: Make sure minimap error indicators follow the minimap scrolling (Thibaud Colas)
 * Fix: Remove the ability to view or add comments to `InlinePanel` inner fields to avoid lost or incorrectly linked comments (Jacob Topp-Mugglestone)
 * Fix: Use consistent heading styles on top-level fields in the page editor (Sage Abdullah)
 * Fix: Allow button labels to wrap onto two lines in dropdown buttons (Coen van der Kamp)
 * Fix: Remove spurious horizontal resize handle from text areas (Matt Westcott)
 * Fix: Move DateField, DateTimeField, TimeField comment buttons to be right next to the fields (Theresa Okoro)
 * Fix: Support text resizing in workflow steps cards (Ivy Jeptoo)
 * Fix: Ignore images added via fixtures when using `WAGTAILIMAGES_FEATURE_DETECTION_ENABLED` to avoid errors for images that do not exist (Aman Pandey)
 * Fix: Restore ability to perform JSONField query operations against StreamField when running against the Django 4.2 development branch (Sage Abdullah)
 * Fix: Ensure there is correct grammar and pluralization for Tab error counts shown to screen readers (Aman Pandey)
 * Fix: Pass through expected `cc`, `bcc` and `reply_to` to the Django mail helper from `wagtail.admin.mail.send_mail` (Ben Gosney)
 * Fix: Allow reviewing or reverting to a Page's initial revision (Andy Chosak)
 * Fix: Use the correct padding for autocomplete block picker (Umar Farouk Yunusa)
 * Fix: Ensure that short content pages (such as editing snippets) do not show an inconsistent background (Sage Abdullah)
 * Fix: Fix horizontal positioning of rich text inline toolbar (Thibaud Colas)
 * Fix: Ensure that `DecimalBlock` correctly handles `None`, when `required=False`, values (Natarajan Balaji)
 * Fix: Close the userbar when clicking its toggle (Albina Starykova)
 * Fix: Add a border around the userbar menu in Windows high-contrast mode so it can be identified (Albina Starykova)
 * Fix: Make sure browser font resizing applies to the userbar (Albina Starykova)
 * Fix: Fix check for `delete_url_name` attribute in generic `DeleteView` (Alex Simpson)
 * Fix: Re-implement design system colors so HSL values exactly match the desired RGB (Albina Starykova)
 * Fix: Resolve issue where workflow and other notification emails would not include the correct tab URL for account notification management (LB (Ben) Johnston)
 * Fix: Use consistent spacing above and below page headers (Thibaud Colas)
 * Fix: Use the correct icon sizes and spacing in slim header (Thibaud Colas)
 * Fix: Use the correct color for placeholders in rich text fields (Thibaud Colas)
 * Fix: Prevent obstructing the outline around rich text fields (Thibaud Colas)
 * Fix: Page editor dropdowns now use indigo backgrounds like elsewhere in the admin interface (Thibaud Colas)
 * Fix: Allow parsing of multiple key/value pairs from string in `wagtail.search.utils.parse_query_string` (Beniamin Bucur)
 * Fix: Prevent memory exhaustion when purging a large number of revisions (Jake Howard)
 * Fix: Add right-to-left (RTL) support for the following form components: Switch, Minimap, live preview (Thibaud Colas)
 * Fix: Improve right-to-left (RTL) positioning for the following components: Page explorer, Sidebar sub-menu, rich text tooltips, rich text toolbar trigger, editor section headers (Thibaud Colas)
 * Fix: Add right-to-left (RTL) support for the caret of select inputs (Badr Fourane)
 * Fix: Use the workflow name as the workflow information dialog title (Sage Abdullah)
 * Fix: Link to workflow history view instead of page history view in the workflow information dialog (Sage Abdullah)
 * Fix: Fix in-progress count in warning message when disabling workflows (Sage Abdullah)
 * Fix: Show workflow name on workflow history index page (Sage Abdullah)
 * Fix: Fix workflow history detail timeline content from showing on initial load (Sage Abdullah)
 * Fix: Center-align StreamField and rich text block picker buttons with the dotted guide line (Thibaud Colas)
 * Fix: Search bar in chooser modals now performs autocomplete searches under PostgreSQL (Matt Westcott)
 * Fix: Server-side document filenames are preserved when replacing a document file (Suyash Singh, Matt Westcott)
 * Fix: Add missing wagtailadmin_tags in `workflow_state_approved.html` template (Alex Tomkins)
 * Fix: Do not show bulk actions checkbox in page type usage view (Sage Abdullah)
 * Fix: Prevent account name from overflowing the sidebar (Aman Pandey)
 * Fix: Ensure edit form is displayed as unlocked immediately after canceling a workflow (Sage Abdullah)
 * Fix: Prevent `latest_revision` pointer from being copied over when copying translatable snippets for translation (Sage Abdullah)
 * Fix: Page listings actions under the "More" dropdown are now accessible for screen reader and keyboard users (Thibaud Colas)
 * Fix: Bulk actions under the "More" dropdown are now accessible for screen reader and keyboard users (Thibaud Colas)
 * Fix: Navigation to translations via the locale dropdown is now accessible for screen reader and keyboard users (Thibaud Colas)
 * Fix: Make it possible for speech recognition users to reveal chooser buttons (Thibaud Colas)
 * Docs: Add custom permissions section to permissions documentation page (Dan Hayden)
 * Docs: Add documentation for how to get started with contributing translations for the Wagtail admin (Ogunbanjo Oluwadamilare)
 * Docs: Officially recommend `fnm` over `nvm` in development documentation (LB (Ben) Johnston)
 * Docs: Mention the importance of passing `request` and `current_site` to `get_url` on the performance documentation page (Jake Howard)
 * Docs: Add documentation for `register_user_listing_buttons` hook (LB (Ben Johnston))
 * Docs: Add development (contributing to Wagtail) documentation notes for development on Windows (Akua Dokua Asiedu)
 * Docs: Mention Wagtail’s usage of Django’s default user model by default (Temidayo Azeez)
 * Docs: Add links to treebeard documentation for relevant methods (Temidayo Azeez)
 * Docs: Add clarification on where to register entity plugins (Mark McOsker)
 * Docs: Fix logo in README not being visible in high-contrast mode (Benita Anawonah)
 * Docs: Improve 'first wagtail site' tutorial (Akua Dokua Asiedu)
 * Docs: Grammatical adjustments of `page models` usage guide (Damilola Oladele)
 * Docs: Add class inheritance information to StreamField block reference (Temidayo Azeez)
 * Docs: Document the hook `register_image_operations` and add an example of a custom Image filter (Coen van der Kamp)
 * Docs: Fix incorrect example code for StreamField migration of `RichTextField` (Matt Westcott)
 * Docs: Document the policy needed to create invalidations in CloudFront (Jake Howard)
 * Docs: Document how to add permission restriction to a report view (Rishabh jain)
 * Docs: Add example for how to configure API `renderer_classes` (Aman Pandey)
 * Docs: Document potential data loss for BaseLogEntry migration in 3.0 (Sage Abdullah)
 * Docs: Add documentation for the reference index mechanism (Daniel Kirkham)
 * Docs: Remove confusing `SettingsPanel` reference in the page editing `TabbedInterface` example as `SettingsPanel` no longer shows anything as of 4.1 (Kenny Wolf, Julian Bigler)
 * Docs: Add more extensive documentation for the `permission` kwarg support in Panels (LB (Ben) Johnston)
 * Maintenance: Switch to using Willow instead of Pillow for images (Darrel O'Pry)
 * Maintenance: Remove unsquashed `testapp` migrations (Matt Westcott)
 * Maintenance: Upgrade to Node 18 for frontend build tooling (LB (Ben) Johnston)
 * Maintenance: Run Python tests with coverage and upload coverage data to codecov (Sage Abdullah)
 * Maintenance: Clean up duplicate JavaScript for the `escapeHtml` function (Jordan Rob)
 * Maintenance: Clean up Prettier & Eslint usage for search promotions formset JS file (LB (Ben Johnston))
 * Maintenance: Ensure that translation file generation ignores JavaScript unit tests and clean up unit tests for Django gettext utils (LB (Ben Johnston))
 * Maintenance: Migrated `initButtonSelects` from core.js to own TypeScript file and add unit tests (Loveth Omokaro)
 * Maintenance: Migrated `initSkipLink` util to TypeScript and add JSDoc & unit tests (Juliet Adeboye)
 * Maintenance: Clean up some unused utility classes and migrate `unlist` to Tailwind utility class `w-list-none` (Loveth Omokaro)
 * Maintenance: Clean up linting on legacy code and add shared util `hasOwn` in TypeScript (Loveth Omokaro)
 * Maintenance: Remove unnecessary box-sizing: border-box declarations in SCSS (Albina Starykova)
 * Maintenance: Migrated `initTooltips` to TypeScript and add JSDoc and unit tests (Fatuma Abdullahi)
 * Maintenance: Migrated `initTagField` from core.js to own TypeScript file and add unit tests (Chisom Okeoma)
 * Maintenance: Added unit tests & JSDoc to `initDismissibles` (Yekasumah)
 * Maintenance: Standardise on `classname` for passing HTML class attributes (LB (Ben Johnston))
 * Maintenance: Clean up expanding formset and `InlinePanel` JavaScript initialization code and adopt a class approach (Matt Westcott)
 * Maintenance: Extracted revision and draft state logic from generic views into mixins (Sage Abdullah)
 * Maintenance: Extracted generic lock / unlock views from page lock / unlock views (Sage Abdullah)
 * Maintenance: Move `identity` JavaScript util into shared utils folder (LB (Ben Johnston))
 * Maintenance: Remove unnecessary declaration of function to determine URL query params, instead use `URLSearchParams` (Loveth Omokaro)
 * Maintenance: Update `tsconfig` to better support modern TypeScript development and clean up some code quality issues via Eslint (Loveth Omokaro)
 * Maintenance: Set up Stimulus application initialization according to RFC 78 (LB (Ben) Johnston)
 * Maintenance: Refactor submit-on-change search filters for image and document listings to use Stimulus (LB (Ben) Johnston)
 * Maintenance: Switch userbar to initialize a Web Component to avoid styling clashes (Albina Starykova)
 * Maintenance: Refactor userbar stylesheets to use the same CSS loading as the rest of the admin (Albina Starykova)
 * Maintenance: Remove unused search-bar and button-filter styles (Thibaud Colas)
 * Maintenance: Use util method to construct dummy requests in tests (Jake Howard)
 * Maintenance: Remove unused dev-only react-axe integration (Thibaud Colas)
 * Maintenance: Migrate accessible Skip Link implementation to a Stimulus controller (Loveth Omokaro)
 * Maintenance: Split up `wagtail.admin.panels` into submodules, existing exports have been preserved (Matt Westcott)
 * Maintenance: Refactor userbar styles to use the same stylesheet as other components (Thibaud Colas)
 * Maintenance: Add deprecation warnings for `wagtail.core` and other imports deprecated in Wagtail 3.0 (Matt Westcott)
 * Maintenance: Migrate admin upgrade notification message implementation to a Stimulus controller (Loveth Omokaro)
 * Maintenance: Migrate workflow and workflow tasks enable action and lock/unlock actions to a Stimulus controller (Loveth Omokaro)
 * Maintenance: Pull out icon sprite setup function from inline script to its own TypeScript file & add unit tests (Loveth Omokaro)
 * Maintenance: Upgraded Transifex configuration to v3 (Loic Teixeira)
 * Maintenance: Replace repeated HTML `avatar` component with a template tag include `{% avatar ... %}` throughout the admin interface (Aman Pandey)
 * Maintenance: Remove unused `icon-help` and `help-inverse` code (Thibaud Colas)
 * Maintenance: Migrate privacy switch, FileFields, history buttons, error messages, Datetimepicker, ordering icons, thumbnails, ModelAdmin, page listings, workflows, and user creation form controls to SVG icons (Thibaud Colas)
 * Maintenance: Switch form submission listings to use the same ordering icons as other listings (Thibaud Colas)
 * Maintenance: Refactor "More" dropdowns, locale selector, "Switch locales", page actions, to use the same dropdown component (Thibaud Colas)
 * Maintenance: Remove or replace legacy CSS classes: visuallyhidden, visuallyvisible, divider-after, divider-before, inline, inline-block, block, u-hidden, clearfix, reordering, overflow (Thibaud Colas)
 * Maintenance: Prevent future issues with icon.html end-of-file newlines (Thibaud Colas)
 * Maintenance: Rewrite styles using legacy `c-`, `o-`, `u-`, `t-`, `is-` prefixes (Thibaud Colas)
 * Maintenance: Remove invalid CSS styles / Sass selector concatenation (Thibaud Colas)


4.1.9 (19.10.2023)
~~~~~~~~~~~~~~~~~~

* Fix: CVE-2023-45809: Disclosure of user names via admin bulk action views (Matt Westcott)


4.1.8 (28.09.2023)
~~~~~~~~~~~~~~~~~~

 * Maintenance: Additionally update Pillow dependency to allow use of versions with security fixes (Dan Braghis)


4.1.7 (27.09.2023)
~~~~~~~~~~~~~~~~~~

 * Maintenance: Relax Willow dependency to allow use of current Pillow versions with security fixes (Dan Braghis)


4.1.6 (25.05.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: Rectify previous fix for TableBlock becoming uneditable after save (Sage Abdullah)
 * Fix: Ensure that copying page correctly picks up the latest revision (Matt Westcott)
 * Fix: Adjust collection field alignment in multi-upload forms (LB (Ben) Johnston)
 * Fix: Prevent lowercase conversions of IndexView column headers (Virag Jain)
 * Docs: Update documentation for `log_action` parameter on `RevisionMixin.save_revision` (Christer Jensen)

4.1.5 (02.05.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent TableBlock from becoming uneditable after save (Sage Abdullah)


4.1.4 (03.04.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2023-28836 - Stored XSS attack via ModelAdmin views (Thibaud Colas)
 * Fix: CVE-2023-28837 - Denial-of-service via memory exhaustion when uploading large files (Jake Howard)
 * Fix: Fix radio and checkbox elements shrinking when using a long label (Sage Abdullah)
 * Fix: Fix select elements expanding beyond their container when using a long option label (Sage Abdullah)
 * Fix: Fix timezone handling of `TemplateResponse`s for users with a custom timezone (Stefan Hammer, Sage Abdullah)
 * Fix: Ensure TableBlock initialization correctly runs after load and its width is aligned with the parent panel (Dan Braghis)
 * Fix: Ensure that the JavaScript media files are loaded by default in Snippet index listings for date fields (Sage Abdullah)
 * Fix: Fix server-side caching of the icons sprite (Thibaud Colas)
 * Fix: Always show Add buttons, guide lines, Move up/down, Duplicate, Delete; in StreamField and Inline Panel (Thibaud Colas)
 * Fix: Ensure datetimepicker widget overlay shows over modals & drop-downs (LB (Ben) Johnston)
 * Maintenance: Render large image renditions to disk (Jake Howard)


4.1.3 (13.03.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: Add right-to-left (RTL) support for the following form components: Switch, Minimap, live preview (Thibaud Colas)
 * Fix: Improve right-to-left (RTL) positioning for the following components: Page explorer, Sidebar sub-menu, rich text tooltips, rich text toolbar trigger, editor section headers (Thibaud Colas)
 * Fix: Ensure links within help blocks meet color contrast guidelines for accessibility (Theresa Okoro)
 * Fix: Support creating `StructValue` copies (Tidiane Dia)
 * Fix: Fix "Edit this page" missing from userbar (Satvik Vashisht)
 * Fix: Prevent audit log report from failing on missing models (Andy Chosak)
 * Fix: Add missing log information for `wagtail.schedule.cancel` (Stefan Hammer)
 * Fix: Fix timezone activation leaking into subsequent requests in `require_admin_access()` (Stefan Hammer)
 * Fix: Prevent matches from unrelated models from leaking into SQLite FTS searches (Matt Westcott)
 * Docs: Clarify `ClusterableModel` requirements for using relations with `RevisionMixin`-enabled models (Sage Abdullah)
 * Maintenance: Update Algolia DocSearch to use new application and correct versioning setup (Thibaud Colas)


4.1.2 (06.02.2023)
~~~~~~~~~~~~~~~~~~

 * Fix: Make "Cancel scheduled publish" button correctly redirect back to the edit view (Sage Abdullah)
 * Fix: Prevent crash when reverting revisions on a snippet with `PreviewableMixin` applied (Sage Abdullah)
 * Fix: Use consistent heading styles on top-level fields in the page editor (Sage Abdullah)
 * Fix: Allow button labels to wrap onto two lines in dropdown buttons (Coen van der Kamp)
 * Fix: Move DateField, DateTimeField, TimeField comment buttons to be right next to the fields (Theresa Okoro)
 * Fix: Support text resizing in workflow steps cards (Ivy Jeptoo)
 * Fix: Use the correct padding for autocomplete block picker (Umar Farouk Yunusa)
 * Fix: Fix horizontal positioning of rich text inline toolbar (Thibaud Colas)
 * Fix: Close the userbar when clicking its toggle (Albina Starykova)
 * Fix: Do not show bulk actions checkbox in page type usage view (Sage Abdullah)
 * Fix: Prevent account name from overflowing the sidebar (Aman Pandey)
 * Fix: Ensure edit form is displayed as unlocked immediately after canceling a workflow (Sage Abdullah)
 * Fix: Prevent `latest_revision` pointer from being copied over when copying translatable snippets for translation (Sage Abdullah)
 * Docs: Document potential data loss for BaseLogEntry migration in 3.0 (Sage Abdullah)
 * Docs: Add documentation for the reference index mechanism (Daniel Kirkham)


4.1.1 (11.11.2022)
~~~~~~~~~~~~~~~~~~

 * Fix: Fix issue where lock/unlock buttons would not work on the Dashboard (home) page or the page index listing via the status sidebar (Stefan Hammer)
 * Fix: Fix disabled style on StreamField add button (Matt Westcott)
 * Fix: Ensure models are fully loaded before registering snippets, to avoid circular import issues (Matt Westcott)
 * Fix: Prevent fields without a `verbose_name` property from breaking usage report views (Matt Westcott)
 * Fix: Exclude tags from the reference index (Matt Westcott)
 * Fix: Fix errors in handling generic foreign keys when populating the reference index (Matt Westcott)
 * Fix: Prevent error in handling null ParentalKeys when populating the reference index (Matt Westcott)
 * Fix: Make sure minimap error indicators follow the minimap scrolling (Thibaud Colas)
 * Fix: Ensure background HTTP request to clear stale preview data correctly respects the `CSRF_HEADER_NAME` setting (Sage Abdullah)
 * Fix: Prevent error on aging pages report when "Last published by" user has been deleted (Joshua Munn)


4.1 LTS (01.11.2022)
~~~~~~~~~~~~~~~~~~~~

 * New scheduled publishing UI, available from the Status side panel (Sage Abdullah)
 * Allow snippet admin views to be customized via `SnippetViewSet` (Sage Abdullah)
 * Implement scheduled publishing for snippets inheriting from `DraftStateMixin` (Sage Abdullah)
 * Add reference index and usage reports for images, documents and snippets (Karl Hobley, Matt Westcott)
 * Formalised support for Python 3.11 (Matt Westcott)
 * Add basic keyboard control and screen reader support for page listing re-ordering (Paarth Agarwal, Thomas van der Hoeven)
 * Add `PageQuerySet.private` method as an alias of `not_public` (Mehrdad Moradizadeh)
 * Most images in the admin will now only load once they are visible on screen (Jake Howard)
 * Allow setting default attributes on image tags (Jake Howard)
 * Optimise the performance of the Wagtail userbar to remove duplicated queries, improving page loads when viewing live pages while signed in (Jake Howard)
 * Remove legacy styling classes for buttons (`unbutton`, `button-neutral`, `button-strokeonhover`, `hover-no`, `yes`) and refactor button styles to be more maintainable (Paarth Agarwal, LB (Ben Johnston))
 * Add button variations to the pattern library (Paarth Agarwal)
 * Provide a more accessible page title where the unique information is shown first and the CMS name is shown last (Mehrdad Moradizadeh)
 * Pull out behavior from `AbstractFormField` to `FormMixin` and `AbstractEmailForm` to `EmailFormMixin` to allow use with subclasses of `Page` (Mehrdad Moradizadeh, Kurt Wall)
 * Add a `docs.wagtail.org/.well-known/security.txt` so that the security policy is available as per the specification on https://securitytxt.org/ (Jake Howard)
 * Add unit tests for the `classnames` Wagtail admin template tag (Mehrdad Moradizadeh)
 * Show an inverse locked indicator when the page has been locked by the current user in reports and dashboard listings (Vaibhav Shukla, LB (Ben Johnston))
 * Add clarity to the development documentation that `admonition` should not be used and titles for `note` are not supported, including clean up of some existing incorrect usage (LB (Ben Johnston))
 * Unify the styling of delete/destructive button styles across the admin interface (Paarth Agarwal)
 * Adopt new designs and unify the styling styles for `.button-secondary` buttons across the admin interface (Paarth Agarwal)
 * Refine designs for disabled buttons throughout the admin interface (Paarth Agarwal)
 * Update expanding formset add buttons to use `button` not link for behaviour (LB (Ben) Johnston)
 * Add robust unit testing for authentication scenarios across the user management admin pages (Mehrdad Moradizadeh)
 * Avoid assuming an integer PK named 'id' on multiple upload views (Matt Westcott)
 * Add a toggle to collapse/expand all page panels at once (Helen Chapman)
 * Improve the GitHub Workflows (CI) security (Alex (sashashura))
 * Use `search` type input in documentation search (LB (Ben) Johnston)
 * Render `help_text` when set on `FieldPanel`, `MultiFieldPanel`, `FieldRowPanel`, and other panel APIs where it previously worked without official support (Matt Westcott)
 * Consolidate usage of Excel libraries to a single library `openpyxl`, removing usage of `XlsxWriter`, `tablib`, `xlrd` and `xlwt` (Jaap Roes)
 * Adopt `wagtail.admin.views.generic.IndexView` for the Users index listing and search results (Mehrdad Moradizadeh)
 * Adopt `wagtail.admin.views.generic.CreateView` for the User creation view (Mehrdad Moradizadeh)
 * Adopt `wagtail.admin.views.generic.DeleteView` for the User delete view (Mehrdad Moradizadeh)
 * Adopt `wagtail.admin.views.generic.EditView` for the User edit view (Mehrdad Moradizadeh)
 * Add `button-secondary bicolor` variants to the pattern library and styleguide (Adinapunyo Banerjee)
 * Add better support for non-integer / non-`id` primary keys into Wagtail's generic views, including for Snippets and custom User models (Mehrdad Moradizadeh)
 * Upgrade jQuery UI to version 1.13.2 (LB (Ben) Johnston)
 * Update pattern library background & text examples (Albina Starykova)
 * Switch StreamField blocks to use a `<section>` element so screen reader users can bypass them more easily (Thibaud Colas)
 * Add anchor links to StreamField blocks so users can navigate straight to a given block (Thibaud Colas)
 * Support "Ctrl + f" in-page search within collapsed StreamField blocks (Thibaud Colas)
 * Remember the last opened side panel in the page editor, activating it on page load (Sage Abdullah)
 * Ensure that the `update_index` command can run without console output if called with `--verbosity 0` (Ben Sturmfels, Oliver Parker)
 * Improve side panels’ resizing in page editor and listings (Steven Steinwand)
 * Adjust breadcrumb text alignment and size in page listings & page editor (Steven Steinwand)
 * Improvements to getting started tutorial aimed at developers who are very new to Python and have no Django experience (Damilola Oladele)
 * Update documentation dependencies; Sphinx Wagtail Theme to v5.3.2, MyST Parser to v0.18.1, add Sphinx Copy Button (LB (Ben) Johnston)
 * Add "What's New" dashboard banner and "Help" menu in sidebar (Sage Abdullah)
 * Implement new "minimap" component for the page editor (Thibaud Colas)
 * The `image_url` template tag, when using the serve view to redirect rather than serve directly, will now use temporary redirects with a cache header instead of permanent redirects (Jake Howard)
 * Add new test assertions to `WagtailPageTestCase` - `assertPageIsRoutable`, `assertPageIsRenderable`, `assertPageIsEditable`, `assertPageIsPreviewable` (Andy Babic)
 * Add documentation to the performance section about how to better create image URLs when not used directly on the page (Jake Howard)
 * Add ability to provide a required `permission` to `PanelGroup`, used by `TabbedInterface`, `ObjectList`, `FieldRowPanel` and `MultiFieldPanel` (Oliver Parker)
 * Update documentation screenshots of the admin interface to align with changes in this release (Thibaud Colas)
 * Fix: Prevent `PageQuerySet.not_public` from returning all pages when no page restrictions exist (Mehrdad Moradizadeh)
 * Fix: Ensure that duplicate block ids are unique when duplicating stream blocks in the page editor (Joshua Munn)
 * Fix: Revise color usage so that privacy & locked indicators can be seen in Windows High Contrast mode (LB (Ben Johnston))
 * Fix: Ensure that disabled buttons have a consistent presentation on hover to indicate no interaction is available (Paarth Agarwal)
 * Fix: Update the 'Locked pages' report menu title so that it is consistent with other pages reports and its own title on viewing (Nicholas Johnson)
 * Fix: Support `formfield_callback` handling on `ModelForm.Meta` for future Django 4.2 release (Matt Westcott)
 * Fix: Ensure that `ModelAdmin` correctly supports filters in combination with subsequent searches without clearing the applied filters (Stefan Hammer)
 * Fix: Add missing translated values to site settings' headers plus models presented in listings and audit report filtering labels (Stefan Hammer)
 * Fix: Remove `capitalize()` calls to avoid issues with other languages or incorrectly presented model names for reporting and parts of site settings (Stefan Hammer)
 * Fix: Add back rendering of `help_text` for InlinePanel (Matt Westcott)
 * Fix: Ensure `for_user` argument is passed to the form class when previewing pages (Matt Westcott)
 * Fix: Ensure the capitalization of the `timesince_simple` tag is consistently added in the template based on usage in context (Stefan Hammer)
 * Fix: Add missing translation usage for the `timesince_last_update` and ensure the translated labels can be easier to work with in Transifex (Stefan Hammer)
 * Fix: Add additional checks for duplicate form field `clean_name` values in the Form Builder validation and increase performance of checks (Dan Bentley)
 * Fix: Use correct color for labels of radio and checkbox fields (Steven Steinwand)
 * Fix: Adjust spacing of fields’ error messages and position in tables (Steven Steinwand)
 * Fix: Update dead or redirected links throughout the documentation (LB (Ben) Johnston)
 * Fix: Use different icons for workflow timeline component, so the steps can be distinguished with other means than color (Sam Moran)
 * Fix: Use the correct custom font for the Wagtail userbar (Umar Farouk Yunusa)
 * Fix: StreamField blocks are now collapsible with the keyboard (Thibaud Colas)
 * Fix: StreamField block headings now have a label for screen reader users (Thibaud Colas)
 * Fix: Display the "*" required field indicator for StreamField blocks (Thibaud Colas)
 * Fix: Resolve inconsistency in action button positions in InlinePanel (Thibaud Colas)
 * Fix: Use h3 elements with a counter in InlinePanel so screen reader users can navigate by heading (Thibaud Colas)
 * Fix: Ensure that buttons on custom chooser widgets are correctly shown on hover (Thibaud Colas)
 * Fix: Add missing asterisk to title field placeholder (Seremba Patrick, Stefan Hammer)
 * Fix: Avoid creating an extra rich text block when inserting a new block at the end of the content (Matt Westcott)
 * Fix: Removed the extra dot in the Wagtail version shown within the admin settings menu item (Loveth Omokaro)
 * Fix: Fully remove the obsolete `wagtailsearch_editorspick` table that prevents flushing the database (Matt Westcott)
 * Fix: Update latest version message on Dashboard to accept dev build version format used on nlightly builds (Sam Moran)
 * Fix: references extraction for ChooserBlock (Alex Tomkins)
 * Fix: Regression in field width for authentication pages (log in / password reset) (Chisom Okeoma)
 * Fix: Ensure the new minimap correctly pluralizes error counts for `aria-label`s (Matt Westcott)


4.0.4 (18.10.2022)
~~~~~~~~~~~~~~~~~~

 * Render `help_text` when set on `FieldPanel`, `MultiFieldPanel`, `FieldRowPanel`, and other panel APIs where it previously worked without official support (Matt Westcott)
 * Update special-purpose `FieldPanel` deprecation message to add clarity for developers (Matt Westcott)
 * Fix: Add back rendering of `help_text` for InlinePanel (Matt Westcott)
 * Fix: Ensure that `AbstractForm` & `AbstractEmailForm` page models correctly pass the form to the preview context (Dan Bentley)
 * Fix: Use the correct custom font for the Wagtail userbar (Umar Farouk Yunusa)
 * Fix: Ensure that buttons on custom chooser widgets are correctly shown on hover (Thibaud Colas)


4.0.3 (18.10.2022)
~~~~~~~~~~~~~~~~~~

[release withdrawn due to packaging issues]


4.0.2 (23.09.2022)
~~~~~~~~~~~~~~~~~~

 * Update all images and sections of the Wagtail Editor's guide to align with the new admin interface changes from Wagtail 3.0 and 4.0 (Thibaud Colas)
 * Ensure all images in the documentation have a suitable alt text (Thibaud Colas)
 * Fix: Ensure tag autocompletion dropdown has a solid background (LB (Ben) Johnston)
 * Fix: Allow inline panels to be ordered (LB (Ben) Johnston)
 * Fix: Only show draft / live status tags on snippets that have `DraftStateMixin` applied (Sage Abdullah)
 * Fix: Prevent JS error when initializing chooser modals with no tabs (LB (Ben) Johnston)
 * Fix: Add missing vertical spacing between chooser modal header and body when there are no tabs (LB (Ben) Johnston)
 * Fix: Reinstate specific labels for chooser buttons (for example 'Choose another page', 'Edit this page' not 'Change', 'Edit') so that it is clearer for users and non-English translations (Matt Westcott)
 * Fix: Resolve issue where searches with a tag and a query param in the image listing would result in an `FilterFieldError` (Stefan Hammer)
 * Fix: Add missing vertical space between header and content in embed chooser modal (LB (Ben) Johnston)
 * Fix: Use the correct type scale for heading levels in rich text (Steven Steinwand)
 * Fix: Update alignment and reveal logic of fields’ comment buttons (Steven Steinwand)
 * Fix: Regression from Markdown conversion in documentation for API configuration - update to correctly use PEP-8 for example code (Storm Heg)
 * Fix: Prevent 'Delete' link on page edit view from redirecting back to the deleted page (LB (Ben) Johnston)
 * Fix: Prevent JS error on images index view when collections dropdown is omitted (Tidiane Dia)
 * Fix: Prevent "Entries per page" dropdown on images index view from reverting to 10 (Tidiane Dia)
 * Fix: Set related_name on user revision relation to avoid conflict with django-reversion (Matt Westcott)
 * Fix: Ensure the "recent edits" panel on the Dashboard (home) page works when page record is missing (Matt Westcott)
 * Fix: Only add Translate buttons when the `simple_translation` app is installed (Dan Braghis)
 * Fix: Ensure that `MultiFieldPanel` correctly outputs all child classnames in the template (Matt Westcott)
 * Fix: Remove over-eager caching on ModelAdmin permission checks (Matt Westcott, Stefan Hammer)


4.0.1 (05.09.2022)
~~~~~~~~~~~~~~~~~~

 * Fix: On the Locked pages report, limit the "locked by" filter to just users who have locked pages (Stefan Hammer)
 * Fix: Prevent JavaScript error when using StreamField on views without commenting support, such as snippets (Jacob Topp-Mugglestone)
 * Fix: Modify base template for new projects so that links opened from the preview panel open in a new window (Sage Abdullah)
 * Fix: Prevent circular import error between custom document models and document chooser blocks (Matt Westcott)


4.0 (31.08.2022)
~~~~~~~~~~~~~~~~

 * Added support for Django 4.1
 * Added a new `BaseGenericSetting` base model class that allows defining a settings model that applies to all sites rather than just a single site (Kyle Bayliss)
 * Add clarity to confirmation when being asked to convert an external link to an internal one (Thijs Kramer)
 * Convert the rest of the documentation to Markdown (Khanh Hoang, Vu Pham, Daniel Kirkham, LB (Ben) Johnston, Thiago Costa de Souza, Benedict Faw, Noble Mittal, Sævar Öfjörð Magnússon, Sandeep M A, Stefano Silvestri)
 * Add `base_url_path` to `ModelAdmin` so that the default URL structure of app_label/model_name can be overridden (Vu Pham, Khanh Hoang)
 * Add `full_url` to the API output of `ImageRenditionField` (Paarth Agarwal)
 * Use `InlinePanel`'s label when available for field comparison label (Sandil Ranasinghe)
 * Drop support for Safari 13 by removing left/right positioning in favor of CSS logical properties (Thibaud Colas)
 * Use `FormData` instead of jQuery's `form.serialize` when editing documents or images just added so that additional fields can be better supported (Stefan Hammer)
 * Add informational Codecov status checks for GitHub CI pipelines (Tom Hu)
 * Replace `PageRevision` with generic `Revision` model (Sage Abdullah)
 * Make it possible to reuse and customize Wagtail’s fonts with CSS variables (LB (Ben) Johnston)
 * Add better handling and informative developer errors for cross linking URLS (e.g. success after add) in generic views `wagtail.admin.views.generic` (Matt Westcott)
 * Introduce `wagtail.admin.widgets.chooser.BaseChooser` to make it easier to build custom chooser inputs (Matt Westcott)
 * Introduce JavaScript chooser module, including a SearchController class which encapsulates the standard pattern of re-rendering the results panel in response to search queries and pagination (Matt Westcott)
 * Migrate Image and Document choosers to new JavaScript chooser module (Matt Westcott)
 * Add ability to select multiple items at once within bulk actions selections when holding shift on subsequent clicks (Hitansh Shah)
 * Upgrade notification, shown to admins on the dashboard if Wagtail is out of date, will now link to the release notes for the closest minor branch instead of the latest patch (Tibor Leupold)
 * Upgrade notification can now be configured to only show updates when there is a new LTS available via `WAGTAIL_ENABLE_UPDATE_CHECK = 'lts'` (Tibor Leupold)
 * Implement redesign of the Workflow Status dialog, fixing accessibility issues (Steven Steinwand)
 * Add the ability to change the number of images displayed per page in the image library (Tidiane Dia, with sponsorship from YouGov)
 * Allow users to sort by different fields in the image library (Tidiane Dia, with sponsorship from YouGov)
 * Add `prefetch_renditions` method to `ImageQueryset` for performance optimization on image listings (Tidiane Dia, Karl Hobley)
 * Add ability to define a custom `get_field_clean_name` method when defining `FormField` models that extend `AbstractFormField` (LB (Ben) Johnston)
 * Migrate Home (Dashboard) view to use generic Wagtail class based view (LB (Ben) Johnston)
 * Combine most of Wagtail’s stylesheets into the global `core.css` file (Thibaud Colas)
 * Add new Breadcrumbs and Tabs to the Wagtail pattern library (Paarth Agarwal)
 * Adopt new Page Editor UI tabs in the workflow history report page (Paarth Agarwal)
 * Update `ReportView` to extend from generic `wagtail.admin.views.generic.models.IndexView` (Sage Abdullah)
 * Introduce a `wagtail.admin.viewsets.chooser.ChooserViewSet` module to serve as a common base implementation for chooser modals (Matt Westcott)
 * Add documentation for `wagtail.admin.viewsets.model.ModelViewSet` (Matt Westcott)
 * Enhance new breadcrumbs so they can be added to any header or container element (Paarth Agarwal)
 * Adopt new breadcrumbs on the page explorer (listing) view and the page chooser modal, remove legacy breadcrumbs code for move page as no longer used (Paarth Agarwal)
 * Added multi-site support to the API (Sævar Öfjörð Magnússon)
 * Add `add_to_admin_menu` option for `ModelAdmin` (Oliver Parker)
 * Implement Fuzzy matching for Elasticsearch (Nick Smith)
 * Rename `Page.get_latest_revision_as_page` to `Page.get_latest_revision_as_object` (Sage Abdullah)
 * Cache model permission codenames in `PermissionHelper` (Tidiane Dia)
 * Selecting a new parent page for moving a page now uses the chooser modal which allows searching (Viggo de Vries)
 * Move `get_snippet_edit_handler` function to `wagtail.admin.panels.get_edit_handler` (Sage Abdullah)
 * Add clarity to the search indexing documentation for how `boost` works when using Postgres with the database search backend (Tibor Leupold)
 * Rename `explorer_breadcrumb` template tag to `breadcrumbs` as it is now used in multiple locations (Paarth Agarwal)
 * Updated `django-filter` version to support 22 (Yuekui)
 * Use `.iterator()` in a few more places in the admin, to make it more stable on sites with many pages (Andy Babic)
 * Migrate some simple React component files to TypeScript (LB (Ben) Johnston)
 * Deprecate the usage and documentation of the `wagtail.contrib.modeladmin.menus.SubMenu` class, provide a warning if used directing developers to use `wagtail.admin.menu.Menu` instead (Matt Westcott)
 * Remove legacy (non-next) breadcrumbs no longer used, remove `ModelAdmin` usage of breadcrumbs completely (Paarth Agarwal)
 * Replace human-readable-date hover pattern with accessible tooltip variant across all of admin (Bernd de Ridder)
 * Added `WAGTAILADMIN_USER_PASSWORD_RESET_FORM` setting for overriding the admin password reset form (Michael Karamuth)
 * Prefetch workflow states in edit page view to avoid queries in other parts of the view/templates that need it (Tidiane Dia)
 * Remove the edit link from edit bird in previews to avoid confusion (Sævar Öfjörð Magnússon)
 * Introduce new template fragment and block level enclosure tags for easier template composition (Thibaud Colas)
 * Add a `classnames` template tag to easily build up classes from variables provided to a template (Paarth Agarwal)
 * Migrate the dashboard (home) view header to the shared header template and update designs (Paarth Agarwal)
 * Switch all report workflow, redirects, form submissions, site settings views to use Wagtail’s reusable header component (Paarth Agarwal)
 * Update classes and styles for the shared header templates to align with UI guidelines (Paarth Agarwal)
 * Clean up multiple eslint rules usage and configs to align better with the Wagtail coding guidelines (LB (Ben Johnston))
 * Add inline toolbar for Draftail, to avoid clashing with the page’s header (Thibaud Colas)
 * Add command palette in rich text editor to change text format with the keyboard only (Thibaud Colas)
 * Add a live-updating character count to the Draftail rich text editor (Thibaud Colas)
 * Add rich text editor paste to auto-create links (Thibaud Colas)
 * Add rich text editor text shortcuts undo, to allow typing text normally detected as a shortcut (Thibaud Colas)
 * Add support for right-to-left (RTL) languages to the rich text editor (Thibaud Colas)
 * Change rich text editor placeholder to follow the user’s focus on empty blocks (Thibaud Colas)
 * Add rich text editor empty block highlight by showing their block type (Thibaud Colas)
 * Add ability to split a rich text field and insert a StreamField block at the same time (Jacob Topp-Mugglestone)
 * Make `ModelAdmin` `InspectView` footer actions consistent with other parts of the UI (Thibaud Colas)
 * Introduce a new auto-updating preview panel inside the page editor (Sage Abdullah)
 * Add support for Twitter and other text-only embeds in Draftail embed previews (Iman Syed, Paarth Agarwal)
 * Use new modal dialog component for privacy settings modal (Sage Abdullah)
 * Add `menu_item_name` to modify `MenuItem`'s name for `ModelAdmin` (Alexander Rogovskyy, Vu Pham)
 * Add an extra confirmation prompt when deleting pages with a large number of child pages (Jaspreet Singh)
 * Adopt the slim header in page listing views, with buttons moved under the "Actions" dropdown, including addition of translation page in the parent "more" button (Paarth Agarwal)
 * Improve help block styles in Windows High Contrast Mode with less reliance on communication via color alone (Anuja Verma)
 * Add a bottom border to top messages so they stand out from the header (Anuja Verma)
 * Replace latin abbreviations (i.e. / e.g.) with common English phrases so that documentation is easier to understand (Dominik Lech)
 * Add shortcut for accessing StreamField blocks by block name with new `blocks_by_name` and `first_block_by_name` methods on `StreamValue` (Tidiane Dia, Matt Westcott)
 * Extend support for custom user interface colors across almost all admin colors (Thibaud Colas)
 * Add HTML-aware max_length validation and character count on RichTextField and RichTextBlock (Matt Westcott, Thibaud Colas)
 * Remove undocumented `SearchableListMixin` (Sage Abdullah)
 * Extract filtering code from ReportView to generic IndexView (Sage Abdullah)
 * Extract unpublish code for pages to generic UnpublishView (Sage Abdullah)
 * Retain other query params in header search behavior (Sage Abdullah)
 * Remove `is_parent` kwarg in various page button hooks as this approach is no longer required (Paarth Agarwal)
 * Improve security of redirect imports by adding a file hash (signature) check for so that any tampering of file contents between requests will throw a `BadSignature` error (Jaap Roes)
 * Refresh designs for Home (Dashboard) site summary panels, use theme spacing and colors, add support for RTL layouts and better support for small devices (Paarth Agarwal, LB (Ben) Johnston)
 * Include all CSS system colors in allowed values in Stylelint's declaration-strict-value rule (Thibaud Colas)
 * Add JavaScript `range` utility function (LB (Ben) Johnston)
 * Allow generic chooser viewsets to support non-model data such as an API endpoint (Matt Westcott)
 * Update all widget styles across the admin UI (Thibaud Colas)
 * Update field styles across forms, with help text consistently under fields, error messages above, and comment buttons to the side (Thibaud Colas)
 * Make all sections of the page editing UI collapsible by default (Thibaud Colas)
 * Update the side panels to prevent overlap with form fields unless necessary (Thibaud Colas)
 * Remove unused change password page, was not removed when account management view was converted to tabs (Paarth Agarwal)
 * Rework layout of login and password reset pages to ensure `main` id on main element (for skip link) and consistent DOM layout for h1 header (Paarth Agarwal, LB (Ben) Johnston)
 * Adopt new design, including logo, for login and password reset pages (Paarth Agarwal, LB (Ben) Johnston)
 * Remove usage of inline script to focus on the username field, instead use `autofocus` (LB (Ben) Johnston)
 * Improve organization of the settings reference page in the documentation (Akash Kumar Sen)
 * Added `path` and `re_path` decorators to the `RoutablePageMixin` module which emulate their Django URL utils equivalent, redirect `re_path` to the original `route` decorator (Tidiane Dia)
 * `BaseChooser` widget now provides a Telepath adapter that's directly usable for any subclasses that use the chooser widget and modal JS as-is with no customizations (Matt Westcott)
 * Implement the new chooser widget styles as part of the page editor redesign (Thibaud Colas)
 * Update base Draftail/TextField form designs as part of the page editor redesign (Thibaud Colas)
 * Move commenting trigger to inline toolbar and move block splitting to the block toolbar and command palette only in Draftail (Thibaud Colas)
 * Pages are now locked when they are scheduled for publishing (Karl Hobley)
 * Simplify page chooser views by converting to class-based views (Matt Westcott)
 * Add support for previews, revisions and drafts on snippets (Sage Abdullah)
 * Add "Translate" button within pages’ Actions dropdown when editing pages (Sage Abdullah)
 * Add translated labels to the bulk actions tags and collections bulk update fields (Stefan Hammer)
 * Add bulk actions support for snippet listings (Shohan Dutta Roy)
 * Fix: Typo in `ResumeWorkflowActionFormatter` message (Stefan Hammer)
 * Fix: Issue where `ModelAdmin` index listings with export list enabled would show buttons with an incorrect layout (Josh Woodcock)
 * Fix: Throw a meaningful error when saving an image to an unrecognized image format (Christian Franke)
 * Fix: Remove extra padding for headers with breadcrumbs on mobile viewport (Steven Steinwand)
 * Fix: Ensure that custom document or image models support custom tag models (Matt Westcott)
 * Fix: Ensure comments use translated values for their placeholder text (Stefan Hammer)
 * Fix: Ensure the upgrade notification, shown to admins on the dashboard if Wagtail is out of date, content is translatable (LB (Ben) Johnston)
 * Fix: Show the re-ordering option to users that have permission to publish pages within the page listing (Stefan Hammer)
 * Fix: Ensure default sidebar branding (bird logo) is not cropped in RTL mode (Steven Steinwand)
 * Fix: Add an accessible label to the image focal point input when editing images (Lucie Le Frapper)
 * Fix: Remove unused header search JavaScript on the redirects import page (LB (Ben) Johnston)
 * Fix: Ensure non-square avatar images will correctly show throughout the admin (LB (Ben) Johnston)
 * Fix: Ignore translations in test files and re-include some translations that were accidentally ignored (Stefan Hammer)
 * Fix: Show alternative message when no page types are available to be created (Jaspreet Singh)
 * Fix: Prevent error on sending notifications for the legacy moderation process when no user was specified (Yves Serrano)
 * Fix: Ensure `aria-label` is not set on locale selection dropdown within page chooser modal as it was a duplicate of the button contents (LB (Ben Johnston))
 * Fix: Revise the `ModelAdmin` title column behavior to only link to 'edit' if the user has the correct permissions, fallback to the 'inspect' view or a non-clickable title if needed (Stefan Hammer)
 * Fix: Ensure that `DecimalBlock` preserves the `Decimal` type when retrieving from the database (Yves Serrano)
 * Fix: When no snippets are added, ensure the snippet chooser modal would have the correct URL for creating a new snippet (Matt Westcott)
 * Fix: `ngettext` in Wagtail's internal JavaScript internationalization utilities now works (LB (Ben) Johnston)
 * Fix: Ensure the linting/formatting npm scripts work on Windows (Anuja Verma)
 * Fix: Fix display of dates in exported xlsx files on macOS Preview and Numbers (Jaap Roes)
 * Fix: Make progress bars’ progress visible in forced colors mode (Anuja Verma)
 * Fix: Make checkboxes visible in forced colors mode (Anuja Verma)
 * Fix: Display the correct color for icons in forced colors mode (Anuja Verma)
 * Fix: Add a border around modal dialogs so they can be identified in forced colors mode (Anuja Verma)
 * Fix: Remove outdated reference to 30-character limit on usernames in help text (minusf)
 * Fix: Resolve multiple form submissions index listing page layout issues including title not being visible on mobile and interaction with large tables (Paarth Agarwal)
 * Fix: Ensure `ModelAdmin` single selection lists show correctly with Django 4.0 form template changes (Coen van der Kamp)
 * Fix: Ensure icons within help blocks have accessible contrasting colors, and links have a darker color plus underline to indicate they are links (Paarth Agarwal)
 * Fix: Ensure consistent sidebar icon position whether expanded or collapsed (Scott Cranfill)
 * Fix: Avoid redirects import error if the file has lots of columns (Jaap Roes)
 * Fix: Resolve accessibility and styling issues with the expanding status panel (Sage Abdullah)
 * Fix: Avoid 503 `AttributeError` when an empty search param `q=` is combined with other filters in the Images index view (Paritosh Kabra)
 * Fix: Fix error with string representation of FormSubmission not returning a string (LB (Ben) Johnston)
 * Fix: Ensure disabled buttons are distinguishable from active buttons in forced colors mode (Anuja Verma)
 * Fix: Revise usage of `extra_actions` in new changes to shared header template to avoid invalid template variable usage (Paarth Agarwal)
 * Fix: Ensure that bulk actions correctly support models with non-integer primary keys (id) (LB (Ben) Johnston)
 * Fix: Make it possible to toggle collapsible panels in the edit UI with the keyboard (Thibaud Colas)
 * Fix: Re-implement checkbox styles so the checked state is visible in forced colors mode (Thibaud Colas)
 * Fix: Re-implement switch component styles so the checked state is visible in forced colors mode (Thibaud Colas)
 * Fix: Always render select widgets consistently regardless of where they are in the admin (Thibaud Colas)
 * Fix: Make sure input labels and always take up the available space (Thibaud Colas)
 * Fix: Correctly style BooleanBlock within StructBlock (Thibaud Colas)
 * Fix: Make sure comment icons can’t overlap with help text (Thibaud Colas)
 * Fix: Make it possible to scroll input fields in admin on safari mobile (Thibaud Colas)
 * Fix: Stop rich text fields from overlapping with sidebar (Thibaud Colas)
 * Fix: Prevent comment buttons from overlapping with fields (Thibaud Colas)
 * Fix: Resolve MySQL search compatibility issue with Django 4.1 (Andy Chosak)
 * Fix: Ensure that the fields on login and password reset forms are visible in forced colors mode (Paarth Agarwal)
 * Fix: Missing a outline on dropdown content and malformed tooltip arrow in forced colors mode (Anuja Verma, LB (Ben) Johnston)
 * Fix: Layout issues with reports (including form submissions listings) on md device widths (Akash Kumar Sen, LB (Ben) Johnston)
 * Fix: Layout issue with page explorer's inner header item on small device widths (Akash Kumar Sen)
 * Fix: Ensure that `BaseSiteSetting` / `BaseGenericSetting` objects can be pickled (Andy Babic)
 * Fix: Ensure `DocumentChooserBlock` can be deconstructed for migrations (Matt Westcott)
 * Fix: Resolve frontend console error and unintended console logging issues (Matt Westcott, Paarth Agarwal)
 * Fix: Resolve issue with sites that have not yet migrated away from `BaseSetting` when upgrading to Wagtail 4.0 (Stefan Hammer)
 * Fix: Use correct classnames for showing/hiding edit button on chooser widget (Matt Westcott)
 * Fix: Render MultiFieldPanel’s heading even when nested (Thibaud Colas)
 * Fix: Make sure select widgets render correctly regardless of the Django field and widget type (Thibaud Colas)
 * Fix: Consistently display boolean field labels above the widget so they render correctly (Thibaud Colas)
 * Fix: Address form field label alignment issues by always displaying labels above the widget (Thibaud Colas)
 * Fix: Make sure rich text URL editing tooltip is fully visible when displayed inside InlinePanel blocks (Thibaud Colas)
 * Fix: Allow input fields to scroll horizontally in Safari iOS (Thibaud Colas)
 * Fix: Ensure screen readers are made aware of page level messages added dynamically to the top of the page (Paarth Agarwal)
 * Fix: Fix `updatemodulepaths` command for Python 3.7 (Matt Westcott)
 * Fix: Only show locale filter in choosers when i18n is enabled in settings (Matt Westcott)
 * Fix: Ensure that the live preview panel correctly clears the cache when a new page is created (Sage Abdullah)
 * Fix: Ensure that there is a larger hoverable area for add block (+) within the Draftail editor (Steven Steinwand)
 * Fix: Resolve multiple header styling issues for modal, alignment on small devices, outside click handling target on medium devices, close button target size and hover styles (Paarth Agarwal)
 * Fix: Fix issue where comments could not be added in StreamField that were already saved (Jacob Topp-Mugglestone)
 * Fix: Remove outdated reference to Image.LoaderError (Matt Westcott)


3.0.3 (05.09.2022)
~~~~~~~~~~~~~~~~~~

 * Fix: On the Locked pages report, limit the "locked by" filter to just users who have locked pages (Stefan Hammer)
 * Fix: Prevent JavaScript error when using StreamField on views without commenting support, such as snippets (Jacob Topp-Mugglestone)


3.0.2 (30.08.2022)
~~~~~~~~~~~~~~~~~~

 * Fix: Ensure string representation of `FormSubmission` returns a string (LB (Ben Johnston))
 * Fix: Fix `updatemodulepaths` command for Python 3.7 (Matt Westcott)
 * Fix: Fix issue where comments could not be added in StreamField that were already saved (Jacob Topp-Mugglestone)
 * Fix: Remove outdated reference to Image.LoaderError (Matt Westcott)


3.0.1 (16.06.2022)
~~~~~~~~~~~~~~~~~~

 * Add warning when `WAGTAILADMIN_BASE_URL` is not configured (Matt Westcott)
 * Fix: Ensure `TabbedInterface` will not show a tab if no panels are visible due to permissions (Paarth Agarwal)
 * Fix: Specific snippets list language picker was not properly styled (Sage Abdullah)
 * Fix: Ensure the upgrade notification request for the latest release, which can be disabled via the `WAGTAIL_ENABLE_UPDATE_CHECK` sends the referrer origin with `strict-origin-when-cross-origin` (Karl Hobley)
 * Fix: Fix misaligned spinner icon on page action button (LB (Ben Johnston))
 * Fix: Ensure radio buttons / checkboxes display vertically under Django 4.0 (Matt Westcott)
 * Fix: Prevent failures when splitting blocks at the start or end of a block, or with highlighted text (Jacob Topp-Mugglestone)
 * Fix: Allow scheduled publishing to complete when the initial editor did not have publish permission (Matt Westcott)
 * Fix: Stop emails from breaking when `WAGTAILADMIN_BASE_URL` is absent due to the request object not being available (Matt Westcott)
 * Fix: Make try/except on sending email less broad so that legitimate template rendering errors are exposed (Matt Westcott)


3.0 (16.05.2022)
~~~~~~~~~~~~~~~~

 * Phase out special-purpose panel types (`StreamFieldPanel`, `RichTextFieldPanel`, `ImageChooserPanel`, `DocumentChooserPanel`, `PageChooserPanel`, `SnippetChooserPanel`) in favor of `FieldPanel` (Matt Westcott)
 * Implement splitting of rich text blocks within StreamField (Jacob Topp-Mugglestone)
 * Add support for image rendition prefetching (Andy Babic)
 * Upgrade ESLint and Stylelint configurations to latest shared Wagtail configs (Thibaud Colas, Paarth Agarwal)
 * Major updates to frontend tooling; move Node tooling from Gulp to Webpack, upgrade to Node v16 and npm v8, eslint v8, stylelint v14 and others (Thibaud Colas)
 * Change comment headers’ date formatting to use browser APIs instead of requiring a library (LB (Ben Johnston))
 * Lint with flake8-comprehensions and flake8-assertive, including adding a pre-commit hook for these (Mads Jensen, Dan Braghis)
 * Switch the Wagtail branding font to a system font stack (Steven Steinwand, Paarth Agarwal)
 * Add black configuration and reformat code using it (Dan Braghis)
 * Remove UI code for legacy browser support: polyfills, IE11 workarounds, Modernizr (Thibaud Colas)
 * Remove redirect auto-creation recipe from documentation as this feature is now supported in Wagtail core (Andy Babic)
 * Remove IE11 warnings (Gianluca De Cola)
 * Remove the legacy Hallo rich text editor as it has moved to an external package (LB (Ben Johnston))
 * Increase the size of checkboxes throughout the UI, and simplify their alignment (Steven Steinwand)
 * Adopt [MyST](https://myst-parser.readthedocs.io/en/latest/) for parsing documentation written in Markdown, replaces recommonmark (LB (Ben Johnston), Thibaud Colas)
 * Installing docs extras requirements in CircleCI so issues with the docs requirements are picked up earlier (Thibaud Colas)
 * Remove core usage of jinjalint and migrate to curlylint to resolve dependency incompatibility issues (Thibaud Colas)
 * Switch focus outlines implementation to `:focus-visible` for cross-browser consistency (Paarth Agarwal)
 * Remove most uppercased text styles from admin UI (Paarth Agarwal)
 * Convert all UI code to CSS logical properties for Right-to-Left (RTL) language support (Thibaud Colas)
 * Migrate multiple documentation pages from RST to MD - including the editor's guide (Vibhakar Solanki, LB (Ben Johnston), Shwet Khatri)
 * Add documentation for defining custom form validation on models used in Wagtail's `modelAdmin` (Serafeim Papastefanos)
 * Update `README.md` logo to work for GitHub dark mode (Paarth Agarwal)
 * Avoid an unnecessary page reload when pressing enter within the header search bar (Images, Pages, Documents) (Riley de Mestre)
 * Removed unofficial length parameter on `If-Modified-Since` header in `sendfile_streaming_backend` which was only used by IE (Mariusz Felisiak)
 * Add Pinterest support to the list of default oEmbed providers (Dharmik Gangani)
 * Update Jinja2 template support for Jinja2 3.x (Seb Brown)
 * Add ability for `StreamField` to use `JSONField` to store data, rather than `TextField` (Sage Abdullah)
 * Replace `content_json` `TextField` with `content` `JSONField` in `PageRevision` (Sage Abdullah)
 * Remove `replace_text` management command (Sage Abdullah)
 * Replace `data_json` `TextField` with `data` `JSONField` in `BaseLogEntry` (Sage Abdullah)
 * Split up linting / formatting tasks in Makefile into client and server components (Hitansh Shah)
 * Add support for embedding Instagram reels (Luis Nell)
 * Use Django’s JavaScript catalog feature to manage translatable strings in JavaScript (Karl Hobley)
 * Add a `page_description` to the Page model, to provide help text for a given page type (Kalob Taulien, Thibaud Colas, Matt Westcott, Stefan Hammer)
 * Add `trimmed` attribute to all blocktrans tags, so spacing is more reliable in translated strings (Harris Lapiroff)
 * Add documentation that describes how to use `ModelAdmin` to manage `Tag`s (Abdulmajeed Isa)
 * Rename the setting `BASE_URL` (undocumented) to `WAGTAILADMIN_BASE_URL` and add to documentation, `BASE_URL` will be removed in a future release (Sandil Ranasinghe)
 * Validate to and from email addresses within form builder pages when using `AbstractEmailForm` (Jake Howard)
 * Add `WAGTAILIMAGES_RENDITION_STORAGE` setting to allow an alternative image rendition storage (Heather White)
 * Add `wagtail_update_image_renditions` management command to regenerate image renditions or purge all existing renditions (Hitansh Shah, Onno Timmerman, Damian Moore)
 * Fully remove the legacy sidebar, with slim sidebar replacing it for all users (Thibaud Colas)
 * Add support for adding custom attributes for link menu items in the slim sidebar (Thibaud Colas)
 * Implement new slim page editor header with breadcrumb (Steven Steinwand, Karl Hobley)
 * Add the ability for choices to be separated by new lines instead of just commas within the form builder, commas will still be supported if used (Abdulmajeed Isa)
 * Add internationalisation UI to modeladmin (Andrés Martano)
 * Support chunking in `PageQuerySet.specific()` to reduce memory consumption (Andy Babic)
 * Implement new tabs design across the admin interface (Steven Steinwand)
 * Move page meta information from the header to a new status side panel component inside of the page editing UI (Steven Steinwand, Karl Hobley)
 * Add useful help text to Tag fields to advise what content is allowed inside tags, including when `TAG_SPACES_ALLOWED` is `True` or `False` (Abdulmajeed Isa)
 * Change `AbstractFormSubmission`'s `form_data` to use JSONField to store form submissions (Jake Howard)
 * Add image duplicate detection on upload (Tidiane Dia, with sponsorship from The Motley Fool)
 * Add a system font stack for monospace fonts (Rishank Kanaparti)
 * Fix: When using `simple_translations` ensure that the user is redirected to the page edit view when submitting for a single locale (Mitchel Cabuloy)
 * Fix: When previewing unsaved changes to `Form` pages, ensure that all added fields are correctly shown in the preview (Joshua Munn)
 * Fix: When Documents (e.g. PDFs) have been configured to be served inline via `WAGTAILDOCS_CONTENT_TYPES` & `WAGTAILDOCS_INLINE_CONTENT_TYPES` ensure that the filename is correctly set in the `Content-Disposition` header so that saving the files will use the correct filename (John-Scott Atlakson)
 * Fix: Improve the contrast of the “Remember me” checkbox against the login page’s background (Steven Steinwand)
 * Fix: Group permission rows with custom permissions no longer have extra padding (Steven Steinwand)
 * Fix: Make sure the focus outline of checkboxes is fully around the outer border (Steven Steinwand)
 * Fix: Consistently set `aria-haspopup="menu"` for all sidebar menu items that have sub-menus (LB (Ben Johnston))
 * Fix: Make sure `aria-expanded` is always explicitly set as a string in sidebar (LB (Ben Johnston))
 * Fix: Use a button element instead of a link for page explorer menu item, for the correct semantics and behaviour (LB (Ben Johnston))
 * Fix: Make sure the “Title” column label can be translated in the page chooser and page move UI (Stephanie Cheng Smith)
 * Fix: Remove redundant `role="main"` attributes on `<main>` elements causing HTML validation issues (Luis Espinoza)
 * Fix: Allow bulk publishing of pages without revisions (Andy Chosak)
 * Fix: Stop skipping heading levels in Wagtail welcome page (Jesse Menn)
 * Fix: Add missing `lang` attributes to `<html>` elements (James Ray)
 * Fix: Avoid 503 server error when entering tags over 100chars and instead show a user facing validation error (Vu Pham, Khanh Hoang)
 * Fix: Ensure `thumb_col_header_text` is correctly used by `ThumbnailMixin` within `ModelAdmin` as the column header label (Kyle J. Roux)
 * Fix: Page copy in Wagtail admin ignores `exclude_fields_in_copy` (John-Scott Atlakson)
 * Fix: Translation key `IntegrityError` when publishing pages with translatable `Orderable`s that were copied without being published (Kalob Taulien, Dan Braghis)
 * Fix: Ignore `GenericRelation` when copying pages (John-Scott Atlakson)
 * Fix: Implement ARIA tabs markup and keyboards interactions for admin tabs (Steven Steinwand)
 * Fix: Ensure `wagtail updatemodulepaths` works when system locale is not UTF-8 (Matt Westcott)
 * Fix: Re-establish focus trap for Pages explorer in slim sidebar (Thibaud Colas)
 * Fix: Ensure the icon font loads correctly when `STATIC_URL` is not `"/static/"` (Jacob Topp-Mugglestone)


2.16.3 (05.09.2022)
~~~~~~~~~~~~~~~~~~~

 * Fix: Ensure the upgrade notification request for the latest release, which can be disabled via the `WAGTAIL_ENABLE_UPDATE_CHECK` sends the referrer origin with `strict-origin-when-cross-origin` (Karl Hobley)
 * Fix: On the Locked pages report, limit the "locked by" filter to just users who have locked pages (Stefan Hammer)
 * Fix: Ensure Python 3.10 compatibility when using Elasticsearch backend (Przemysław Buczkowski, Matt Westcott)


2.16.2 (11.04.2022)
~~~~~~~~~~~~~~~~~~~

 * Fix: Update django-treebeard dependency to 4.5.1 or above (Serafeim Papastefanos)
 * Fix: Fix permission error when sorting pages having page type restrictions (Thijs Kramer)
 * Fix: Allow bulk publishing of pages without revisions (Andy Chosak)
 * Fix: Ensure that all descendant pages are logged when deleting a page, not just immediate children (Jake Howard)
 * Fix: Refactor `FormPagesListView` in wagtail.contrib.forms to avoid undefined `locale` variable when subclassing (Dan Braghis)
 * Fix: Page copy in Wagtail admin ignores `exclude_fields_in_copy` (John-Scott Atlakson)
 * Fix: Translation key `IntegrityError` when publishing pages with translatable `Orderable`s that were copied without being published (Kalob Taulien, Dan Braghis)
 * Fix: Ignore `GenericRelation` when copying pages (John-Scott Atlakson)
 * Fix: Ensure 'next' links from image / document listings do not redirect back to partial AJAX view (Matt Westcott)
 * Fix: Skip creation of automatic redirects when page cannot be routed (Matt Westcott)
 * Fix: Prevent JS errors on locale switcher in page chooser (Matt Westcott)


2.16.1 (11.02.2022)
~~~~~~~~~~~~~~~~~~~

 * Fix: Ensure that correct sidebar submenus open when labels use non-Latin alphabets (Matt Westcott)
 * Fix: Fix issue where invalid bulk action URLs would incorrectly trigger a server error (500) instead of a valid not found (404) (Ihor Marhitych)
 * Fix: Fix issue where bulk actions would not work for object IDs greater than 999 when `USE_THOUSAND_SEPARATOR` (Dennis McGregor)
 * Fix: Set cookie for sidebar collapsed state to "SameSite: lax" (LB (Ben Johnston))
 * Fix: Prevent error on creating automatic redirects for sites with non-standard ports (Matt Westcott)
 * Fix: Restore ability to customize admin UI colors via CSS (LB (Ben Johnston))


2.16 (07.02.2022)
~~~~~~~~~~~~~~~~~

 * Added support for Django 4.0
 * Removed support for Django 3.0 and 3.1
 * Removed support for Python 3.6
 * Added persistent IDs for ListBlock items, allowing commenting and improvements to revision comparisons (Matt Westcott, Tidiane Dia, with sponsorship from [NHS](https://www.nhs.uk/))
 * Added Aging Pages report (Tidiane Dia)
 * Added automatic redirect creation feature (Andy Babic, with sponsorship from [The National Archives](https://www.nationalarchives.gov.uk))
 * Added `page_slug_changed` signal for pages (Andy Babic)
 * Add more SketchFab oEmbed patterns for models (Tom Usher)
 * Add collapse option to `StreamField`, `StreamBlock`, and `ListBlock` which will load all sub-blocks initially collapsed (Matt Westcott)
 * Private pages can now be fetched over the API (Nabil Khalil)
 * Added `alias_of` field to the pages API (Dmitrii Faiazov)
 * Add support for Azure CDN and Front Door front-end cache invalidation (Tomasz Knapik)
 * Improved styling of workflow timeline modal view (Tidiane Dia)
 * Add secondary actions menu in edit page headers (Tidiane Dia)
 * Removed WOFF fonts
 * Add system check for missing core Page fields in `search_fields` (LB (Ben Johnston))
 * Improve CircleCI frontend & backend build caches, add automated browser accessibility test suite in CircleCI (Thibaud Colas)
 * Add a 'remember me' checkbox to the admin sign in form, if unticked (default) the auth session will expire if the browser is closed (Michael Karamuth, Jake Howard)
 * When returning to image or document listing views after editing, filters (collection or tag) are now remembered (Tidiane Dia)
 * Improve the visibility of field error messages, in Windows high-contrast mode and out (Jason Attwood)
 * Improve implementations of visually-hidden text in explorer and main menu toggle (Martin Coote)
 * Add locale labels to page listings (Dan Braghis)
 * Add locale labels to page reports (Dan Braghis)
 * Change release check domain to releases.wagtail.org (Jake Howard)
 * Add the user who submitted a page for moderation to the "Awaiting your review" homepage summary panel (Tidiane Dia)
 * When moving pages, default to the current parent section (Tidiane Dia)
 * `admin/expanding_formset.js` has been renamed to `admin/expanding-formset.js` (LB (Ben Johnston))
 * Change docs URL to docs.wagtail.org (Jake Howard)
 * Update links to wagtail.io to point to new domain wagtail.org (Jake Howard)
 * Add borders to TypedTableBlock to help visualize rows and columns (Scott Cranfill)
 * Set default submit button label on generic create views to 'Create' instead of 'Save' (Matt Westcott)
 * Improve display of image listing for long image titles (Krzysztof Jeziorny)
 * Use SVG icons in admin home page site summary items (Jérôme Lebleu)
 * Ensure site summary items wrap on smaller devices on the admin home page (Jérôme Lebleu)
 * Rework Workflow task chooser modal to align with other chooser modals, using consistent pagination and leveraging class based views (Matt Westcott)
 * Implemented a locale switcher on the forms listing page in the admin (Dan Braghis)
 * Implemented a locale switcher on the page chooser modal (Dan Braghis)
 * Implemented the `wagtail_site` template tag for Jinja2 (Vladimir Tananko)
 * Change webmaster to website administrator in the admin (Naomi Morduch Toubman)
 * Added documentation for creating custom submenus in the admin menu (Sævar Öfjörð Magnússon)
 * Choice blocks in StreamField now show label rather than value when collapsed (Jérôme Lebleu)
 * Added documentation to clarify configuration of user-uploaded files (Cynthia Kiser)
 * Change security contact address to security@wagtail.org (Jake Howard)
 * Fix: Accessibility fixes for Windows high contrast mode; Dashboard icons color and contrast, help/error/warning blocks for fields and general content, side comment buttons within the page editor, dropdown buttons (Sakshi Uppoor, Shariq Jamil, LB (Ben Johnston), Jason Attwood)
 * Fix: Rename additional 'spin' CSS animations to avoid clashes with other libraries (Kevin Gutiérrez)
 * Fix: `default_app_config` deprecations for Django >= 3.2 (Tibor Leupold)
 * Fix: Refresh page from database on create before passing to hooks. Page aliases get correct `first_published_date` and `last_published_date` (Dan Braghis)
 * Fix: Additional login form fields from `WAGTAILADMIN_USER_LOGIN_FORM` are now rendered correctly (Michael Karamuth)
 * Fix: Icon only button styling issue on small devices where height would not be set correctly (Vu Pham)
 * Fix: Add padding to the Draftail editor to ensure `ol` items are not cut off (Khanh Hoang)
 * Fix: Prevent opening choosers multiple times for Image, Page, Document, Snippet (LB (Ben Johnston))
 * Fix: Ensure subsequent changes to styles files are picked up by Gulp watch (Jason Attwood)
 * Fix: Ensure that programmatic page moves are correctly logged as 'move' and not 'reorder' in some cases (Andy Babic)
 * Fix: Add missing translation usage in Workflow templates (Anuja Verma, Saurabh Kumar)


2.15.6 (05.09.2022)
~~~~~~~~~~~~~~~~~~~

 * Fix: Ensure the upgrade notification request for the latest release, which can be disabled via the `WAGTAIL_ENABLE_UPDATE_CHECK` sends the referrer origin with `strict-origin-when-cross-origin` (Karl Hobley)
 * Fix: On the Locked pages report, limit the "locked by" filter to just users who have locked pages (Stefan Hammer)
 * Fix: Ensure Python 3.10 compatibility when using Elasticsearch backend (Przemysław Buczkowski, Matt Westcott)


2.15.5 (11.04.2022)
~~~~~~~~~~~~~~~~~~~

 * Fix: Allow bulk publishing of pages without revisions (Andy Chosak)
 * Fix: Ensure that all descendant pages are logged when deleting a page, not just immediate children (Jake Howard)
 * Fix: Translation key `IntegrityError` when publishing pages with translatable `Orderable`s that were copied without being published (Kalob Taulien, Dan Braghis)
 * Fix: Ignore `GenericRelation` when copying pages (John-Scott Atlakson)


2.15.4 (11.02.2022)
~~~~~~~~~~~~~~~~~~~

 * Fix: Fix issue where invalid bulk action URLs would incorrectly trigger a server error (500) instead of a valid not found (404) (Ihor Marhitych)
 * Fix: Fix issue where bulk actions would not work for object IDs greater than 999 when `USE_THOUSAND_SEPARATOR` (Dennis McGregor)
 * Fix: Fix syntax when logging image rendition generation (Jake Howard)


2.15.3 (26.01.2022)
~~~~~~~~~~~~~~~~~~~

 * Fix: Implement correct check for SQLite installations without full-text search support (Matt Westcott)


2.15.2 (18.01.2022)
~~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2022-21683 - Comment reply notifications sent to incorrect users (Ihor Marhitych, Jacob Topp-Mugglestone)
 * Fix: Transform operations in Filter.run() when image has been re-oriented (Justin Michalicek)
 * Fix: Remove extraneous header action buttons when creating or editing workflows and tasks (Matt Westcott)
 * Fix: Ensure that bulk publish actions pick up the latest draft revision (Matt Westcott)
 * Fix: Ensure the `checkbox_aria_label` is used correctly in the Bulk Actions checkboxes (Vu Pham)
 * Fix: Prevent error on MySQL search backend when searching three or more terms (Aldán Creo)
 * Fix: Allow wagtail.search app migrations to complete on versions of SQLite without full-text search support (Matt Westcott)
 * Fix: Update Pillow dependency to allow 9.x (Matt Westcott)


2.15.1 (11.11.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Fix syntax when logging image rendition generation (Jake Howard)
 * Fix: Increase version range for django-filter dependency (Serafeim Papastefanos)
 * Fix: Prevent bulk action checkboxes from displaying on page reports and other non-explorer listings (Matt Westcott)
 * Fix: Fix errors on publishing pages via bulk actions (Matt Westcott)
 * Fix: Fix `csrf_token` issue when using the Approve or Unlock buttons on pages on the Wagtail admin home (Matt Westcott)


2.15 LTS (04.11.2021)
~~~~~~~~~~~~~~~~~~~~~

 * Implemented a new database search backend that supports the FTS features of the database in use (Developed by Aldán Creo. Mentored by Karl Hobley and Cynthia Kiser. Funded by Google Summer of Code)
 * Added bulk actions in the Wagtail Admin for Pages, Users, Images and Documents (Developed by Shohan Dutta Roy. Mentored by Dan Braghis, Jacob Topp-Mugglestone, and Storm Heg.)
 * Extended audit logging to all models and added a history view for snippets and ModelAdmin (Matt Westcott. Sponsored by The Motley Fool)
 * Allow granting collection management permissions over individual collections (Cynthia Kiser)
 * Added `TypedTableBlock` block type for StreamField, for building tables with mixed data types (Matt Westcott, Coen van der Kamp, Scott Cranfill. Sponsored by YouGov)
 * Add the ability for the page chooser to convert external urls that match a page to internal links (Jacob Topp-Mugglestone. Sponsored by The Motley Fool)
 * Added "Extending Wagtail" section to documentation (Matt Westcott)
 * Introduced template components, a standard mechanism for renderable objects in the admin (Matt Westcott)
 * Support `min_num` / `max_num` options on ListBlock (Matt Westcott)
 * Implemented automatic tree synchronization for `contrib.simple_translation` (Mitchel Cabuloy)
 * Added a `background_position_style` property to renditions (Karl Hobley)
 * Added a distinct `wagtail.copy_for_translation` log action type (Karl Hobley)
 * Add a debug logger around image rendition generation (Jake Howard)
 * Convert Documents and Images to class based views for easier overriding (Matt Westcott)
 * Isolate admin URLs for Documents and Images search listing results with the name `'listing_results'` (Matt Westcott)
 * Removed `request.is_ajax()` usage in Documents, Image and Snippet views (Matt Westcott)
 * Simplify generic admin view templates plus ensure `page_title` and `page_subtitle` are used consistently (Matt Westcott)
 * Extend support for collapsing edit panels from just MultiFieldPanels to all kinds of panels (Fabien Le Frapper, Robbie Mackay)
 * Add object count to header within modeladmin listing view (Jonathan "Yoni" Knoll)
 * Add ability to return HTML in multiple image upload errors (Gordon Pendleton)
 * Upgrade internal JS tooling; Node v14 plus other smaller package upgrades (LB (Ben Johnston))
 * Add support for `non_field_errors` rendering in Workflow action modal (LB (Ben Johnston))
 * Support calling `get_image_model` and `get_document_model` at import time (Matt Westcott)
 * When copying a page, default the 'Publish copied page' field to false (Justin Slay)
 * Open Preview and Live page links in the same tab, except where it would interrupt editing a Page (Sagar Agarwal)
 * Added `ExcelDateFormatter` to `wagtail.admin.views.mixins` so that dates in Excel exports will appear in the locale's `SHORT_DATETIME_FORMAT` (Andrew Stone)
 * Add TIDAL support to the list of oEmbed providers (Wout De Puysseleir)
 * Add `label_format` attribute to customize the label shown for a collapsed StructBlock (Matt Westcott)
 * User Group permissions will now show all custom object permissions in one row instead of a separate table (Kamil Marut)
 * Create `ImageFileMixin` to extract shared file handling methods from `AbstractImage` and `AbstractRendition` (Fabien Le Frapper)
 * Add `before_delete_page` and `register_permissions` examples to Hooks documentation (Jane Liu, Daniel Fairhead)
 * Add clarity to modeladmin template override behavior in the documentation (Joe Howard, Dan Swain)
 * Add section about CSV exports to security documentation (Matt Westcott)
 * Add initial support for Django 4.0 deprecations (Matt Westcott, Jochen Wersdörfer)
 * Move translations in `nl_NL` to `nl` (Loïc Teixeira, Coen van der Kamp)
 * Add documentation for how to redirect to a separate page on Form builder submissions using ``RoutablePageMixin`` (Nick Smith)
 * Refactored index listing views and made column sort-by headings more consistent (Matt Westcott)
 * The title field on Image and Document uploads will now default to the filename without the file extension and this behavior can be customized (LB Johnston)
 * Add support for Python 3.10 (Matt Westcott)
 * Introduce, `autocomplete`, a separate method that performs partial matching on specific autocomplete fields. This is useful for suggesting pages to the user in real-time as they type their query. (Karl Hobley, Matt Westcott)
 * Use SVG icons in modeladmin headers and StreamField buttons/headers (Jérôme Lebleu)
 * Add tags to existing Django registered checks (LB Johnston)
 * Upgrade admin frontend JS libraries jQuery to 3.6.0 (Fabien Le Frapper)
 * Added `request.preview_mode` so that template rendering can vary based on preview mode (Andy Chosak)
 * Fix: Delete button is now correct colour on snippets and modeladmin listings (Brandon Murch)
 * Fix: Ensure that StreamBlock / ListBlock-level validation errors are counted towards error counts (Matt Westcott)
 * Fix: InlinePanel add button is now keyboard navigatable (Jesse Menn)
 * Fix: Remove redundant 'clear' button from site root page chooser (Matt Westcott)
 * Fix: Make ModelAdmin IndexView keyboard-navigable (Saptak Sengupta)
 * Fix: Prevent error on refreshing page previews when multiple preview tabs are open (Alex Tomkins)
 * Fix: Multiple accessibility fixes for Windows high contrast mode; Admin fields, Dropdown button, Editor Tabs, Icon visibility, Page Editor field panels, sidebar menu, sidebar hamburger icon, sidebar search, streamfield, checkboxes (Dmitrii Faiazov, Chakita Muttaraju, Onkar Apte, Desai Akshata, LB (Ben Johnston), Amy Chan, Dan Braghis, Thibaud Colas, Shariq Jamil)
 * Fix: Menu sidebar hamburger icon on smaller viewports now correctly indicates it is a button to screen readers and can be accessed via keyboard (Amy Chan, Dan Braghis)
 * Fix: `blocks.MultipleChoiceBlock`, `forms.CheckboxSelectMultiple` and `ArrayField` checkboxes will now stack instead of display inline to align with all other checkboxes fields (Seb Brown)
 * Fix: Screen readers can now access login screen field labels (Amy Chan)
 * Fix: Admin breadcrumbs home icon now shows for users with access to a subtree only (Stefan Hammer)
 * Fix: Add handling of invalid inline styles submitted to `RichText` so `ConfigException` is not thrown (Alex Tomkins)
 * Fix: Ensure comment notifications dropdown handles longer translations without overflowing content (Krzysztof Jeziorny)
 * Fix: Set `default_auto_field` in `postgres_search` `AppConfig` (Nick Moreton)
 * Fix: Ensure admin tab JS events are handled on page load (Andrew Stone)
 * Fix: `EmailNotificationMixin` and `send_notification` should only send emails to active users (Bryan Williams)
 * Fix: Disable Task confirmation now shows the correct value for quantity of tasks in progress (LB Johnston)
 * Fix: Page history now works correctly when it contains changes by a deleted user (Dan Braghis)
 * Fix: Add `gettext_lazy` to `ModelAdmin` built in view titles so that language settings are correctly used (Matt Westcott)
 * Fix: Tabbing and keyboard interaction on the Wagtail userbar now aligns with ARIA best practices (Storm Heg)
 * Fix: Add full support for custom `edit_handler` usage by adding missing `bind_to` call to `PreviewOnEdit` view (Stefan Hammer)
 * Fix: Only show active (not disabled) tasks in the workflow task chooser (LB Johnston)
 * Fix: CSS build scripts now output to the correct directory paths on Windows (Vince Salvino)
 * Fix: Capture log output from style fallback to avoid noise in unit tests (Matt Westcott)
 * Fix: Switch widgets on/off states are now visually different for high-contrast mode users (Sakshi Uppoor)
 * Fix: Nested InlinePanel usage no longer fails to save when creating two or more items (Indresh P, Rinish Sam, Anirudh V S)
 * Fix: Changed relation name used for admin commenting from `comments` to `wagtail_admin_comments` to avoid conflicts with third-party commenting apps (Matt Westcott)
 * Fix: CSS variables are now correctly used for the filtering menu in modeladmin (Noah H)
 * Fix: Panel heading attribute is no longer ignored when nested inside a `MultiFieldPanel` (Jérôme Lebleu)


2.14.2 (14.10.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Allow relation name used for admin commenting to be overridden to avoid conflicts with third-party commenting apps (Matt Westcott)
 * Fix: Corrected badly-formed format strings in translations (Matt Westcott)
 * Fix: Page history now works correctly when it contains changes by a deleted user (Dan Braghis)


2.14.1 (12.08.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Prevent failure on Twitter embeds and others which return cache_age as a string (Matt Westcott)
 * Fix: Fix Uncaught ReferenceError when editing links in Hallo (Cynthia Kiser)


2.14 (02.08.2021)
~~~~~~~~~~~~~~~~~

 * Removed support for Django 2.2
 * Added `ancestor_of` API filter (Jaap Roes)
 * Added support for customizing group management views (Jan Seifert)
 * Added `full_url` property to image renditions (Shreyash Srivastava)
 * Added locale selector when choosing translatable snippets (Karl Hobley)
 * Added `WAGTAIL_WORKFLOW_ENABLED` setting for enabling / disabling moderation workflows globally (Matt Westcott)
 * Allow specifying `max_width` and `max_height` on EmbedBlock (Petr Dlouhý)
 * Add warning when StreamField is used without a StreamFieldPanel (Naomi Morduch Toubman)
 * Added keyboard and screen reader support to Wagtail user bar (LB Johnston, Storm Heg)
 * Add Google Data Studio to the list of oEmbed providers (Petr Dlouhý)
 * Added instructions on copying and aliasing pages to the editor's guide in documentation (Vlad Podgurschi)
 * Allow ListBlock to raise validation errors that are not attached to an individual child block (Matt Westcott)
 * Use `DATETIME_FORMAT` for localization in templates (Andrew Stone)
 * Added documentation on multi-site, multi-instance and multi-tenancy setups (Coen Van Der Kamp)
 * Updated Facebook / Instagram oEmbed endpoints to v11.0 (Thomas Kremmel)
 * Performance improvements for admin listing pages (Jake Howard, Dan Braghis, Tom Usher)
 * Fix: Invalid filter values for foreign key fields in the API now give an error instead of crashing (Tidiane Dia)
 * Fix: Ordering specified in `construct_explorer_page_queryset` hook is now taken into account again by the page explorer API (Andre Fonseca)
 * Fix: Deleting a page from its listing view no longer results in a 404 error (Tidiane Dia)
 * Fix: The Wagtail admin urls will now respect the `APPEND_SLASH` setting (Tidiane Dia)
 * Fix: Prevent “Forgotten password” link from overlapping with field on mobile devices (Helen Chapman)
 * Fix: Snippet admin urls are now namespaced to avoid ambiguity with the primary key component of the url (Matt Westcott)
 * Fix: Save order of promoted search results (Hardcodd)
 * Fix: Prevent error on copying pages with ClusterTaggableManager relations and multi-level inheritance (Chris Pollard)
 * Fix: Prevent failure on root page when registering the Page model with ModelAdmin (Jake Howard)
 * Fix: Prevent error when filtering page search results with a malformed content_type (Chris Pollard)
 * Fix: Prevent multiple submissions of "update" form when uploading images / documents (Mike Brown)
 * Fix: Ensure HTML title is populated on project template 404 page (Matt Westcott)
 * Fix: Respect cache_age parameters on embeds (Gordon Pendleton)
 * Fix: Page comparison view now reflects request-level customizations to edit handlers (Matt Westcott)
 * Fix: Add `block.super` to remaining `extra_js` & `extra_css` blocks (Andrew Stone)
 * Fix: Ensure that `editor` and `features` arguments on RichTextField are preserved by `clone()` (Daniel Fairhead)
 * Fix: Rename 'spin' CSS animation to avoid clashes with other libraries (Kevin Gutiérrez)
 * Fix: Prevent crash when copying a page from a section where the user has no publish permission (Karl Hobley)
 * Fix: Ensure that rich text conversion correctly handles images / embeds inside links or inline styles (Matt Westcott)


2.13.5 (14.10.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Allow relation name used for admin commenting to be overridden to avoid conflicts with third-party commenting apps (Matt Westcott)
 * Fix: Corrected badly-formed format strings in translations (Matt Westcott)
 * Fix: Correctly handle non-numeric user IDs for deleted users in reports (Dan Braghis)


2.13.4 (13.07.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Prevent embed thumbnail_url migration from failing on URLs longer than 200 characters (Matt Westcott)


2.13.3 (05.07.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Prevent error when using rich text on views where commenting is unavailable (Jacob Topp-Mugglestone)
 * Fix: Include form media on account settings page (Matt Westcott)
 * Fix: Avoid error when rendering validation error messages on ListBlock children (Matt Westcott)
 * Fix: Prevent comments CSS from overriding admin UI color customizations (Matt Westcott)
 * Fix: Avoid validation error when editing rich text content preceding a comment (Jacob Topp-Mugglestone)


2.13.2 (17.06.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2021-32681 - fix improper escaping of HTML ('Cross-site Scripting') in Wagtail StreamField blocks (Karen Tracey, Matt Westcott)


2.13.1 (01.06.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Ensure comment notification checkbox is fully hidden when commenting is disabled (Karl Hobley)
 * Fix: Prevent commenting from failing for user models with UUID primary keys (Jacob Topp-Mugglestone)
 * Fix: Fix incorrect link in comment notification HTML email (Matt Westcott)


2.13 (12.05.2021)
~~~~~~~~~~~~~~~~~

 * New StreamField implementation with performance and functionality improvements (Matt Westcott, Karl Hobley)
 * Added a simple translation module into `wagtail.contrib.simple_translation` (Coen van der Kamp)
 * Combined account settings into a single form (Karl Hobley)
 * Add support for exporting redirects (Martin Sandström)
 * The documentation now uses Sphinx Wagtail Theme https://github.com/wagtail/sphinx_wagtail_theme (Storm Heg, Tibor Leupold, Thibaud Colas and Coen van der Kamp).
 * Add support for Django 3.2
 * Support passing `min_num`, `max_num` and `block_counts` arguments directly to `StreamField` (Haydn Greatnews, Matt Westcott)
 * Add the option to set rich text images as decorative, without alt text (Helen Chapman, Thibaud Colas)
 * Add support for `__year` lookup in Elasticsearch queries (Seb Brown)
 * Support passing multiple models as arguments to `type()`, `not_type()`, `exact_type()` and `not_exact_type()` methods on `PageQuerySet` (Andy Babic)
 * Update default attribute copying behaviour of `Page.get_specific()` and added the `copy_attrs_exclude` option (Andy Babic)
 * Update `PageQueryset.specific(defer=True)` to only perform a single database query (Andy Babic)
 * Add `PageQueryset.defer_streamfields()` (Andy Babic)
 * Utilize `PageQuerySet.defer_streamfields()` to improve efficiency in a few key places (Andy Babic)
 * Switch ``register_setting``, ``register_settings_menu_item`` to use SVG icons (Thibaud Colas)
 * Add support to SVG icons for ``SearchArea`` subclasses in ``register_admin_search_area`` (Thibaud Colas)
 * Add `wagtail.reorder` page audit log action (Storm Heg)
 * `get_settings` template tag now supports specifying the variable name with `{% get_settings as var %}` (Samir Shah)
 * Reinstate submitter's name on moderation notification email (Matt Westcott)
 * Add a new switch input widget as an alternative to checkboxes (Karl Hobley)
 * Allow `{% pageurl %}` fallback to be a direct URL or an object with a `get_absolute_url` method (Andy Babic)
 * Support slicing on StreamField / StreamBlock values (Matt Westcott)
 * Switch Wagtail choosers to use SVG icons instead of font icon (Storm Heg)
 * Save revision when restart workflow (Ihor Marhitych)
 * Add a visible indicator of unsaved changes to the page editor (Jacob Topp-Mugglestone)
 * Fix: StreamField required status is now consistently handled by the `blank` keyword argument (Matt Westcott)
 * Fix: Show 'required' asterisks for blocks inside required StreamFields (Matt Westcott)
 * Fix: Make image chooser "Select format" fields translatable (Helen Chapman, Thibaud Colas)
 * Fix: Move labels above the form field in the image format chooser, to avoid styling issues at tablet size (Helen Chapman)
 * Fix: `{% include_block with context %}` now passes local variables into the block template (Jonny Scholes)
 * Fix: Fix pagination on 'view users in a group' (Sagar Agarwal)
 * Fix: Prevent page privacy menu from being triggered by pressing enter on a char field (Sagar Agarwal)
 * Fix: Validate host/scheme of return URLs on password authentication forms (Susan Dreher)
 * Fix: Reordering a page now includes the correct user in the audit log (Storm Heg)
 * Fix: Reverse migration errors in images and documents (Mike Brown)
 * Fix: Apply enough chevron padding to all applicable select elements (Scott Cranfill)
 * Fix: Reduce database queries in the page edit view (Ihor Marhitych)


2.12.6 (13.07.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Prevent embed thumbnail_url migration from failing on URLs longer than 200 characters (Matt Westcott)


2.12.5 (17.06.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2021-32681 - fix improper escaping of HTML ('Cross-site Scripting') in Wagtail StreamField blocks (Karen Tracey, Matt Westcott)


2.12.4 (19.04.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2021-29434 - fix improper validation of URLs ('Cross-site Scripting') in rich text fields (Kevin Breen, Matt Westcott)
 * Fix: Reverse migration errors in images and documents (Mike Brown)
 * Fix: Avoid wagtailembeds migration failure on MySQL 8.0.13+ (Matt Westcott)


2.12.3 (05.03.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Un-pin django-treebeard following upstream fix for migration issue (Matt Westcott)
 * Fix: Prevent crash when copying an alias page (Karl Hobley)
 * Fix: Prevent errors on page editing after changing LANGUAGE_CODE (Matt Westcott)
 * Fix: Correctly handle model inheritance and `ClusterableModel` on `copy_for_translation` (Karl Hobley)


2.12.2 (18.02.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Pin django-treebeard to <4.5 to prevent migration conflicts (Matt Westcott)


2.12.1 (16.02.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Ensure aliases are published when the source page is published (Karl Hobley)
 * Fix: Make page privacy rules apply to aliases (Karl Hobley)
 * Fix: Prevent error when saving embeds that do not include a thumbnail URL (Cynthia Kiser)
 * Fix: Ensure that duplicate embed records are deleted when upgrading (Matt Westcott)
 * Fix: Prevent failure when running `manage.py dumpdata` with no arguments (Matt Westcott)


2.12 (02.02.2021)
~~~~~~~~~~~~~~~~~

 * Added a distinct 'choose' permission for images and documents (Robert Rollins)
 * StreamField values can now be modified in-place (Matt Westcott)
 * Added support for custom admin color themes (Joshua Marantz)
 * Added support for Python 3.9
 * Added `WAGTAILIMAGES_IMAGE_FORM_BASE` and `WAGTAILDOCS_DOCUMENT_FORM_BASE` settings to customize the forms for images and documents (Dan Braghis)
 * Switch pagination icons to use SVG instead of icon fonts (Scott Cranfill)
 * Added string representation to image Format class (Andreas Nüßlein)
 * Support returning None from `register_page_action_menu_item` and `register_snippet_action_menu_item` to skip registering an item (Vadim Karpenko)
 * Fields on a custom image model can now be defined as required / `blank=False` (Matt Westcott)
 * Add combined index for Postgres search backend (Will Giddens)
 * Add `Page.specific_deferred` property for accessing specific page instance without up-front database queries (Andy Babic)
 * Add hash lookup to embeds to support URLs longer than 255 characters (Coen van der Kamp)
 * Fix: Stop menu icon overlapping the breadcrumb on small viewport widths in page editor (Karran Besen)
 * Fix: Make sure document chooser pagination preserves the selected collection when moving between pages (Alex Sa)
 * Fix: Gracefully handle oEmbed endpoints returning non-JSON responses (Matt Westcott)
 * Fix: Fix unique constraint on WorkflowState for SQL Server compatibility (David Beitey)
 * Fix: Reinstate chevron on collection dropdown (Mike Brown)
 * Fix: Prevent delete button showing on collection / workflow edit views when delete permission is absent (Helder Correia)


2.11.9 (24.01.2022)
~~~~~~~~~~~~~~~~~~~

 * Fix: Update Pillow dependency to allow 9.x (Rizwan Mansuri)


2.11.8 (17.06.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2021-32681 - fix improper escaping of HTML ('Cross-site Scripting') in Wagtail StreamField blocks (Karen Tracey, Matt Westcott)


2.11.7 (19.04.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2021-29434 - fix improper validation of URLs ('Cross-site Scripting') in rich text fields (Kevin Breen, Matt Westcott)


2.11.6 (05.03.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Un-pin django-treebeard following upstream fix for migration issue (Matt Westcott)
 * Fix: Prevent crash when copying an alias page (Karl Hobley)
 * Fix: Prevent errors on page editing after changing LANGUAGE_CODE (Matt Westcott)
 * Fix: Correctly handle model inheritance and `ClusterableModel` on `copy_for_translation` (Karl Hobley)


2.11.5 (18.02.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Pin django-treebeard to <4.5 to prevent migration conflicts (Matt Westcott)


2.11.4 (16.02.2021)
~~~~~~~~~~~~~~~~~~~

 * Fix: Prevent delete button showing on collection / workflow edit views when delete permission is absent (Helder Correia)
 * Fix: Ensure aliases are published when the source page is published (Karl Hobley)
 * Fix: Make page privacy rules apply to aliases (Karl Hobley)


2.11.3 (10.12.2020)
~~~~~~~~~~~~~~~~~~~

 * Fix: Updated project template migrations to ensure that initial homepage creation runs before addition of locale field (Dan Braghis)
 * Fix: Restore ability to use translatable strings in `LANGUAGES` / `WAGTAIL_CONTENT_LANGUAGES` settings (Andreas Morgenstern)
 * Fix: Allow `locale` / `translation_of` API filters to be used in combination with search (Matt Westcott)
 * Fix: Prevent error on `create_log_entries_from_revisions` when checking publish state on a revision that cannot be restored (Kristin Riebe)


2.11.2 (17.11.2020)
~~~~~~~~~~~~~~~~~~~

 * Add custom finder to support Instagram oEmbed API (Luis Nell)
 * Add custom finder to support Facebook oEmbed API (Cynthia Kiser)
 * Fix: Improve performance of permission check on translations for edit page (Karl Hobley)
 * Fix: Gracefully handle missing Locale records on `Locale.get_active` and `.localized` (Matt Westcott)
 * Fix: Handle `get_supported_language_variant` returning a language variant not in `LANGUAGES` (Matt Westcott)
 * Fix: Reinstate missing icon on settings edit view (Jérôme Lebleu)
 * Fix: Avoid performance and pagination logic issues with a large number of languages (Karl Hobley)
 * Fix: Allow deleting the default locale (Matt Westcott)


2.11.1 (06.11.2020)
~~~~~~~~~~~~~~~~~~~

 * Fix: Ensure that cached `wagtail_site_root_paths` structures from older Wagtail versions are invalidated (Sævar Öfjörð Magnússon)
 * Fix: Avoid circular import between wagtail.admin.auth and custom user models (Matt Westcott)
 * Fix: Prevent error on resolving page URLs when a locale outside of `WAGTAIL_CONTENT_LANGUAGES` is active (Matt Westcott)


2.11 LTS (02.11.2020)
~~~~~~~~~~~~~~~~~~~~~

 * Add support for multi-lingual content (Karl Hobley)
 * Add support for aliased pages (Karl Hobley)
 * Add support for hierarchical/nested Collections (Robert Rollins)
 * Extend treebeard's `fix_tree` method with the ability to non-destructively fix path issues and add a --full option to apply path fixes (Matt Westcott)
 * Add `before_edit_snippet`, `before_create_snippet` and `before_delete_snippet` hooks and documentation (Karl Hobley. Sponsored by the Mozilla Foundation)
 * Add `register_snippet_listing_buttons` and `construct_snippet_listing_buttons` hooks and documentation (Karl Hobley. Sponsored by the Mozilla Foundation)
 * Add `wagtail --version` to available Wagtail CLI commands (Kalob Taulien)
 * Add `hooks.register_temporarily` utility function for testing hooks (Karl Hobley. Sponsored by the Mozilla Foundation)
 * Remove `unidecode` and use `anyascii` in for Unicode to ASCII conversion (Robbie Mackay)
 * Add `render` helper to `RoutablePageMixin` to support serving template responses according to Wagtail conventions (Andy Babic)
 * Specify minimum Python version in setup.py (Vince Salvino)
 * Show user's full name in report views (Matt Westcott)
 * Improve Wagtail admin page load performance by caching SVG icons sprite in localStorage (Coen van der Kamp)
 * Support SVG icons in ModelAdmin menu items (Scott Cranfill)
 * Support SVG icons in admin breadcrumbs (Coen van der Kamp)
 * Serve PDFs inline in the browser (Matt Westcott)
 * Make document `content-type` and `content-disposition` configurable via `WAGTAILDOCS_CONTENT_TYPES` and `WAGTAILDOCS_INLINE_CONTENT_TYPES` (Matt Westcott)
 * Slug generation no longer removes stopwords (Andy Chosak, Scott Cranfill)
 * Add check to disallow StreamField block names that do not match Python variable syntax (François Poulain)
 * The `BASE_URL` setting is now converted to a string, if it isn't already, when constructing API URLs (thenewguy)
 * Preview from 'pages awaiting moderation' now opens in a new window (Cynthia Kiser)
 * Add document extension validation if `WAGTAIL_DOCS_EXTENSIONS` is set (Meghana Bhange)
 * Use `django-admin` command in place of `django-admin.py` (minusf)
 * Add `register_snippet_action_menu_item` and `construct_snippet_action_menu` hooks to modify the actions available when creating / editing a snippet (Karl Hobley)
 * Moved `generate_signature` and `verify_signature` functions into `wagtail.images.utils` (Noah H)
 * Implement `bulk_to_python` on all structural StreamField block types (Matt Westcott)
 * Add natural key support to `GroupCollectionPermission` (Jim Jazwiecki)
 * Implement `prepopulated_fields` for `wagtail.contrib.modeladmin` (David Bramwell)
 * Change `classname` keyword argument on basic StreamField blocks to `form_classname` (Meghana Bhange)
 * Replace page explorer pushPage/popPage with gotoPage for more flexible explorer navigation (Karl Hobley)
 * Fix: Make page-level actions accessible to keyboard users in page listing tables (Jesse Menn)
 * Fix: `WAGTAILFRONTENDCACHE_LANGUAGES` was being interpreted incorrectly. It now accepts a list of strings, as documented (Karl Hobley)
 * Fix: Update oEmbed endpoints to use https where available (Matt Westcott)
 * Fix: Revise `edit_handler` bind order in ModelAdmin views and fix duplicate form instance creation (Jérôme Lebleu)
 * Fix: Properly distinguish child blocks when comparing revisions with nested StreamBlocks (Martin Mena)
 * Fix: Correctly handle Turkish 'İ' characters in client-side slug generation (Matt Westcott)
 * Fix: Page chooser widgets now reflect custom ``get_admin_display_title`` methods (Saptak Sengupta)
 * Fix: `Page.copy()` now raises an error if the page being copied is unsaved (Anton Zhyltsou)
 * Fix: `Page.copy()` now triggers a `page_published` if the copied page is live (Anton Zhyltsou)
 * Fix: The Elasticsearch `URLS` setting can now take a string on its own instead of a list (Sævar Öfjörð Magnússon)
 * Fix: Avoid retranslating month / weekday names that Django already provides (Matt Westcott)
 * Fix: Fixed padding around checkbox and radio inputs (Cole Maclean)
 * Fix: Fix spacing around the privacy indicator panel (Sævar Öfjörð Magnússon, Dan Braghis)
 * Fix: Consistently redirect to admin home on permission denied (Matt Westcott, Anton Zhyltsou)


2.10.2 (25.09.2020)
~~~~~~~~~~~~~~~~~~~

 * Fix: Avoid use of `icon` class name on userbar icon to prevent clashes with front-end styles (Karran Besen)
 * Fix: Prevent focused button labels from displaying as white on white (Karran Bessen)
 * Fix: Avoid showing preview button on moderation dashboard for page types with preview disabled (Dino Perovic)
 * Fix: Prevent oversized buttons in moderation dashboard panel (Dan Braghis)
 * Fix: `create_log_entries_from_revisions` now handles revisions that cannot be restored due to foreign key constraints (Matt Westcott)


2.10.1 (26.08.2020)
~~~~~~~~~~~~~~~~~~~

 * Fix: Prevent `create_log_entries_from_revisions` command from failing when page model classes are missing (Dan Braghis)
 * Fix: Prevent page audit log views from failing for user models without a `username` field (Vyacheslav Matyukhin)
 * Fix: Fix icon alignment on menu items (Coen van der Kamp)
 * Fix: Page editor header bar now correctly shows 'Published' or 'Draft' status when no revisions exist (Matt Westcott)
 * Fix: Prevent page editor from failing when `USE_TZ` is false (Matt Westcott)
 * Fix: Ensure whitespace between block-level elements is preserved when stripping tags from rich text for search indexing (Matt Westcott)


2.10 (11.08.2020)
~~~~~~~~~~~~~~~~~

 * Added Django 3.1 support (Matt Westcott, Karl Hobley)
 * Removed support for Python 3.5
 * Implemented configurable moderation workflow (Jacob Topp-Mugglestone, Karl Hobley, Matt Westcott, Dan Braghis)
 * Implemented phrase searching and structured search query expressions (Karl Hobley)
 * Add ability to import redirects from an uploaded file (CSV, TSV, XLS, and XLSX) (Martin Sandström)
 * Added `webpquality` and `format-webp-lossless` image filters and `WAGTAILIMAGES_WEBP_QUALITY` setting (Nikolay Lukyanov)
 * Reorganised Dockerfile in project template to follow best practices (Tomasz Knapik, Jannik Wempe)
 * Added filtering to locked pages report (Karl Hobley)
 * Adds ability to view a group's users via standalone admin URL and a link to this on the group edit view (Karran Besen)
 * Redirect to previous url when deleting/copying/unpublish a page and modify this url via the relevant hooks (Ascani Carlo)
 * Added `next_url` keyword argument on `register_page_listing_buttons` and `register_page_listing_more_buttons` hooks (Ascani Carlo, Matt Westcott, LB (Ben Johnston))
 * `AbstractEmailForm` will use `SHORT_DATETIME_FORMAT` and `SHORT_DATE_FORMAT` Django settings to format date/time values in email (Haydn Greatnews)
 * `AbstractEmailForm` now has a separate method (`render_email`) to build up email content on submission emails (Haydn Greatnews)
 * Add `pre_page_move` and `post_page_move` signals (Andy Babic)
 * Add ability to sort search promotions on listing page (Chris Ranjana, LB (Ben Johnston))
 * Upgrade internal JS tooling; Node v10, Gulp v4 & Jest v23 (Jim Jazwiecki, Kim LaRocca, Thibaud Colas)
 * Add `after_publish_page`, `before_publish_page`, `after_unpublish_page` & `before_unpublish_page` hooks (Jonatas Baldin, Coen van der Kamp)
 * Add convenience `page_url` shortcut to improve how page URLs can be accessed from site settings in Django templates (Andy Babic)
 * Show more granular error messages from Pillow when uploading images (Rick van Hattem)
 * Add ordering to `Site` object, so that index page and `Site` switcher will be sorted consistently (Coen van der Kamp, Tim Leguijt)
 * Add Reddit to oEmbed provider list (Luke Hardwick)
 * Add ability to replace the default Wagtail logo in the userbar, via `branding_logo` block (Meteor0id)
 * Remove sticky footer on small devices, so that content is not blocked and more easily editable (Saeed Tahmasebi)
 * Add `alt` property to `ImageRenditionField` api representation (Liam Mullens)
 * Add `purge_revisions` management command to purge old page revisions (Jacob Topp-Mugglestone, Tom Dyson)
 * Render the Wagtail User Bar on non `Page` views (Caitlin White, Coen van der Kamp)
 * Add ability to define `form_classname` on `ListBlock` & `StreamBlock` (LB (Ben Johnston))
 * Add documentation about how to use `Rustface` for image feature detection (Neal Todd)
 * Improve performance of public/not_public queries in `PageQuerySet` (Timothy Bautista)
 * Add `add_redirect` static method to `Redirect` class for programmatic redirect creation (Brylie Christopher Oxley, Lacey Williams Henschel)
 * Add reference documentation for `wagtail.contrib.redirects` (LB (Ben Johnston))
 * `bulk_delete` page permission is no longer required to move pages, even if those pages have children (Robert Rollins, LB (Ben Johnston))
 * Add `after_edit_snippet`, `after_create_snippet` and `after_delete_snippet` hooks and documentation (Kalob Taulien)
 * Improve performance of empty search results by avoiding downloading the entire search index in these scenarios (Lars van de Kerkhof, Coen van der Kamp)
 * Replace `gulp-sass` with `gulp-dart-sass` to improve core development across different platforms (Thibaud Colas)
 * Add SVG icons to resolve accessibility and customization issues and start using them in a subset of Wagtail's admin (Coen van der Kamp, Scott Cranfill, Thibaud Colas, Dan Braghis)
 * Switch userbar and header H1s to use SVG icons (Coen van der Kamp)
 * Remove markup around rich text rendering by default, provide a way to use old behaviour via `wagtail.contrib.legacy.richtext` (Coen van der Kamp, Dan Braghis)
 * Apply title length normalization to improve ranking on PostgreSQL search (Karl Hobley)
 * Add `WAGTAIL_TIME_FORMAT` setting (Jacob Topp-Mugglestone)
 * Allow omitting the default editor from `WAGTAILADMIN_RICH_TEXT_EDITORS` (Gassan Gousseinov)
 * Disable password auto-completion on user creation form (Samir Shah)
 * Upgrade jQuery to version 3.5.1 to reduce penetration testing false positives (Matt Westcott)
 * Add ability to extend `EditHandler` without a children attribute (Seb Brown)
 * `Page.objects.specific` now gracefully handles pages with missing specific records (Andy Babic)
 * StreamField 'add' buttons are now disabled when maximum count is reached (Max Gabrielsson)
 * Use underscores for form builder field names to allow use as template variables (Ashia Zawaduk, LB (Ben Johnston))
 * Deprecate use of unidecode within form builder field names (Michael van Tellingen, LB (Ben Johnston))
 * Improve error feedback when editing a page with a missing model class (Andy Babic)
 * Change Wagtail tabs implementation to only allow slug-formatted tab identifiers, reducing false positives from security audits (Matt Westcott)
 * Add skip link for keyboard users to bypass Wagtail navigation in the admin (Martin Coote)
 * Ensure errors during Postgres search indexing are left uncaught to assist troubleshooting (Karl Hobley)
 * Add ability to edit images and embeds in rich text editor (Maylon Pedroso, Samuel Mendes, Gabriel Peracio)
 * Fix: Support IPv6 domain (Alex Gleason, Coen van der Kamp)
 * Fix: Ensure link to add a new user works when no users are visible in the users list (LB (Ben Johnston))
 * Fix: `AbstractEmailForm` saved submission fields are now aligned with the email content fields, `form.cleaned_data` will be used instead of `form.fields` (Haydn Greatnews)
 * Fix: Removed ARIA `role="table"` from TableBlock output (Thibaud Colas)
 * Fix: Set Cache-Control header to prevent page preview responses from being cached (Tomas Walch)
 * Fix: Accept unicode characters in slugs on the "copy page" form (François Poulain)
 * Fix: Remove top padding when `FieldRowPanel` is used inside a `MultiFieldPanel` (Jérôme Lebleu)
 * Fix: Add Wagtail User Bar back to page previews and ensure moderation actions are available (Coen van der Kamp)
 * Fix: Resolve issue where queryset annotations were lost (e.g. `.annotate_score()`) when using specific models in page query (Dan Bentley)
 * Fix: Prevent date/time picker from losing an hour on losing focus when 12-hour times are in use (Jacob Topp-Mugglestone)
 * Fix: Strip out HTML tags from `RichTextField` & `RichTextBlock` search index content (Timothy Bautista)
 * Fix: Avoid using null on string `Site.site_name` blank values to avoid different values for no name (Coen van der Kamp)
 * Fix: Fix deprecation warnings on Elasticsearch 7 (Yngve Høiseth)
 * Fix: Remove use of Node.forEach for IE 11 compatibility in admin menu items (Thibaud Colas)
 * Fix: Fix incorrect method name in SiteMiddleware deprecation warning (LB (Ben Johnston))
 * Fix: `wagtail.contrib.sitemaps` no longer depends on SiteMiddleware (Matt Westcott)
 * Fix: Purge image renditions cache when renditions are deleted (Pascal Widdershoven, Matt Westcott)
 * Fix: Image / document forms now display non-field errors such as `unique_together` constraints (Matt Westcott)
 * Fix: Make "Site" chooser in site settings translatable (Andreas Bernacca)
 * Fix: Add missing dropdown icons to image upload, document upload, and site settings screens (Andreas Bernacca)
 * Fix: Prevent snippets’ bulk delete button from being present for screen reader users when it’s absent for sighted users (LB (Ben Johnston))
 * Fix: Fix group permission checkboxes not being clickable in IE11 (LB (Ben Johnston))


2.9.3 (20.07.2020)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2020-15118 - prevent HTML injection through form field help text (Timothy Bautista, Matt Westcott)


2.9.2 (03.07.2020)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent startup failure when `wagtail.contrib.sitemaps` is in `INSTALLED_APPS` (Matt Westcott)


2.9.1 (30.06.2020)
~~~~~~~~~~~~~~~~~~

 * Fix: Fix incorrect method name in SiteMiddleware deprecation warning (LB (Ben Johnston))
 * Fix: `wagtail.contrib.sitemaps` no longer depends on SiteMiddleware (Matt Westcott)
 * Fix: Purge image renditions cache when renditions are deleted (Pascal Widdershoven, Matt Westcott)


2.9 (04.05.2020)
~~~~~~~~~~~~~~~~

 * Removed support for Django 2.1
 * Added data exports in XLSX and CSV format for reports, ModelAdmin and form submissions (Jacob Topp-Mugglestone)
 * Added support for creating custom reports (Jacob Topp-Mugglestone)
 * Skip page validation when unpublishing a page (Samir Shah)
 * Added `MultipleChoiceBlock` block type for StreamField (James O'Toole)
 * ChoiceBlock now accepts a `widget` keyword argument (James O'Toole)
 * Reduced contrast of rich text toolbar (Jack Paine)
 * Support the rel attribute on custom ModelAdmin buttons (Andy Chosak)
 * Server-side page slug generation now respects `WAGTAIL_ALLOW_UNICODE_SLUGS` (Arkadiusz Michał Ryś)
 * Wagtail admin no longer depends on SiteMiddleware, avoiding incompatibility with Django sites framework and redundant database queries (aritas1, timmysmalls, Matt Westcott)
 * Tag field autocompletion now handles custom tag models (Matt Westcott)
 * `wagtail_serve` URL route can now be omitted for headless sites (Storm Heg)
 * Allow free tagging to be disabled on custom tag models (Matt Westcott)
 * Allow disabling page preview by setting `preview_modes` to an empty list (Casper Timmers)
 * Add Vidyard to oEmbed provider list (Steve Lyall)
 * Optimise compiling media definitions for complex StreamBlocks (pimarc)
 * FieldPanel now accepts a 'heading' argument (Jacob Topp-Mugglestone)
 * Replaced deprecated `ugettext` / `ungettext` calls with `gettext` / `ngettext` (Mohamed Feddad)
 * ListBlocks now call child block `bulk_to_python` if defined (Andy Chosak)
 * Site settings are now identifiable/cacheable by request as well as site (Andy Babic)
 * Added `select_related` attribute to site settings to enable more efficient fetching of foreign key values (Andy Babic)
 * Add caching of image renditions (Tom Dyson, Tim Kamanin)
 * Add documentation for reporting security issues and internationalization (Matt Westcott)
 * Fields on a custom image model can now be defined as required `blank=False` (Matt Westcott)
 * Fix: CVE-2020-11037 - avoid potential timing attack on password-protected private pages (Thibaud Colas)
 * Fix: Added ARIA alert role to live search forms in the admin (Casper Timmers)
 * Fix: Reorder login form elements to match expected tab order (Kjartan Sverrisson)
 * Fix: Re-add 'Close Explorer' button on mobile viewports (Sævar Öfjörð Magnússon)
 * Fix: Add a more descriptive label to Password reset link for screen reader users (Casper Timmers, Martin Coote)
 * Fix: Improve Wagtail logo contrast by adding a background (Brian Edelman, Simon Evans, Ben Enright)
 * Fix: Prevent duplicate notification messages on page locking (Jacob Topp-Mugglestone)
 * Fix: Fix InlinePanel item non field errors not visible (Storm Heg)
 * Fix: `{% image ... as var %}` now clears the context variable when passed None as an image (Maylon Pedroso)
 * Fix: `refresh_index` method on Elasticsearch no longer fails (Lars van de Kerkhof)
 * Fix: Document tags no longer fail to update when replacing the document file at the same time (Matt Westcott)
 * Fix: Prevent error from very tall / wide images being resized to 0 pixels (Fidel Ramos)
 * Fix: Remove excess margin when editing snippets (Quadric)
 * Fix: Added `scope` attribute to table headers in TableBlock output (Quadric)
 * Fix: Prevent KeyError when accessing a StreamField on a deferred queryset (Paulo Alvarado)
 * Fix: Hide empty 'view live' links (Karran Besen)
 * Fix: Mark up a few strings for translation (Luiz Boaretto)
 * Fix: Invalid focal_point attribute on image edit view (Michał (Quadric) Sieradzki)
 * Fix: No longer expose the `.delete()` method on the default Page.objects manager (Nick Smith)
 * Fix: `exclude_fields_in_copy` on Page models will now work for modelcluster parental / many to many relations (LB (Ben Johnston))
 * Fix: Response header (content disposition) now correctly handles filenames with non-ascii characters when using a storage backend (Rich Brennan)
 * Fix: Improved accessibility fixes for `main`, `header` and `footer` elements in the admin page layout (Mitchel Cabuloy)
 * Fix: Prevent version number from obscuring long settings menus (Naomi Morduch Toubman)
 * Fix: Admin views using TemplateResponse now respect the user's language setting (Jacob Topp-Mugglestone)
 * Fix: Fixed incorrect language code for Japanese in language setting dropdown (Tomonori Tanabe)


2.8.2 (04.05.2020)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2020-11037 - avoid potential timing attack on password-protected private pages (Thibaud Colas)


2.8.1 (14.04.2020)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2020-11001 - prevent XSS attack via page revision comparison view (Vlad Gerasimenko, Matt Westcott)


2.8 (03.02.2020)
~~~~~~~~~~~~~~~~

 * Django 3.0 support (Matt Westcott, Mads Jensen)
 * Improved page locking to give editors exclusive edit access (Karl Hobley, Jacob Topp-Mugglestone)
 * Removed support for Django 2.0
 * Removed leftover Python 2.x compatibility code (Sergey Fedoseev)
 * Combine flake8 configurations (Sergey Fedoseev)
 * Improve diffing behavior for text fields (Aliosha Padovani)
 * Improve contrast of disabled inputs (Nick Smith)
 * Added `get_document_model_string` function (Andrey Smirnov)
 * Added support for Cloudflare API tokens for frontend cache invalidation (Tom Usher)
 * Cloudflare frontend cache invalidation requests are now sent in chunks of 30 to fit within API limits (Tom Usher)
 * Added `ancestors` field to the pages endpoint in admin API (Karl Hobley)
 * Removed Django admin management of `Page` & `Site` models (Andreas Bernacca)
 * Cleaned up Django docs URLs in documentation (Pete Andrew)
 * Add StreamFieldPanel to available panel types in documentation (Dan Swain)
 * Add `{{ block.super }}` example to ModelAdmin customization in documentation (Dan Swain)
 * Add ability to filter image index by a tag (Benedikt Willi)
 * Add partial experimental support for nested InlinePanels (Matt Westcott, Sam Costigan, Andy Chosak, Scott Cranfill)
 * Added cache control headers when serving documents (Johannes Vogel)
 * Use `sensitive_post_parameters` on password reset form (Dan Braghis)
 * Add `WAGTAILEMBEDS_RESPONSIVE_HTML` setting to remove automatic addition of `responsive-object` around embeds (Kalob Taulien)
 * Fix: Rename documents listing column 'uploaded' to 'created' (LB (Ben Johnston))
 * Fix: Unbundle the l18n library as it was bundled to avoid installation errors which have been resolved (Matt Westcott)
 * Fix: Prevent error when comparing pages that reference a model with a custom primary key (Fidel Ramos)
 * Fix: Moved `get_document_model` location so it can be imported when Models are not yet loaded (Andrey Smirnov)
 * Fix: Use correct HTML escaping of Jinja2 form templates for StructBlocks (Brady Moe)
 * Fix: All templates with wagtailsettings and modeladmin now use `block.super` for `extra_js` & `extra_css` (Timothy Bautista)
 * Fix: Layout issue when using `FieldRowPanel` with a heading (Andreas Bernacca)
 * Fix: `file_size` and `file_hash` now updated when Document file changed (Andreas Bernacca)
 * Fix: Fixed order of URLs in project template so that static / media URLs are not blocked (Nick Smith)
 * Fix: Added `verbose_name_plural` to form submission model (Janneke Janssen)
 * Fix: Prevent `update_index` failures and incorrect front-end rendering on blank `TableBlock` (Carlo Ascani)
 * Fix: Dropdown initialization on the search page after AJAX call (Eric Sherman)
 * Fix: Make sure all modal chooser search results correspond to the latest search by canceling previous requests (Esper Kuijs)


2.7.4 (20.07.2020)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2020-15118 - prevent HTML injection through form field help text (Timothy Bautista, Matt Westcott)
 * Fix: Expand Pillow dependency range to include 7.x (Harris Lapiroff, Matt Westcott)


2.7.3 (04.05.2020)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2020-11037 - avoid potential timing attack on password-protected private pages (Thibaud Colas)


2.7.2 (14.04.2020)
~~~~~~~~~~~~~~~~~~

 * Fix: CVE-2020-11001 - prevent XSS attack via page revision comparison view (Vlad Gerasimenko, Matt Westcott)


2.7.1 (08.01.2020)
~~~~~~~~~~~~~~~~~~

 * Fix: Management command startup checks under `ManifestStaticFilesStorage` no longer fail if `collectstatic` has not been run first (Alex Tomkins)


2.7 LTS (06.11.2019)
~~~~~~~~~~~~~~~~~~~~

 * Improved StreamField design (Bertrand Bordage)
 * Added WebP image support (frmdstryr, Karl Hobley, Matt Westcott)
 * Added Elasticsearch 7 support (pySilver)
 * Added Python 3.8 support (John Carter, Matt Westcott)
 * Added `construct_page_listing_buttons` hook (Michael van Tellingen)
 * Added more detailed documentation and troubleshooting for installing OpenCV for feature detection (Daniele Procida)
 * Added Table Block caption for accessibility (Rahmi Pruitt)
 * Move and refactor upgrade notification JS (Jonny Scholes)
 * Add ability to insert internal anchor links/links with fragment identifiers in Draftail (rich text) fields (Iman Syed)
 * Remove need for Elasticsearch `update_all_types` workaround, upgrade minimum release to 6.4.0 or above (Jonathan Liuti)
 * Add ability for users to change their own name via the account settings page (Kevin Howbrook)
 * Add ability to insert telephone numbers as links in Draftail (rich text) fields (Mikael Engström and Liam Brenner)
 * Increase delay before search in the snippet chooser, to prevent redundant search request round trips (Robert Rollins)
 * Add `WAGTAIL_EMAIL_MANAGEMENT_ENABLED` setting to determine whether users can change their email address (Janne Alatalo)
 * Recognise Soundcloud artist URLs as embeddable (Kiril Staikov)
 * Add `WAGTAILDOCS_SERVE_METHOD` setting to determine how document downloads will be linked to and served (Tobias McNulty, Matt Westcott)
 * Add `WAGTAIL_MODERATION_ENABLED` setting to enable / disable the 'Submit for Moderation' option (Jacob Topp-Mugglestone)
 * Added settings to customize pagination page size for the Images admin area (Brian Whitton)
 * Added ARIA role to TableBlock output (Matt Westcott)
 * Added cache-busting query parameters to static files within the Wagtail admin (Matt Westcott)
 * Allow `register_page_action_menu_item` and `construct_page_action_menu` hooks to override the default menu action (Rahmi Pruitt, Matt Westcott)
 * `WAGTAILIMAGES_MAX_IMAGE_PIXELS` limit now takes the number of animation frames into account (Karl Hobley)
 * Fix: Added line breaks to long filenames on multiple image / document uploader (Kevin Howbrook)
 * Fix: Added https support for Scribd oEmbed provider (Rodrigo)
 * Fix: Changed StreamField group labels color so labels are visible (Catherine Farman)
 * Fix: Prevented images with a very wide aspect ratio from being displayed distorted in the rich text editor (Iman Syed)
 * Fix: Prevent exception when deleting a model with a protected One-to-one relationship (Neal Todd)
 * Fix: Added labels to snippet bulk edit checkboxes for screen reader users (Martey Dodoo)
 * Fix: Middleware responses during page preview are now properly returned to the user (Matt Westcott)
 * Fix: Default text of page links in rich text uses the public page title rather than the admin display title (Andy Chosak)
 * Fix: Specific page permission checks are now enforced when viewing a page revision (Andy Chosak)
 * Fix: `pageurl` and `slugurl` tags no longer fail when `request.site` is `None` (Samir Shah)
 * Fix: Output form media on add/edit image forms with custom models (Matt Westcott)
 * Fix: Output form media on add/edit document forms with custom models (Sergey Fedoseev)
 * Fix: Layout for the clear checkbox in default FileField widget (Mikalai Radchuk)
 * Fix: Remove ASCII conversion from Postgres search backend, to support stemming in non-Latin alphabets (Pavel Denisov)
 * Fix: Prevent tab labels on page edit view from being cut off on very narrow screens (Kevin Howbrook)
 * Fix: Very long words in page listings are now broken where necessary (Kevin Howbrook)
 * Fix: Language chosen in user preferences no longer persists on subsequent requests (Bojan Mihelac)
 * Fix: Prevent new block IDs from being assigned on repeated calls to `StreamBlock.get_prep_value` (Colin Klein)
 * Fix: Prevent broken images in notification emails when static files are hosted on a remote domain (Eduard Luca)
 * Fix: Replace styleguide example avatar with default image to avoid issues when custom user model is used (Matt Westcott)
 * Fix: `DraftailRichTextArea` is no longer treated as a hidden field by Django's form logic (Sergey Fedoseev)
 * Fix: Replace format() placeholders in translatable strings with % formatting (Matt Westcott)
 * Fix: Altering Django REST Framework's `DEFAULT_AUTHENTICATION_CLASSES` setting no longer breaks the page explorer menu and admin API (Matt Westcott)
 * Fix: Regression - missing label for external link URL field in link chooser (Stefani Castellanos)


2.6.3 (22.10.2019)
~~~~~~~~~~~~~~~~~~

 * Fix: Altering Django REST Framework's `DEFAULT_AUTHENTICATION_CLASSES` setting no longer breaks the page explorer menu and admin API (Matt Westcott)


2.6.2 (19.09.2019)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent search indexing failures on Postgres 9.4 and Django >= 2.2.1 (Matt Westcott)


2.6.1 (05.08.2019)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent JavaScript errors caused by unescaped quote characters in translation strings (Matt Westcott)


2.6 (01.08.2019)
~~~~~~~~~~~~~~~~

 * Removed support for Python 3.4
 * Added support for `short_description` for field labels in modeladmin's `InspectView` (Wesley van Lee)
 * Rearranged SCSS folder structure to the client folder and split them approximately according to ITCSS. (Naomi Morduch Toubman, Jonny Scholes, Janneke Janssen, Hugo van den Berg)
 * Added support for specifying cell alignment on TableBlock (Samuel Mendes)
 * Added more informative error when a non-image object is passed to the `image` template tag (Deniz Dogan)
 * Added more ARIA landmarks across the admin interface and welcome page for screen reader users to navigate the CMS more easily (Beth Menzies)
 * Added ButtonHelper examples in the modelAdmin primer page within documentation (Kalob Taulien)
 * Multiple clarifications, grammar and typo fixes throughout documentation (Dan Swain)
 * Use correct URL in API example in documentation (Michael Bunsen)
 * Move datetime widget initializer JS into the widget's form media instead of page editor media (Matt Westcott)
 * Add form field prefixes for input forms in chooser modals (Matt Westcott)
 * Increase font-size across the whole admin (Beth Menzies, Katie Locke)
 * Improved text color contrast across the whole admin (Beth Menzies, Katie Locke)
 * Added consistent focus outline styles across the whole admin (Thibaud Colas)
 * Removed version number from the logo link’s title. The version can now be found under the Settings menu (Thibaud Colas)
 * Added "don't delete" option to confirmation screen when deleting images, documents and modeladmin models (Kevin Howbrook)
 * Added `branding_title` template block for the admin title prefix (Dillen Meijboom)
 * Add image dimensions in image gallery and image choosers for screen reader users (Helen Chapman)
 * Added support for custom search handler classes to modeladmin's IndexView, and added a class that uses the default Wagtail search backend for searching (Seb Brown, Andy Babic)
 * Improved heading structure for screen reader users navigating the CMS admin (Beth Menzies, Helen Chapman)
 * Updated group edit view to expose the Permission object for each checkbox (George Hickman)
 * Improve performance of Pages for Moderation panel (Fidel Ramos)
 * Add more contextual information for screen readers in the explorer menu’s links (Helen Chapman)
 * Added `process_child_object` and `exclude_fields` arguments to ``Page.copy()`` to make it easier for third-party apps to customize copy behavior (Karl Hobley)
 * Added `Page.with_content_json()`, allowing revision content loading behavior to be customized on a per-model basis (Karl Hobley)
 * Improved screen-reader labels for action links in page listing (Helen Chapman, Katie Locke)
 * Added screen-reader labels for table headings in page listing (Helen Chapman, Katie Locke)
 * Added screen reader labels for page privacy toggle, edit lock, status tag in page explorer & edit views (Helen Chapman, Katie Locke)
 * Added screen-reader labels for dashboard summary cards (Helen Chapman, Katie Locke)
 * Added screen-reader labels for privacy toggle of collections (Helen Chapman, Katie Locke)
 * Added `construct_settings_menu` hook (Jordan Bauer, Quadric)
 * Fixed compatibility of date / time choosers with wagtail-react-streamfield (Mike Hearn)
 * Performance optimization of several admin functions, including breadcrumbs, home and index pages (Fidel Ramos)
 * Fix: ModelAdmin no longer fails when filtering over a foreign key relation (Jason Dilworth, Matt Westcott)
 * Fix: The Wagtail version number is now visible within the Settings menu (Kevin Howbrook)
 * Fix: Scaling images now rounds values to an integer so that images render without errors (Adrian Brunyate)
 * Fix: Revised test decorator to ensure TestPageEditHandlers test cases run correctly (Alex Tomkins)
 * Fix: Wagtail bird animation in admin now ends correctly on all browsers (Deniz Dogan)
 * Fix: Explorer menu no longer shows sibling pages for which the user does not have access (Mike Hearn)
 * Fix: Fixed occurrences of invalid HTML across the CMS admin (Thibaud Colas)
 * Fix: Admin HTML now includes the correct `dir` attribute for the active language (Andreas Bernacca)
 * Fix: Fix type error when using `--chunk_size` argument on `./manage.py update_index` (Seb Brown)
 * Fix: Avoid rendering entire form in EditHandler's `repr` method (Alex Tomkins)
 * Fix: Add empty alt attributes to HTML output of Embedly and oEmbed embed finders (Andreas Bernacca)
 * Fix: Add empty alt attributes to all images in the CMS admin (Andreas Bernacca)
 * Fix: Make URL generator preview image alt translatable (Thibaud Colas)
 * Fix: Clear pending AJAX request if error occurs on page chooser (Matt Westcott)
 * Fix: Prevent text from overlapping in focal point editing UI (Beth Menzies)
 * Fix: Screen readers now announce "Dashboard" for the main nav’s logo link instead of Wagtail’s version number (Thibaud Colas)
 * Fix: Screen readers now treat page-level action dropdowns as navigation instead of menus (Helen Chapman)
 * Fix: Make icon font implementation more screen-reader-friendly (Thibaud Colas)
 * Fix: Remove duplicate labels in image gallery and image choosers for screen reader users (Helen Chapman)
 * Fix: Restore custom "Date" icon for scheduled publishing panel in Edit page’s Settings tab (Helen Chapman)
 * Fix: Added missing form media to user edit form template (Matt Westcott)
 * Fix: Add a label to the modals’ “close” button for screen reader users (Helen Chapman, Katie Locke)
 * Fix: Ensure the 'add child page' button displays when focused (Helen Chapman, Katie Locke)
 * Fix: Remove tab order customizations in CMS admin (Jordan Bauer)
 * Fix: Add labels to permission checkboxes for screen reader users (Helen Chapman, Katie Locke)
 * Fix: Page.copy() no longer copies child objects when the accessor name is included in `exclude_fields_in_copy` (Karl Hobley)
 * Fix: Move focus to the pages explorer menu when open (Helen Chapman)
 * Fix: Clicking the privacy toggle while the page is still loading no longer loads the wrong data in the page (Helen Chapman)
 * Fix: Added missing `is_stored_locally` method to `AbstractDocument` (jonny5532)
 * Fix: Query model no longer removes punctuation as part of string normalization (William Blackie)
 * Fix: Make login test helper work with user models with non-default username fields (Andrew Miller)
 * Fix: Delay dirty form check to prevent "unsaved changes" warning from being wrongly triggered (Thibaud Colas)
 * Fix: Make "Collection" and "Parent" form field labels translatable (Thibaud Colas)


2.5.2 (01.08.2019)
~~~~~~~~~~~~~~~~~~

 * Fix: Delay dirty form check to prevent "unsaved changes" warning from being wrongly triggered (Thibaud Colas)


2.5.1 (07.05.2019)
~~~~~~~~~~~~~~~~~~

 * Fix: Prevent crash when comparing StructBlocks in revision history (Adrian Turjak, Matt Westcott)


2.5 (24.04.2019)
~~~~~~~~~~~~~~~~

 * Django 2.2 support (Matt Westcott, Andy Babic)
 * Added support for customizing EditHandler-based forms on a per-request basis (Bertrand Bordage)
 * Added more informative error message when `|richtext` filter is applied to a non-string value (mukesh5)
 * Automatic search indexing can now be disabled on a per-model basis via the `search_auto_update` attribute (Karl Hobley)
 * Improved diffing of StreamFields when comparing page revisions (Karl Hobley)
 * Highlight broken links to pages and missing documents in rich text (Brady Moe)
 * Preserve links when copy-pasting rich text content from Wagtail to other tools (Thibaud Colas)
 * Rich text to contentstate conversion now prioritises more specific rules, to accommodate `<p>` and `<br>` elements with attributes (Matt Westcott)
 * Added limit image upload size by number of pixels (Thomas Elliott)
 * Added `manage.py wagtail_update_index` alias to avoid clashes with `update_index` commands from other packages (Matt Westcott)
 * Renamed `target_model` argument on `PageChooserBlock` to `page_type` (Loic Teixeira)
 * `edit_handler` and `panels` can now be defined on a `ModelAdmin` definition (Thomas Kremmel)
 * Add Learn Wagtail to third-party tutorials in documentation (Matt Westcott)
 * Add a Django setting `TAG_LIMIT` to limit number of tags that can be added to any taggit model (Mani)
 * Added instructions on how to generate urls for `ModelAdmin` to documentation (LB (Ben Johnston), Andy Babic)
 * Added option to specify a fallback URL on `{% pageurl %}` (Arthur Holzner)
 * Add support for more rich text formats, disabled by default: `blockquote`, `superscript`, `subscript`, `strikethrough`, `code` (Md Arifin Ibne Matin)
 * Added `max_count_per_parent` option on page models to limit the number of pages of a given type that can be created under one parent page (Wesley van Lee)
 * `StreamField` field blocks now accept a `validators` argument (Tom Usher)
 * Added edit / delete buttons to snippet index and "don't delete" option to confirmation screen, for consistency with pages (Kevin Howbrook)
 * Added support for Markdown shortcuts for inline formatting in rich text editor, e.g. `**` for bold, `_` for italic, etc. (Thibaud Colas)
 * Added name attributes to all built-in page action menu items (LB (Ben Johnston))
 * Added validation on the filter string to the Jinja2 image template tag (Jonny Scholes)
 * Changed the pages reordering UI toggle to make it easier to find (Katie Locke, Thibaud Colas)
 * Added support for rich text link rewrite handlers for `external` and `email` links (Md Arifin Ibne Matin)
 * Clarify installation instructions in documentation, especially regarding virtual environments. (Naomi Morduch Toubman)
 * Fix: Set `SERVER_PORT` to 443 in `Page.dummy_request()` for HTTPS sites (Sergey Fedoseev)
 * Fix: Include port number in `Host` header of `Page.dummy_request()` (Sergey Fedoseev)
 * Fix: Validation error messages in `InlinePanel` no longer count towards `max_num` when disabling the 'add' button (Todd Dembrey, Thibaud Colas)
 * Fix: Rich text to contentstate conversion now ignores stray closing tags (frmdstryr)
 * Fix: Escape backslashes in `postgres_search` queries (Hammy Goonan)
 * Fix: Parent page link in page chooser search results no longer navigates away (Asanka Lihiniyagoda, Sævar Öfjörð Magnússon)
 * Fix: `routablepageurl` tag now correctly omits domain part when multiple sites exist at the same root (Gassan Gousseinov)
 * Fix: Added missing collection column specifier on document listing template (Sergey Fedoseev)
 * Fix: Page Copy will now also copy ParentalManyToMany field relations (LB (Ben Johnston))
 * Fix: Admin HTML header now includes correct language code (Matt Westcott)
 * Fix: Unclear error message when saving image after focal point edit (Hugo van den Berg)
 * Fix: `send_mail` now correctly uses the `html_message` kwarg for HTML messages (Tiago Requeijo)
 * Fix: Page copying no longer allowed if page model has reached its `max_count` (Andy Babic)
 * Fix: Don't show page type on page chooser button when multiple types are allowed (Thijs Kramer)
 * Fix: Make sure page chooser search results correspond to the latest search by canceling previous requests (Esper Kuijs)
 * Fix: Inform user when moving a page from one parent to another where there is an already existing page with the same slug (Casper Timmers)
 * Fix: User add/edit forms now support form widgets with JS/CSS media (Damian Grinwis)
 * Fix: Rich text processing now preserves non-breaking spaces instead of converting them to normal spaces (Wesley van Lee)
 * Fix: Prevent autocomplete dropdowns from appearing over date choosers on Chrome (Kevin Howbrook)
 * Fix: Prevent crash when logging HTTP errors from Cloudflare (Kevin Howbrook)
 * Fix: Prevent rich text editor crash when filtering copy-pasted content and the last block is to be removed, e.g. unsupported image (Thibaud Colas)
 * Fix: Removing rich text links / documents now also works when the text selection is backwards (Thibaud Colas)
 * Fix: Prevent the rich text editor from crashing when copy-paste filtering removes all of its content (Thibaud Colas)
 * Fix: Page chooser now respects custom `get_admin_display_title` methods on parent page and breadcrumb (Haydn Greatnews)
 * Fix: Added consistent whitespace around sortable table headings (Matt Westcott)
 * Fix: Moved locale names for Chinese (Simplified) and Chinese (Traditional) to `zh_Hans` and `zh_Hant` (Matt Westcott)
 * Fix: Increase max length on `Embed.thumbnail_url` to 255 characters (Kevin Howbrook)


2.4 (19.12.2018)
~~~~~~~~~~~~~~~~

 * Added support for Python 3.7 (Matt Westcott)
 * Removed support for Django 1.11 (Matt Westcott)
 * Added `max_count` option on page models to limit the number of pages of a particular type that can be created (Dan Braghis)
 * Document and image choosers now show the document / image's collection (Alejandro Garza, Janneke Janssen)
 * Added new "Welcome to your Wagtail site" Starter Page when using wagtail start command (Timothy Allen, Scott Cranfill)
 * Added ability to run individual tests through tox (Benjamin Bach)
 * Collection listings are now ordered by name (Seb Brown)
 * Added `file_hash` field to documents (Karl Hobley, Dan Braghis)
 * Added last login to the user overview (Noah B Johnson)
 * Changed design of image editing page (Janneke Janssen, Ben Enright)
 * Added Slovak character map for JavaScript slug generation (Andy Chosak)
 * Make documentation links on welcome page work for prereleases (Matt Westcott)
 * Allow overridden `copy()` methods in `Page` subclasses to be called from the page copy view (Robert Rollins)
 * Users without a preferred language set on their profile now use language selected by Django's `LocaleMiddleware` (Benjamin Bach)
 * Added hooks to customize the actions menu on the page create/edit views (Matt Westcott)
 * Cleanup: Use `functools.partial()` instead of `django.utils.functional.curry()` (Sergey Fedoseev)
 * Squashed migrations for wagtailimages (Karl Hobley)
 * Added `before_move_page` and `after_move_page` hooks (Maylon Pedroso)
 * Bulk deletion button for snippets is now hidden until items are selected (Karl Hobley)
 * Fix: Query objects returned from `PageQuerySet.type_q` can now be merged with `|` (Brady Moe)
 * Fix: Add `rel="noopener noreferrer"` to target blank links (Anselm Bradford)
 * Fix: Additional fields on custom document models now show on the multiple document upload view (Robert Rollins, Sergey Fedoseev)
 * Fix: Help text is partially hidden when using a combination of BooleanField and FieldPanel in page model (Dzianis Sheka)
 * Fix: Allow custom logos of any height in the admin menu (Meteor0id)
 * Fix: Allow nav menu to take up all available space instead of scrolling (Meteor0id)
 * Fix: Redirects now return 404 when destination is unspecified or a page with no site (Hillary Jeffrey)
 * Fix: Refactor all breakpoint definitions, removing style overlaps (Janneke Janssen)
 * Fix: Updated draftjs_exporter to 2.1.5 to fix bug in handling adjacent entities (Thibaud Colas)
 * Fix: Page titles consisting only of stopwords now generate a non-empty default slug (Andy Chosak, Janneke Janssen)
 * Fix: Sitemap generator now allows passing a sitemap instance in the URL configuration (Mitchel Cabuloy, Dan Braghis)


2.3 LTS (23.10.2018)
~~~~~~~~~~~~~~~~~~~~

 * Added support for Django 2.1 (Ryan Verner, Matt Westcott)
 * Improved color contrast (Coen van der Kamp, Naomi Morduch Toubman, Naa Marteki Reed, Edd Baldry, Ben Enright)
 * Added 'scale' image filter (Oliver Wilkerson)
 * Added meta tag to prevent search engines from indexing admin pages (Karl Hobley)
 * EmbedBlock now validates against recognized embed providers on save (Bertrand Bordage)
 * Made cache control headers on Wagtail admin consistent with Django admin (Tomasz Knapik)
 * Notification emails now include an "Auto-Submitted: auto-generated" header (Dan Braghis)
 * Image chooser panels now show alt text as title (Samir Shah)
 * Added `download_url` field to images in the API (Michael Harrison)
 * Dummy requests for preview now preserve the HTTP Authorization header (Ben Dickinson)
 * Fix: Respect next param on login (Loic Teixeira)
 * Fix: InlinePanel now handles relations that specify a related_query_name (Aram Dulyan)
 * Fix: before_delete_page / after_delete_page hooks now run within the same database transaction as the page deletion (Tomasz Knapik)
 * Fix: Snippet chooser modal no longer fails on snippet models with UUID primary keys (Sævar Öfjörð Magnússon)
 * Fix: Restored localization in date/time pickers (David Moore, Thibaud Colas)
 * Fix: Tag input field no longer treats 'б' on Russian keyboards as a comma (Michael Borisov)
 * Fix: Disabled autocomplete dropdowns on date/time chooser fields (Janneke Janssen)
 * Fix: Split up `wagtail.admin.forms` to make it less prone to circular imports (Matt Westcott)
 * Fix: Disable linking to root page in rich text, making the page non-functional (Matt Westcott)
 * Fix: Pages should be editable and save-able even if there are broken page or document links in rich text (Matt Westcott)
 * Fix: Avoid redundant round-trips of JSON StreamField data on save, improving performance and preventing consistency issues on fixture loading (Andy Chosak, Matt Westcott)
 * Fix: Users are not logged out when changing their own password through the Users area (Matt Westcott)


2.2.2 (29.08.2018)
~~~~~~~~~~~~~~~~~~

 * Fix: Seek to the beginning of image files when uploading, to restore compatibility with django-storages Google Cloud and Azure backends (Mikalai Radchuk)
 * Fix: Respect next param on login (Loic Teixeira)


2.2.1 (13.08.2018)
~~~~~~~~~~~~~~~~~~

 * Fix: Pin Beautiful Soup to 4.6.0 due to further regressions in formatting empty elements (Matt Westcott)
 * Fix: Prevent AppRegistryNotReady error when wagtail.contrib.sitemaps is in INSTALLED_APPS (Matt Westcott)


2.2 (10.08.2018)
~~~~~~~~~~~~~~~~

 * Added faceted search using the `.facet()` method (Karl Hobley)
 * Added page type filtering and ordering to the Wagtail admin page search (Karl Hobley)
 * Added another valid AudioBoom oEmbed pattern (Bertrand Bordage)
 * Added `annotate_score` support to PostgreSQL search backend (Bertrand Bordage)
 * Pillow's image optimization is now applied when saving PNG images (Dmitry Vasilev)
 * JS / CSS media files can now be associated with Draftail feature definitions (Matt Westcott)
 * The `{% slugurl %}` template tag is now site-aware (Samir Shah)
 * Added `file_size` field to documents (Karl Hobley)
 * Added `file_hash` field to images (Karl Hobley)
 * Update documentation (configuring Django for Wagtail) to contain all current settings options (Matt Westcott, LB (Ben Johnston))
 * Added `defer` flag to `PageQuerySet.specific` (Karl Hobley)
 * Snippets can now be deleted from the listing view (LB (Ben Johnston))
 * Increased max length of redirect URL field to 255 (Michael Harrison)
 * Added documentation for new JS/CSS media files association with Draftail feature definitions (Ed Henderson)
 * Added accessible color contrast guidelines to the style guide (Catherine Farman)
 * Admin modal views no longer rely on JavaScript `eval()`, for better CSP compliance (Matt Westcott)
 * Update editor guide for embeds and documents in rich text (Kevin Howbrook)
 * Improved performance of sitemap generation (Michael van Tellingen, Bertrand Bordage)
 * Added an internal API for autocomplete (Karl Hobley, Bertrand Bordage)
 * Fix: Handle all exceptions from `Image.get_file_size` (Andrew Plummer)
 * Fix: Fix display of breadcrumbs in ModelAdmin (LB (Ben Johnston))
 * Fix: Remove duplicate border radius of avatars (Benjamin Thurm)
 * Fix: Site.get_site_root_paths() preferring other sites over the default when some sites share the same root_page (Andy Babic)
 * Fix: Pages with missing model definitions no longer crash the API (Abdulmalik Abdulwahab)
 * Fix: Rich text image chooser no longer skips format selection after a validation error (Matt Westcott)
 * Fix: Null characters in URLs no longer crash the redirect middleware on PostgreSQL (Andrew Crewdson, Matt Westcott)
 * Fix: Permission checks no longer prevent a non-live page from being unscheduled (Abdulmalik Abdulwahab)
 * Fix: Copy-paste between Draftail editors now preserves all formatting/content (Thibaud Colas)
 * Fix: Fix alignment of checkboxes and radio buttons on Firefox (Matt Westcott)


2.1.3 (13.08.2018)
~~~~~~~~~~~~~~~~~~

 * Fix: Pin Beautiful Soup to 4.6.0 due to further regressions in formatting empty elements (Matt Westcott)


2.1.2 (06.08.2018)
~~~~~~~~~~~~~~~~~~

 * Fix: Bundle the l18n package to avoid installation issues on systems with a non-Unicode locale (Matt Westcott)
 * Fix: Mark Beautiful Soup 4.6.1 as incompatible due to bug in formatting empty elements (Matt Westcott)


2.1.1 (04.07.2018)
~~~~~~~~~~~~~~~~~~

 * Fix: Site.get_site_root_paths() preferring other sites over the default when some sites share the same root_page (Andy Babic)
 * Fix: Rich text image chooser no longer skips format selection after a validation error (Matt Westcott)
 * Fix: Null characters in URLs no longer crash the redirect middleware on PostgreSQL (Matt Westcott)


2.1 (22.05.2018)
~~~~~~~~~~~~~~~~

 * Add `HelpPanel` to add HTML within an edit form (Keving Chung)
 * Added direct profile picture upload to account preferences (Daniel Chimeno, Pierre Geier, Matt Westcott)
 * Added API endpoint for finding pages by HTML path (Karl Hobley)
 * Added time zone setting to account preferences (David Moore)
 * Added Elasticsearch 6 support (Karl Hobley)
 * Persist tab hash in URL to allow direct navigation to tabs in the admin interface (Ben Weatherman)
 * Animate the chevron icon when opening sub-menus in the admin (Carlo Ascani)
 * Look through the target link and target page slug (in addition to the old slug) when searching for redirects in the admin (Michael Harrison)
 * Remove support for IE6 to IE9 from project template (Samir Shah)
 * Remove outdated X-UA-Compatible meta from admin template  (Thibaud Colas)
 * Add JavaScript source maps in production build for packaged Wagtail (Thibaud Colas)
 * Removed `assert` statements from Wagtail API (Kim Chee Leong)
 * Update `jquery-datetimepicker` dependency to make Wagtail more CSP-friendly (`unsafe-eval`) (Pomax)
 * Added error notification when running the `wagtail` command on Python <3.4 (Matt Westcott)
 * `update_index` management command now accepts a `--chunk_size` option to determine the number of items to load at once (Dave Bell)
 * Added hook `register_account_menu_item` to add new account preference items (Michael van Tellingen)
 * Added change email functionality from the account settings (Alejandro Garza, Alexs Mathilda)
 * Add request parameter to edit handlers (Rajeev J Sebastian)
 * ImageChooser now sets a default title based on filename (Coen van der Kamp)
 * Added error handling to the Draftail editor (Thibaud Colas)
 * Add new `wagtail_icon` template tag to facilitate making admin icons accessible (Sander Tuit)
 * Set `ALLOWED_HOSTS` in the project template to allow any host in development (Tom Dyson)
 * Expose reusable client-side code to build Draftail extensions (Thibaud Colas)
 * Added `WAGTAILFRONTENDCACHE_LANGUAGES` setting to specify the languages whose URLs are to be purged when using `i18n_patterns` (PyMan Claudio Marinozzi)
 * Added `extra_footer_actions` template blocks for customizing the add/edit page views (Arthur Holzner)
 * Fix: Status button on 'edit page' now links to the correct URL when live and draft slug differ (LB (Ben Johnston))
 * Fix: Image title text in the gallery and in the chooser now wraps for long filenames (LB (Ben Johnston), Luiz Boaretto)
 * Fix: Move image editor action buttons to the bottom of the form on mobile (Julian Gallo)
 * Fix: StreamField icons are now correctly sorted into groups on the 'append' menu (Tim Heap)
 * Fix: Draftail now supports features specified via the `WAGTAILADMIN_RICH_TEXT_EDITORS` setting (Todd Dembrey)
 * Fix: Password reset form no longer indicates whether the email is recognized, as per standard Django behavior (Bertrand Bordage)
 * Fix: `UserAttributeSimilarityValidator` is now correctly enforced on user creation / editing forms (Tim Heap)
 * Fix: Focal area removal not working in IE11 and MS Edge (Thibaud Colas)
 * Fix: Rewrite password change feedback message to be more user-friendly (Casper Timmers)
 * Fix: Correct dropdown arrow styling in Firefox, IE11 (Janneke Janssen, Alexs Mathilda)
 * Fix: Password reset no indicates specific validation errors on certain password restrictions (Lucas Moeskops)
 * Fix: Confirmation page on page deletion now respects custom `get_admin_display_title` methods (Kim Chee Leong)
 * Fix: Adding external link with selected text now includes text in link chooser (Tony Yates, Thibaud Colas, Alexs Mathilda)
 * Fix: Editing setting object with no site configured no longer crashes (Harm Zeinstra)
 * Fix: Creating a new object with inlines while mandatory fields are empty no longer crashes (Bertrand Bordage)
 * Fix: Localization of image and apps verbose names
 * Fix: Draftail editor no longer crashes after deleting image/embed using DEL key (Thibaud Colas)
 * Fix: Breadcrumb navigation now respects custom `get_admin_display_title` methods (Arthur Holzner, Wietze Helmantel, Matt Westcott)
 * Fix: Inconsistent order of heading features when adding h1, h5 or h6 as default feature for Hallo RichText editor (Loic Teixeira)
 * Fix: Add invalid password reset link error message (Coen van der Kamp)
 * Fix: Bypass select/prefetch related optimization on `update_index` for `ParentalManyToManyField` to fix crash (Tim Kamanin)
 * Fix: 'Add user' is now rendered as a button due to the use of quotes within translations (Benoît Vogel)
 * Fix: Menu icon no longer overlaps with title in Modeladmin on mobile (Coen van der Kamp)
 * Fix: Background color overflow within the Wagtail documentation (Sergey Fedoseev)
 * Fix: Page count on homepage summary panel now takes account of user permissions (Andy Chosak)
 * Fix: Explorer view now prevents navigating outside of the common ancestor of the user's permissions (Andy Chosak)
 * Fix: Generate URL for the current site when multiple sites share the same root page (Codie Roelf)
 * Fix: Restored ability to use non-model fields with FieldPanel (Matt Westcott, LB (Ben Johnston))
 * Fix: Stop revision comparison view from crashing when non-model FieldPanels are in use (LB (Ben Johnston))
 * Fix: Ordering in the page explorer now respects custom `get_admin_display_title` methods when sorting <100 pages (Matt Westcott)
 * Fix: Use index-specific Elasticsearch endpoints for bulk insertion, for compatibility with providers that lock down the root endpoint (Karl Hobley)
 * Fix: Fix usage URL on the document edit page (Jérôme Lebleu)


2.0.2 (13.08.2018)
~~~~~~~~~~~~~~~~~~

 * Fix: Restored ability to use non-model fields with FieldPanel (Matt Westcott, LB (Ben Johnston))
 * Fix: Fix usage URL on the document edit page (Jérôme Lebleu)
 * Fix: Pin Beautiful Soup to 4.6.0 due to further regressions in formatting empty elements (Matt Westcott)


2.0.1 (04.04.2018)
~~~~~~~~~~~~~~~~~~

 * Added error notification when running the `wagtail` command on Python <3.4 (Matt Westcott)
 * Added error handling to the Draftail editor (Thibaud Colas)
 * Fix: Draftail now supports features specified via the `WAGTAILADMIN_RICH_TEXT_EDITORS` setting (Todd Dembrey)
 * Fix: Password reset form no longer indicates whether the email is recognized, as per standard Django behavior (Bertrand Bordage)
 * Fix: `UserAttributeSimilarityValidator` is now correctly enforced on user creation / editing forms (Tim Heap)
 * Fix: Editing setting object with no site configured no longer crashes (Harm Zeinstra)
 * Fix: Creating a new object with inlines while mandatory fields are empty no longer crashes (Bertrand Bordage)


2.0 (28.02.2018)
~~~~~~~~~~~~~~~~

 * Added support for Django 2.0 (Matt Westcott, Karl Hobley, LB (Ben Johnston), Mads Jensen)
 * Reorganised module paths (Karl Hobley, Matt Westcott)
 * Replaced the hallo.js rich text editor with Draftail (Thibaud Colas, Loïc Teixeira, Matt Westcott)
 * Removed support for Python 2.7, Django 1.8 and Django 1.10
 * Removed support for Elasticsearch 1.x
 * Added the ability to schedule updates to existing published pages (Patrick Woods)
 * Moved Wagtail API v1 implementation (`wagtail.contrib.api`) to an external app (https://github.com/wagtail/wagtailapi_legacy) (Karl Hobley)
 * The page chooser now searches all fields of a page, instead of just the title (Bertrand Bordage)
 * Implement ordering by date in form submission view (LB (Ben Johnston))
 * Elasticsearch scroll API is now used when fetching more than 100 search results (Karl Hobley)
 * Added hidden field to the form builder (Ross Crawford-d'Heureuse)
 * Usage count now shows on delete confirmation page when WAGTAIL_USAGE_COUNT_ENABLED is active (Kees Hink)
 * Added usage count to snippets (Kees Hink)
 * Moved usage count to the sidebar on the edit page (Kees Hink)
 * Explorer menu now reflects customizations to the page listing made via the `construct_explorer_page_queryset` hook and `ModelAdmin.exclude_from_explorer` property (Tim Heap)
 * "Choose another image" button changed to "Change image" to avoid ambiguity (Edd Baldry)
 * Added hooks `before_create_user`, `after_create_user`, `before_delete_user`, `after_delete_user`, `before_edit_user`, `after_edit_user` (Jon Carmack)
 * Added `exclude_fields_in_copy` property to Page to define fields that should not be included on page copy (LB (Ben Johnston))
 * Improved error message on incorrect `{% image %}` tag syntax (LB (Ben Johnston))
 * Optimised preview data storage (Bertrand Bordage)
 * Added `render_landing_page` method to `AbstractForm` to be easily overridden and pass `form_submission` to landing page context (Stein Strindhaug)
 * Added `heading` kwarg to `InlinePanel` to allow heading to be set independently of button label (Adrian Turjak)
 * The value type returned from a `StructBlock` can now be customized (LB (Ben Johnston))
 * Added `bgcolor` image operation (Karl Hobley)
 * Added `WAGTAILADMIN_USER_LOGIN_FORM` setting for overriding the admin login form (Mike Dingjan)
 * Snippets now support custom primary keys (Sævar Öfjörð Magnússon)
 * Upgraded jQuery to version 3.2.1 (Janneke Janssen)
 * Updated documentation styling (LB (Ben Johnston))
 * Rich text fields now take feature lists into account when whitelisting HTML elements (Matt Westcott)
 * FormPage lists and Form submission lists in admin now use class based views for easy overriding (Johan Arensman)
 * Form submission csv exports now have the export date in the filename and can be customized (Johan Arensman)
 * FormBuilder class now uses bound methods for field generation, adding custom fields is now easier and documented (LB (Ben) Johnston)
 * Added `WAGTAILADMIN_NOTIFICATION_INCLUDE_SUPERUSERS` setting to determine whether superusers are included in moderation email notifications (Bruno Alla)
 * Added a basic Dockerfile to the project template (Tom Dyson)
 * StreamField blocks now allow custom `get_template` methods for overriding templates in instances (Christopher Bledsoe)
 * Simplified edit handler API (Florent Osmont, Bertrand Bordage)
 * Made 'add/change/delete collection' permissions configurable from the group edit page (Matt Westcott)
 * Update autoprefixer configuration to better match browser support targets (Janneke Janssen)
 * Update React and related dependencies to latest versions (Janneke Janssen, Hugo van den Berg)
 * Remove Hallo editor `.richtext` CSS class in favor of more explicit extension points (Thibaud Colas)
 * Expose React-related dependencies as global variables for extension in the admin interface (Thibaud Colas)
 * Added helper functions for constructing form data for use with `assertCanCreate` (Tim Heap, Matt Westcott)
 * Fix: Do not remove stopwords when generating slugs from non-ASCII titles, to avoid issues with incorrect word boundaries (Sævar Öfjörð Magnússon)
 * Fix: The PostgreSQL search backend now preserves ordering of the `QuerySet` when searching with `order_by_relevance=False` (Bertrand Bordage)
 * Fix: Using `modeladmin_register` as a decorator no longer replaces the decorated class with `None` (Tim Heap)
 * Fix: Fixed crash in XML sitemap generator when all pages on the site are private (Stein Strindhaug)
 * Fix: The `{% routablepageurl %}` template tag no longer generates invalid URLs when the `WAGTAIL_APPEND_SLASH` setting was set to `False` (Venelin Stoykov)
 * Fix: The "View live" button is no longer shown if the page doesn't have a routable URL (Tim Heap)
 * Fix: Fixed rendering of border on dropdown arrow buttons on Chrome (Bertrand Bordage)
 * Fix: Fixed incorrect z-index on userbar causing it to appear behind page content (Stein Strindhaug)
 * Fix: Form submissions pagination no longer looses date filter when changing page (Bertrand Bordage)
 * Fix: PostgreSQL search backend now removes duplicate page instances from the database (Bertrand Bordage)
 * Fix: `FormSubmissionsPanel` now recognizes custom form submission classes (LB (Ben Johnston))
 * Fix: Prevent the footer and revisions link from unnecessarily collapsing on mobile (Jack Paine)
 * Fix: Empty searches were activated when paginating through images and documents (LB (Ben Johnston))
 * Fix: Summary numbers of pages, images and documents were not responsive when greater than 4 digits (Michael Palmer)
 * Fix: Project template now has password validators enabled by default (Matt Westcott)
 * Fix: Alignment options correctly removed from `TableBlock` context menu (LB (Ben Johnston))
 * Fix: Fix support of `ATOMIC_REBUILD` for projects with Elasticsearch client >=1.7.0 (Mikalai Radchuk)
 * Fix: Fixed error on Elasticsearch backend when passing a queryset as an `__in` filter (Karl Hobley, Matt Westcott)
 * Fix: `__isnull` filters no longer fail on Elasticsearch 5 (Karl Hobley)
 * Fix: Prevented intermittent failures on Postgres search backend when a field is defined as both a `SearchField` and a `FilterField` (Matt Westcott)
 * Fix: Alt text of images in rich text is no longer truncated on double-quote characters (Matt Westcott)
 * Fix: Ampersands in embed URLs within rich text are no longer double-escaped (Matt Westcott)
 * Fix: Using RGBA images no longer crashes with Pillow >= 4.2.0 (Karl Hobley)
 * Fix: Copying a page with PostgreSQL search enabled no longer crashes (Bertrand Bordage)
 * Fix: Style of the page unlock button was broken (Bertrand Bordage)
 * Fix: Admin search no longer floods browser history (Bertrand Bordage)
 * Fix: Version comparison now handles custom primary keys on inline models correctly (LB (Ben Johnston))
 * Fix: Fixed error when inserting chooser panels into FieldRowPanel (Florent Osmont, Bertrand Bordage)
 * Fix: Reinstated missing error reporting on image upload (Matt Westcott)
 * Fix: Only load Hallo CSS if Hallo is in use (Thibaud Colas)
 * Fix: Prevent style leak of Wagtail panel icons in widgets using ``h2`` elements (THibaud Colas)


1.13.4 (13.08.2018)
~~~~~~~~~~~~~~~~~~~

 * Fix: Pin Beautiful Soup to 4.6.0 due to further regressions in formatting empty elements (Matt Westcott)


1.13.3 (13.08.2018)
~~~~~~~~~~~~~~~~~~~

 * Fix: Pin django-taggit to <0.23 to restore Django 1.8 compatibility (Matt Westcott)
 * Fix: Mark Beautiful Soup 4.6.1 as incompatible due to bug in formatting empty elements (Matt Westcott)


1.13.2 (04.07.2018)
~~~~~~~~~~~~~~~~~~~

 * Fix: Fix support of `ATOMIC_REBUILD` for projects with Elasticsearch client >=1.7.0 (Mikalai Radchuk)
 * Fix: Logging an indexing failure on an object with a non-ASCII representation no longer crashes on Python 2 (Aram Dulyan)
 * Fix: Rich text image chooser no longer skips format selection after a validation error (Matt Westcott)
 * Fix: Null characters in URLs no longer crash the redirect middleware on PostgreSQL (Matt Westcott)


1.13.1 (17.11.2017)
~~~~~~~~~~~~~~~~~~~

 * Fix: API listing views no longer fail when no site records are defined (Karl Hobley)
 * Fix: Fixed crash in XML sitemap generator when all pages on the site are private (Stein Strindhaug)
 * Fix: Fixed incorrect z-index on userbar causing it to appear behind page content (Stein Strindhaug)
 * Fix: Fixed error in Postgres search backend when searching specific fields of a specific() Page queryset (Bertrand Bordage, Matt Westcott)
 * Fix: Fixed error on Elasticsearch backend when passing a queryset as an `__in` filter (Karl Hobley, Matt Westcott)
 * Fix: `__isnull` filters no longer fail on Elasticsearch 5 (Karl Hobley)
 * Fix: Prevented intermittent failures on Postgres search backend when a field is defined as both a `SearchField` and a `FilterField` (Matt Westcott)


1.13 LTS (16.10.2017)
~~~~~~~~~~~~~~~~~~~~~

 * Front-end cache invalidator now supports purging URLs as a batch (Karl Hobley)
 * Custom document model is now documented (Emily Horsman)
 * Use minified versions of CSS in the admin by adding minification to the front-end tooling (Vincent Audebert, Thibaud Colas)
 * Wagtailforms serve view now passes `request.FILES`, for use in custom form handlers (LB (Ben Johnston))
 * Documents and images are now given new filenames on re-uploading, to avoid old versions being kept in cache (Bertrand Bordage)
 * Added custom 404 page for admin interface (Jack Paine)
 * Breadcrumb navigation now uses globe icon to indicate tree root, rather than home icon (Matt Westcott)
 * Updated React to 15.6.2 due to relicensing (Janneke Janssen)
 * User search in the Wagtail admin UI now works across multiple fields (Will Giddens)
 * `Page.last_published_at` is now a filterable field for search (Mikalai Radchuk)
 * Page search results and usage listings now include navigation links (Matt Westcott)
 * Fix: "Open Link in New Tab" on a right arrow in page explorer should open page list (Emily Horsman)
 * Fix: Using `order_by_relevance=False` when searching with PostgreSQL now works (Mitchel Cabuloy)
 * Fix: Inline panel first and last sorting arrows correctly hidden in non-default tabs (Matt Westcott)
 * Fix: `WAGTAILAPI_LIMIT_MAX` now accepts None to disable limiting (jcronyn)
 * Fix: In PostgreSQL, new default ordering when ranking of objects is the same (Bertrand Bordage)
 * Fix: Fixed overlapping header elements on form submissions view on mobile (Jack Paine)
 * Fix: Fixed avatar position in footer on mobile (Jack Paine)
 * Fix: Custom document models no longer require their own post-delete signal handler (Gordon Pendleton)
 * Fix: Deletion of image / document files now only happens when database transaction has completed (Gordon Pendleton)
 * Fix: Fixed Node build scripts to work on Windows (Mikalai Radchuk)
 * Fix: Stop breadcrumb home icon from showing as ellipsis in Chrome 60 (Matt Westcott)
 * Fix: Prevent `USE_THOUSAND_SEPARATOR = True` from breaking the image focal point chooser (Sævar Öfjörð Magnússon)
 * Fix: Removed deprecated `SessionAuthenticationMiddleware` from project template (Samir Shah)
 * Fix: Custom display page titles defined with `get_admin_display_title` are now shown in search results (Ben Sturmfels, Matt Westcott)
 * Fix: Custom PageManagers now return the correct PageQuerySet subclass (Matt Westcott)
 * Fix: API listing views no longer fail when no site records are defined (Karl Hobley)


1.12.6 (13.08.2018)
~~~~~~~~~~~~~~~~~~~

 * Fix: Pin Beautiful Soup to 4.6.0 due to further regressions in formatting empty elements (Matt Westcott)


1.12.5 (13.08.2018)
~~~~~~~~~~~~~~~~~~~

 * Fix: Pin django-taggit to <0.23 to restore Django 1.8 compatibility (Matt Westcott)
 * Fix: Mark Beautiful Soup 4.6.1 as incompatible due to bug in formatting empty elements (Matt Westcott)


1.12.4 (04.07.2018)
~~~~~~~~~~~~~~~~~~~

 * Fix: Fix support of `ATOMIC_REBUILD` for projects with Elasticsearch client >=1.7.0 (Mikalai Radchuk)
 * Fix: Logging an indexing failure on an object with a non-ASCII representation no longer crashes on Python 2 (Aram Dulyan)
 * Fix: Rich text image chooser no longer skips format selection after a validation error (Matt Westcott)
 * Fix: Null characters in URLs no longer crash the redirect middleware on PostgreSQL (Matt Westcott)


1.12.3 (17.11.2017)
~~~~~~~~~~~~~~~~~~~

 * Fix: API listing views no longer fail when no site records are defined (Karl Hobley)
 * Fix: Pinned Django REST Framework to <3.7 to restore Django 1.8 compatibility (Matt Westcott)
 * Fix: Fixed crash in XML sitemap generator when all pages on the site are private (Stein Strindhaug)
 * Fix: Fixed error in Postgres search backend when searching specific fields of a specific() Page queryset (Bertrand Bordage, Matt Westcott)
 * Fix: Fixed error on Elasticsearch backend when passing a queryset as an `__in` filter (Karl Hobley, Matt Westcott)
 * Fix: `__isnull` filters no longer fail on Elasticsearch 5 (Karl Hobley)
 * Fix: Prevented intermittent failures on Postgres search backend when a field is defined as both a `SearchField` and a `FilterField` (Matt Westcott)


1.12.2 (18.09.2017)
~~~~~~~~~~~~~~~~~~~

 * Fix: Migration for addition of `Page.draft_title` field is now reversible (Venelin Stoykov)
 * Fix: Fixed failure on application startup when `ManifestStaticFilesStorage` is in use and `collectstatic` has not yet been run (Matt Westcott)
 * Fix: Fixed handling of Vimeo and other oEmbed providers with a format parameter in the endpoint URL (Mitchel Cabuloy)
 * Fix: Fixed regression in rendering save button in wagtail.contrib.settings edit view (Matt Westcott)


1.12.1 (30.08.2017)
~~~~~~~~~~~~~~~~~~~

 * Fix: Prevent home page draft title from displaying as blank (Mikalai Radchuk, Matt Westcott)
 * Fix: Fix regression on styling of preview button with more than one preview mode (Jack Paine)
 * Fix: Enabled translations within date-time chooser widget (Lucas Moeskops)


1.12 LTS (21.08.2017)
~~~~~~~~~~~~~~~~~~~~~

 * Ability to configure the feature set of rich text fields on a per-field basis (Matt Westcott)
 * New class-based configuration for media embeds (Karl Hobley)
 * The admin interface now displays a title of the latest draft (Mikalai Radchuk)
 * `RoutablePageMixin` now has a default "index" route (Andreas Nüßlein, Matt Westcott)
 * Added multi-select form field to the form builder (dwasyl)
 * Improved performance of sitemap generation (Levi Adler)
 * StreamField now respects the `blank` setting; StreamBlock accepts a `required` setting (Loic Teixeira)
 * StreamBlock now accepts `min_num`, `max_num` and `block_counts` settings to control the minimum and maximum numbers of blocks (Edwar Baron, Matt Westcott)
 * Users can no longer remove their own active / superuser flags through Settings -> Users (Stein Strindhaug, Huub Bouma)
 * The `process_form_submission` method of form pages now return the created form submission object (cho-leukeleu)
 * Added `WAGTAILUSERS_PASSWORD_ENABLED` and `WAGTAILUSERS_PASSWORD_REQUIRED` settings to permit creating users with no Django-side passwords, to support external authentication setups (Matt Westcott)
 * Added help text parameter to `DecimalBlock` and `RegexBlock` (Tomasz Knapik)
 * Optimised caudal oscillation parameters on logo (Jack Paine)
 * Fix: FieldBlocks in StreamField now call the field's `prepare_value` method (Tim Heap)
 * Fix: Initial disabled state of InlinePanel add button is now set correctly on non-default tabs (Matthew Downey)
 * Fix: Redirects with unicode characters now work (Rich Brennan)
 * Fix: Prevent explorer view from crashing when page model definitions are missing, allowing the offending pages to be deleted (Matt Westcott)
 * Fix: Hide the userbar from printed page representation (Eugene Morozov)
 * Fix: Prevent the page editor footer content from collapsing into two lines unnecessarily (Jack Paine)
 * Fix: StructBlock values no longer render HTML templates as their `str` representation, to prevent infinite loops in debugging / logging tools (Matt Westcott)
 * Fix: Removed deprecated jQuery ``load`` call from TableBlock initialisation (Jack Paine)
 * Fix: Position of options in mobile nav-menu (Jack Paine)
 * Fix: Center page editor footer regardless of screen width (Jack Paine)
 * Fix: Change the design of the navbar toggle icon so that it no longer obstructs page headers (Jack Paine)
 * Fix: Document add/edit forms no longer render container elements for hidden fields (Jeffrey Chau)


1.11.1 (07.07.2017)
~~~~~~~~~~~~~~~~~~~

 * Fix: Custom display page titles defined with `get_admin_display_title` are now shown within the page explorer menu (Matt Westcott, Janneke Janssen)


1.11 (30.06.2017)
~~~~~~~~~~~~~~~~~

 * Added a new page explorer menu built with the admin API and React (Karl Hobley, Josh Barr, Thibaud Colas, Janneke Janssen, Rob Moorman, Maurice Bartnig, Jonny Scholes, Matt Westcott, Sævar Öfjörð Magnússon, Eirikur Ingi Magnusson, Harris Lapiroff, Hugo van den Berg, Olly Willans, Andy Babic, Ben Enright, Bertrand Bordage)
 * Added privacy settings for documents (Ulrich Wagner, Matt Westcott)
 * Optimised page URL generation by caching site paths in the request scope (Tobias McNulty, Matt Westcott)
 * The current live version of a page is now tracked on the revision listing view (Matheus Bratfisch)
 * Each block created in a `StreamField` is now assigned a globally unique identifier (Matt Westcott)
 * Mixcloud oEmbed pattern has been updated (Alice Rose)
 * Added `last_published_at` field to the Page model (Matt Westcott)
 * Added `show_in_menus_default` flag on page models, to allow "show in menus" to be checked by default (LB (Ben Johnston))
 * "Copy page" form now validates against copying to a destination where the user does not have permission (Henk-Jan van Hasselaar)
 * Allows reverse relations in `RelatedFields` for elasticsearch & PostgreSQL search backends (Lucas Moeskops, Bertrand Bordage)
 * Added oEmbed support for Facebook (Mikalai Radchuk)
 * Added oEmbed support for Tumblr (Mikalai Radchuk)
 * Fix: Unauthenticated AJAX requests to admin views now return 403 rather than redirecting to the login page (Karl Hobley)
 * Fix: `TableBlock` options `afterChange`, `afterCreateCol`, `afterCreateRow`, `afterRemoveCol`, `afterRemoveRow` and `contextMenu` can now be overridden (Loic Teixeira)
 * Fix: The lastmod field returned by wagtailsitemaps now shows the last published date rather than the date of the last draft edit (Matt Westcott)
 * Fix: Document chooser upload form no longer renders container elements for hidden fields (Jeffrey Chau)
 * Fix: Prevented exception when visiting a preview URL without initiating the preview (Paul Kamp)


1.10.1 (19.05.2017)
~~~~~~~~~~~~~~~~~~~

 * Fix: Fix admin page preview that was broken 24 hours after previewing a page (Martin Hill)
 * Fix: Removed territory-specific translations for Spanish, Polish, Swedish, Russian and Chinese (Taiwan) that block more complete translations from being used (Matt Westcott)


1.10 (03.05.2017)
~~~~~~~~~~~~~~~~~

 * Added PostgreSQL search engine (Bertrand Bordage, Jaap Roes, Arne de Laat, Ramon de Jezus)
 * Django 1.11 support (Tim Graham, Matt Westcott, Mikalai Radchuk, Bertrand Bordage)
 * Dropped Django 1.9 and Python 3.3 support; note that Django 1.8.x is still supported
 * Added user-preferred admin language along with `WAGTAILADMIN_PERMITTED_LANGUAGES` (Daniel Chimeno)
 * Added `WAGTAIL_AUTO_UPDATE_PREVIEW` setting that when set to `True`, allows the preview window to be refreshed when changes have been made in the editor (Bertrand Bordage)
 * Dropped support for generating static sites using django-medusa
 * Use minified versions of jQuery and jQuery UI in the admin. Total savings without compression 371 KB (Tom Dyson)
 * Hooks can now specify the order in which they are run (Gagaro)
 * Added a `submit_buttons` block to login template (Gagaro)
 * Added `construct_image_chooser_queryset`, `construct_document_chooser_queryset` and `construct_page_chooser_queryset` hooks (Gagaro)
 * The homepage created in the project template is now titled "Home" rather than "Homepage" (Karl Hobley)
 * Signal receivers for custom `Image` and `Rendition` models are connected automatically (Mike Dingjan)
 * `PageChooserBlock` can now accept a list/tuple of page models as `target_model` (Mikalai Radchuk)
 * Styling tweaks for the ModelAdmin's `IndexView` to be more inline with the Wagtail styleguide (Andy Babic)
 * Added `.nvmrc` to the project root for Node versioning support (Janneke Janssen)
 * Added `form_fields_exclude` property to ModelAdmin views (Matheus Bratfisch)
 * User creation / edit form now enforces password validators set in `AUTH_PASSWORD_VALIDATORS` (Bertrand Bordage)
 * Added support for showing `non_field_errors` when validation fails in the page editor (Matt Westcott)
 * Added `WAGTAILADMIN_RECENT_EDITS_LIMIT` setting to define the number of your most recent edits on the dashboard (Maarten Kling)
 * Creating / editing users through the Wagtail admin no longer modifies the `is_staff` flag (Matt Westcott)
 * Added link to the full Elasticsearch setup documentation from the Performance page (Matt Westcott)
 * Tag input fields now accept spaces in tags by default, and can be overridden with the `TAG_SPACES_ALLOWED` setting (Kees Hink, Alex Gleason)
 * Page chooser widgets now display the required page type where relevant (Christine Ho)
 * Site root pages are now indicated with a globe icon in the explorer listing (Nick Smith, Huub Bouma)
 * Draft page view is now restricted to users with edit / publish permission over the page (Kees Hink)
 * Added the option to delete a previously saved focal point on a image (Maarten Kling)
 * Page explorer menu item, search and summary panel are now hidden for users with no page permissions (Tim Heap)
 * Added support for custom date and datetime formats in input fields (Bojan Mihelac)
 * Added support for custom Django REST framework serializer fields in `Page.api_fields` using a new `APIField` class (Karl Hobley)
 * Added `classname` argument to `StreamFieldPanel` (Christine Ho)
 * Added `group` keyword argument to StreamField blocks for grouping related blocks together in the block menu (Andreas Nüßlein)
 * Update the sitemap generator to use the Django sitemap module (Michael van Tellingen, Mike Dingjan)
 * Fix: Marked 'Date from' / 'Date to' strings in wagtailforms for translation (Vorlif)
 * Fix: "File" field label on image edit form is now translated (Stein Strindhaug)
 * Fix: Unreliable preview is now reliable by always opening in a new window (Kjartan Sverrisson)
 * Fix: Fixed placement of `{{ block.super }}` in `snippets/type_index.html` (LB (Ben Johnston))
 * Fix: Optimised database queries on group edit page (Ashia Zawaduk)
 * Fix: Choosing a popular search term for promoted search results now works correctly after pagination (Janneke Janssen)
 * Fix: IDs used in tabbed interfaces are now namespaced to avoid collisions with other page elements (Janneke Janssen)
 * Fix: Page title not displaying page name when moving a page (Trent Holliday)
 * Fix: The ModelAdmin module can now work without the wagtailimages and wagtaildocs apps installed (Andy Babic)
 * Fix: Cloudflare error handling now handles non-string error responses correctly (hdnpl)
 * Fix: Search indexing now uses a defined query ordering to prevent objects from being skipped (Christian Peters)
 * Fix: Ensure that number localization is not applied to object IDs within admin templates (Tom Hendrikx)
 * Fix: Paginating with a search present was always returning the 1st page in Internet Explorer 10 & 11 (Ralph Jacobs)
 * Fix: RoutablePageMixin and wagtailforms previews now set the `request.is_preview` flag (Wietze Helmantel)
 * Fix: The save and preview buttons in the page editor are now mobile-friendly (Maarten Kling)
 * Fix: Page links within rich text now respect custom URLs defined on specific page models (Gary Krige, Huub Bouma)
 * Fix: Default avatar no longer visible when using a transparent gravatar image (Thijs Kramer)
 * Fix: Scrolling within the datetime picker is now usable again for touchpads (Ralph Jacobs)
 * Fix: List-based fields within form builder form submissions are now displayed as comma-separated strings rather than as Python lists (Christine Ho, Matt Westcott)
 * Fix: The page type usage listing now have a translatable page title (Ramon de Jezus)
 * Fix: Styles for submission filtering form now have a consistent height. (Thijs Kramer)
 * Fix: Custom user models with a primary key type requiring `get_db_prep_value` conversion are now supported (thenewguy)
 * Fix: Slicing a search result set no longer loses the annotation added by `annotate_score` (Karl Hobley)
 * Fix: String-based primary keys are now escaped correctly in ModelAdmin URLs (Andreas Nüßlein)
 * Fix: Empty search in the API now works (Morgan Aubert)
 * Fix: `RichTextBlock` toolbar now correctly positioned within `StructBlock` (Janneke Janssen)
 * Fix: Fixed display of ManyToMany fields and False values on the ModelAdmin inspect view (Andy Babic)
 * Fix: Prevent pages from being recursively copied into themselves (Matheus Bratfisch)
 * Fix: Specifying the full file name in documents URL is mandatory (Morgan Aubert)
 * Fix: Reordering inline forms now works correctly when moving past a deleted form (Janneke Janssen)
 * Fix: Removed erroneous ``|safe`` filter from search results template in project template (Karl Hobley)


1.9.1 (21.04.2017)
~~~~~~~~~~~~~~~~~~

 * Fix: Removed erroneous `|safe` filter from search results template in project template (Karl Hobley)
 * Fix: Prevent pages from being recursively copied into themselves (Matheus Bratfisch)


1.9 (16.02.2017)
~~~~~~~~~~~~~~~~

 * Added support for comparing page revisions (Karl Hobley, Janneke Janssen, Matt Westcott)
 * Added support for many-to-many relations on page models (Thejaswi Puthraya, Matt Westcott)
 * Form builder form submissions can now be bulk-deleted (Karl Hobley)
 * `get_context` methods on StreamField blocks can now access variables from the parent context (Mikael Svensson, Peter Baumgartner)
 * Updated admin dashboard welcome message for multi-tenanted installations (Jeffrey Chau)
 * Changed text of "Draft" and "Live" buttons to "View draft" and "View live" (Dan Braghis)
